/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.35.0-dev.20220807(e58c66c819a9739dc3d70e04943db03f213c3735)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/strings","vs/editor/common/core/position","vs/editor/common/core/range","vs/base/common/platform","vs/base/common/event","vs/base/common/lifecycle","vs/base/common/objects","vs/base/common/uri","vs/base/common/errors","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/diff/diff","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/base/common/stopwatch","vs/nls","vs/base/common/arrays","vs/base/common/assert","vs/base/common/cache","vs/base/common/codicons","vs/base/common/diff/diffChange","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/hash","vs/base/common/types","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/diffComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],J=function(I){for(var r=[],N=0,e=I.length;N<e;N++)r[N]=Z[I[N]];return r},Ae=this,Ee=typeof global=="object"?global:{},ie;(function(I){I.global=Ae;var r=function(){function N(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(N.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(N.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(N.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(N.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(N.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),N.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=N._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof I.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="worker")},N._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},N}();I.Environment=r})(ie||(ie={}));var ie;(function(I){var r=function(){function A(l,L,C){this.type=l,this.detail=L,this.timestamp=C}return A}();I.LoaderEvent=r;var N=function(){function A(l){this._events=[new r(1,"",l)]}return A.prototype.record=function(l,L){this._events.push(new r(l,L,I.Utilities.getHighPerformanceTimestamp()))},A.prototype.getEvents=function(){return this._events},A}();I.LoaderEventRecorder=N;var e=function(){function A(){}return A.prototype.record=function(l,L){},A.prototype.getEvents=function(){return[]},A.INSTANCE=new A,A}();I.NullLoaderEventRecorder=e})(ie||(ie={}));var ie;(function(I){var r=function(){function N(){}return N.fileUriToFilePath=function(e,A){if(A=decodeURI(A).replace(/%23/g,"#"),e){if(/^file:\/\/\//.test(A))return A.substr(8);if(/^file:\/\//.test(A))return A.substr(5)}else if(/^file:\/\//.test(A))return A.substr(7);return A},N.startsWith=function(e,A){return e.length>=A.length&&e.substr(0,A.length)===A},N.endsWith=function(e,A){return e.length>=A.length&&e.substr(e.length-A.length)===A},N.containsQueryString=function(e){return/^[^\#]*\?/gi.test(e)},N.isAbsolutePath=function(e){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(e)},N.forEachProperty=function(e,A){if(e){var l=void 0;for(l in e)e.hasOwnProperty(l)&&A(l,e[l])}},N.isEmpty=function(e){var A=!0;return N.forEachProperty(e,function(){A=!1}),A},N.recursiveClone=function(e){if(!e||typeof e!="object"||e instanceof RegExp||!Array.isArray(e)&&Object.getPrototypeOf(e)!==Object.prototype)return e;var A=Array.isArray(e)?[]:{};return N.forEachProperty(e,function(l,L){L&&typeof L=="object"?A[l]=N.recursiveClone(L):A[l]=L}),A},N.generateAnonymousModule=function(){return"===anonymous"+N.NEXT_ANONYMOUS_ID+++"==="},N.isAnonymousModule=function(e){return N.startsWith(e,"===anonymous")},N.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=I.global.performance&&typeof I.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?I.global.performance.now():Date.now()},N.NEXT_ANONYMOUS_ID=1,N.PERFORMANCE_NOW_PROBED=!1,N.HAS_PERFORMANCE_NOW=!1,N}();I.Utilities=r})(ie||(ie={}));var ie;(function(I){function r(A){if(A instanceof Error)return A;var l=new Error(A.message||String(A)||"Unknown Error");return A.stack&&(l.stack=A.stack),l}I.ensureError=r;var N=function(){function A(){}return A.validateConfigurationOptions=function(l){function L(c){if(c.phase==="loading"){console.error('Loading "'+c.moduleId+'" failed'),console.error(c),console.error("Here are the modules that depend on it:"),console.error(c.neededBy);return}if(c.phase==="factory"){console.error('The factory function of "'+c.moduleId+'" has thrown an exception'),console.error(c),console.error("Here are the modules that depend on it:"),console.error(c.neededBy);return}}if(l=l||{},typeof l.baseUrl!="string"&&(l.baseUrl=""),typeof l.isBuild!="boolean"&&(l.isBuild=!1),typeof l.buildForceInvokeFactory!="object"&&(l.buildForceInvokeFactory={}),typeof l.paths!="object"&&(l.paths={}),typeof l.config!="object"&&(l.config={}),typeof l.catchError=="undefined"&&(l.catchError=!1),typeof l.recordStats=="undefined"&&(l.recordStats=!1),typeof l.urlArgs!="string"&&(l.urlArgs=""),typeof l.onError!="function"&&(l.onError=L),Array.isArray(l.ignoreDuplicateModules)||(l.ignoreDuplicateModules=[]),l.baseUrl.length>0&&(I.Utilities.endsWith(l.baseUrl,"/")||(l.baseUrl+="/")),typeof l.cspNonce!="string"&&(l.cspNonce=""),typeof l.preferScriptTags=="undefined"&&(l.preferScriptTags=!1),Array.isArray(l.nodeModules)||(l.nodeModules=[]),l.nodeCachedData&&typeof l.nodeCachedData=="object"&&(typeof l.nodeCachedData.seed!="string"&&(l.nodeCachedData.seed="seed"),(typeof l.nodeCachedData.writeDelay!="number"||l.nodeCachedData.writeDelay<0)&&(l.nodeCachedData.writeDelay=1e3*7),!l.nodeCachedData.path||typeof l.nodeCachedData.path!="string")){var C=r(new Error("INVALID cached data configuration, 'path' MUST be set"));C.phase="configuration",l.onError(C),l.nodeCachedData=void 0}return l},A.mergeConfigurationOptions=function(l,L){l===void 0&&(l=null),L===void 0&&(L=null);var C=I.Utilities.recursiveClone(L||{});return I.Utilities.forEachProperty(l,function(c,d){c==="ignoreDuplicateModules"&&typeof C.ignoreDuplicateModules!="undefined"?C.ignoreDuplicateModules=C.ignoreDuplicateModules.concat(d):c==="paths"&&typeof C.paths!="undefined"?I.Utilities.forEachProperty(d,function(S,t){return C.paths[S]=t}):c==="config"&&typeof C.config!="undefined"?I.Utilities.forEachProperty(d,function(S,t){return C.config[S]=t}):C[c]=I.Utilities.recursiveClone(d)}),A.validateConfigurationOptions(C)},A}();I.ConfigurationOptionsUtil=N;var e=function(){function A(l,L){if(this._env=l,this.options=N.mergeConfigurationOptions(L),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var C=this.options.nodeRequire.main.filename,c=Math.max(C.lastIndexOf("/"),C.lastIndexOf("\\"));this.options.baseUrl=C.substring(0,c+1)}if(this.options.nodeMain&&this._env.isNode){var C=this.options.nodeMain,c=Math.max(C.lastIndexOf("/"),C.lastIndexOf("\\"));this.options.baseUrl=C.substring(0,c+1)}}}return A.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var l=0;l<this.options.ignoreDuplicateModules.length;l++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[l]]=!0},A.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var l=0,L=this.options.nodeModules;l<L.length;l++){var C=L[l];this.nodeModulesMap[C]=!0}},A.prototype._createSortedPathsRules=function(){var l=this;this.sortedPathsRules=[],I.Utilities.forEachProperty(this.options.paths,function(L,C){Array.isArray(C)?l.sortedPathsRules.push({from:L,to:C}):l.sortedPathsRules.push({from:L,to:[C]})}),this.sortedPathsRules.sort(function(L,C){return C.from.length-L.from.length})},A.prototype.cloneAndMerge=function(l){return new A(this._env,N.mergeConfigurationOptions(l,this.options))},A.prototype.getOptionsLiteral=function(){return this.options},A.prototype._applyPaths=function(l){for(var L,C=0,c=this.sortedPathsRules.length;C<c;C++)if(L=this.sortedPathsRules[C],I.Utilities.startsWith(l,L.from)){for(var d=[],S=0,t=L.to.length;S<t;S++)d.push(L.to[S]+l.substr(L.from.length));return d}return[l]},A.prototype._addUrlArgsToUrl=function(l){return I.Utilities.containsQueryString(l)?l+"&"+this.options.urlArgs:l+"?"+this.options.urlArgs},A.prototype._addUrlArgsIfNecessaryToUrl=function(l){return this.options.urlArgs?this._addUrlArgsToUrl(l):l},A.prototype._addUrlArgsIfNecessaryToUrls=function(l){if(this.options.urlArgs)for(var L=0,C=l.length;L<C;L++)l[L]=this._addUrlArgsToUrl(l[L]);return l},A.prototype.moduleIdToPaths=function(l){if(this._env.isNode){var L=this.nodeModulesMap[l]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(l);if(L)return this.isBuild()?["empty:"]:["node|"+l]}var C=l,c;if(!I.Utilities.endsWith(C,".js")&&!I.Utilities.isAbsolutePath(C)){c=this._applyPaths(C);for(var d=0,S=c.length;d<S;d++)this.isBuild()&&c[d]==="empty:"||(I.Utilities.isAbsolutePath(c[d])||(c[d]=this.options.baseUrl+c[d]),!I.Utilities.endsWith(c[d],".js")&&!I.Utilities.containsQueryString(c[d])&&(c[d]=c[d]+".js"))}else!I.Utilities.endsWith(C,".js")&&!I.Utilities.containsQueryString(C)&&(C=C+".js"),c=[C];return this._addUrlArgsIfNecessaryToUrls(c)},A.prototype.requireToUrl=function(l){var L=l;return I.Utilities.isAbsolutePath(L)||(L=this._applyPaths(L)[0],I.Utilities.isAbsolutePath(L)||(L=this.options.baseUrl+L)),this._addUrlArgsIfNecessaryToUrl(L)},A.prototype.isBuild=function(){return this.options.isBuild},A.prototype.shouldInvokeFactory=function(l){return this.options.isBuild?this.options.buildForceInvokeFactory[l]||I.Utilities.isAnonymousModule(l):!0},A.prototype.isDuplicateMessageIgnoredFor=function(l){return this.ignoreDuplicateModulesMap.hasOwnProperty(l)},A.prototype.getConfigForModule=function(l){if(this.options.config)return this.options.config[l]},A.prototype.shouldCatchError=function(){return this.options.catchError},A.prototype.shouldRecordStats=function(){return this.options.recordStats},A.prototype.onError=function(l){this.options.onError(l)},A}();I.Configuration=e})(ie||(ie={}));var ie;(function(I){var r=function(){function c(d){this._env=d,this._scriptLoader=null,this._callbackMap={}}return c.prototype.load=function(d,S,t,w){var u=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new A;else if(this._env.isElectronRenderer){var b=d.getConfig().getOptionsLiteral().preferScriptTags;b?this._scriptLoader=new N:this._scriptLoader=new l(this._env)}else this._env.isNode?this._scriptLoader=new l(this._env):this._scriptLoader=new N;var y={callback:t,errorback:w};if(this._callbackMap.hasOwnProperty(S)){this._callbackMap[S].push(y);return}this._callbackMap[S]=[y],this._scriptLoader.load(d,S,function(){return u.triggerCallback(S)},function(g){return u.triggerErrorback(S,g)})},c.prototype.triggerCallback=function(d){var S=this._callbackMap[d];delete this._callbackMap[d];for(var t=0;t<S.length;t++)S[t].callback()},c.prototype.triggerErrorback=function(d,S){var t=this._callbackMap[d];delete this._callbackMap[d];for(var w=0;w<t.length;w++)t[w].errorback(S)},c}(),N=function(){function c(){}return c.prototype.attachListeners=function(d,S,t){var w=function(){d.removeEventListener("load",u),d.removeEventListener("error",b)},u=function(y){w(),S()},b=function(y){w(),t(y)};d.addEventListener("load",u),d.addEventListener("error",b)},c.prototype.load=function(d,S,t,w){if(/^node\|/.test(S)){var u=d.getConfig().getOptionsLiteral(),b=L(d.getRecorder(),u.nodeRequire||I.global.nodeRequire),y=S.split("|"),g=null;try{g=b(y[1])}catch(a){w(a);return}d.enqueueDefineAnonymousModule([],function(){return g}),t()}else{var v=document.createElement("script");v.setAttribute("async","async"),v.setAttribute("type","text/javascript"),this.attachListeners(v,t,w);var h=d.getConfig().getOptionsLiteral().trustedTypesPolicy;h&&(S=h.createScriptURL(S)),v.setAttribute("src",S);var i=d.getConfig().getOptionsLiteral().cspNonce;i&&v.setAttribute("nonce",i),document.getElementsByTagName("head")[0].appendChild(v)}},c}();function e(c){var d=c.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var S=d?self.eval(d.createScript("","true")):new Function("true");return S.call(self),!0}catch{return!1}}var A=function(){function c(){this._cachedCanUseEval=null}return c.prototype._canUseEval=function(d){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=e(d)),this._cachedCanUseEval},c.prototype.load=function(d,S,t,w){if(/^node\|/.test(S)){var u=d.getConfig().getOptionsLiteral(),b=L(d.getRecorder(),u.nodeRequire||I.global.nodeRequire),y=S.split("|"),g=null;try{g=b(y[1])}catch(i){w(i);return}d.enqueueDefineAnonymousModule([],function(){return g}),t()}else{var v=d.getConfig().getOptionsLiteral().trustedTypesPolicy,h=/^((http:)|(https:)|(file:))/.test(S)&&S.substring(0,self.origin.length)!==self.origin;if(!h&&this._canUseEval(d)){fetch(S).then(function(i){if(i.status!==200)throw new Error(i.statusText);return i.text()}).then(function(i){i=i+`
//# sourceURL=`+S;var a=v?self.eval(v.createScript("",i)):new Function(i);a.call(self),t()}).then(void 0,w);return}try{v&&(S=v.createScriptURL(S)),importScripts(S),t()}catch(i){w(i)}}},c}(),l=function(){function c(d){this._env=d,this._didInitialize=!1,this._didPatchNodeRequire=!1}return c.prototype._init=function(d){this._didInitialize||(this._didInitialize=!0,this._fs=d("fs"),this._vm=d("vm"),this._path=d("path"),this._crypto=d("crypto"))},c.prototype._initNodeRequire=function(d,S){var t=S.getConfig().getOptionsLiteral().nodeCachedData;if(!t||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var w=this,u=d("module");function b(y){var g=y.constructor,v=function(i){try{return y.require(i)}finally{}};return v.resolve=function(i,a){return g._resolveFilename(i,y,!1,a)},v.resolve.paths=function(i){return g._resolveLookupPaths(i,y)},v.main=process.mainModule,v.extensions=g._extensions,v.cache=g._cache,v}u.prototype._compile=function(y,g){var v=u.wrap(y.replace(/^#!.*/,"")),h=S.getRecorder(),i=w._getCachedDataPath(t,g),a={filename:g},m;try{var p=w._fs.readFileSync(i);m=p.slice(0,16),a.cachedData=p.slice(16),h.record(60,i)}catch{h.record(61,i)}var o=new w._vm.Script(v,a),s=o.runInThisContext(a),f=w._path.dirname(g),_=b(this),E=[this.exports,_,this,g,f,process,Ee,Buffer],M=s.apply(this.exports,E);return w._handleCachedData(o,v,i,!a.cachedData,S),w._verifyCachedData(o,v,i,m,S),M}},c.prototype.load=function(d,S,t,w){var u=this,b=d.getConfig().getOptionsLiteral(),y=L(d.getRecorder(),b.nodeRequire||I.global.nodeRequire),g=b.nodeInstrumenter||function(s){return s};this._init(y),this._initNodeRequire(y,d);var v=d.getRecorder();if(/^node\|/.test(S)){var h=S.split("|"),i=null;try{i=y(h[1])}catch(s){w(s);return}d.enqueueDefineAnonymousModule([],function(){return i}),t()}else{S=I.Utilities.fileUriToFilePath(this._env.isWindows,S);var a=this._path.normalize(S),m=this._getElectronRendererScriptPathOrUri(a),p=Boolean(b.nodeCachedData),o=p?this._getCachedDataPath(b.nodeCachedData,S):void 0;this._readSourceAndCachedData(a,o,v,function(s,f,_,E){if(s){w(s);return}var M;f.charCodeAt(0)===c._BOM?M=c._PREFIX+f.substring(1)+c._SUFFIX:M=c._PREFIX+f+c._SUFFIX,M=g(M,a);var D={filename:m,cachedData:_},P=u._createAndEvalScript(d,M,D,t,w);u._handleCachedData(P,M,o,p&&!_,d),u._verifyCachedData(P,M,o,E,d)})}},c.prototype._createAndEvalScript=function(d,S,t,w,u){var b=d.getRecorder();b.record(31,t.filename);var y=new this._vm.Script(S,t),g=y.runInThisContext(t),v=d.getGlobalAMDDefineFunc(),h=!1,i=function(){return h=!0,v.apply(null,arguments)};return i.amd=v.amd,g.call(I.global,d.getGlobalAMDRequireFunc(),i,t.filename,this._path.dirname(t.filename)),b.record(32,t.filename),h?w():u(new Error("Didn't receive define call in "+t.filename+"!")),y},c.prototype._getElectronRendererScriptPathOrUri=function(d){if(!this._env.isElectronRenderer)return d;var S=d.match(/^([a-z])\:(.*)/i);return S?"file:///"+(S[1].toUpperCase()+":"+S[2]).replace(/\\/g,"/"):"file://"+d},c.prototype._getCachedDataPath=function(d,S){var t=this._crypto.createHash("md5").update(S,"utf8").update(d.seed,"utf8").update(process.arch,"").digest("hex"),w=this._path.basename(S).replace(/\.js$/,"");return this._path.join(d.path,w+"-"+t+".code")},c.prototype._handleCachedData=function(d,S,t,w,u){var b=this;d.cachedDataRejected?this._fs.unlink(t,function(y){u.getRecorder().record(62,t),b._createAndWriteCachedData(d,S,t,u),y&&u.getConfig().onError(y)}):w&&this._createAndWriteCachedData(d,S,t,u)},c.prototype._createAndWriteCachedData=function(d,S,t,w){var u=this,b=Math.ceil(w.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),y=-1,g=0,v=void 0,h=function(){setTimeout(function(){v||(v=u._crypto.createHash("md5").update(S,"utf8").digest());var i=d.createCachedData();if(!(i.length===0||i.length===y||g>=5)){if(i.length<y){h();return}y=i.length,u._fs.writeFile(t,Buffer.concat([v,i]),function(a){a&&w.getConfig().onError(a),w.getRecorder().record(63,t),h()})}},b*Math.pow(4,g++))};h()},c.prototype._readSourceAndCachedData=function(d,S,t,w){if(!S)this._fs.readFile(d,{encoding:"utf8"},w);else{var u=void 0,b=void 0,y=void 0,g=2,v=function(h){h?w(h):--g==0&&w(void 0,u,b,y)};this._fs.readFile(d,{encoding:"utf8"},function(h,i){u=i,v(h)}),this._fs.readFile(S,function(h,i){!h&&i&&i.length>0?(y=i.slice(0,16),b=i.slice(16),t.record(60,S)):t.record(61,S),v()})}},c.prototype._verifyCachedData=function(d,S,t,w,u){var b=this;!w||d.cachedDataRejected||setTimeout(function(){var y=b._crypto.createHash("md5").update(S,"utf8").digest();w.equals(y)||(u.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+t+"' now, but a RESTART IS REQUIRED")),b._fs.unlink(t,function(g){g&&u.getConfig().onError(g)}))},Math.ceil(5e3*(1+Math.random())))},c._BOM=65279,c._PREFIX="(function (require, define, __filename, __dirname) { ",c._SUFFIX=`
});`,c}();function L(c,d){if(d.__$__isRecorded)return d;var S=function(w){c.record(33,w);try{return d(w)}finally{c.record(34,w)}};return S.__$__isRecorded=!0,S}I.ensureRecordedNodeRequire=L;function C(c){return new r(c)}I.createScriptLoader=C})(ie||(ie={}));var ie;(function(I){var r=function(){function C(c){var d=c.lastIndexOf("/");d!==-1?this.fromModulePath=c.substr(0,d+1):this.fromModulePath=""}return C._normalizeModuleId=function(c){var d=c,S;for(S=/\/\.\//;S.test(d);)d=d.replace(S,"/");for(d=d.replace(/^\.\//g,""),S=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;S.test(d);)d=d.replace(S,"/");return d=d.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),d},C.prototype.resolveModule=function(c){var d=c;return I.Utilities.isAbsolutePath(d)||(I.Utilities.startsWith(d,"./")||I.Utilities.startsWith(d,"../"))&&(d=C._normalizeModuleId(this.fromModulePath+d)),d},C.ROOT=new C(""),C}();I.ModuleIdResolver=r;var N=function(){function C(c,d,S,t,w,u){this.id=c,this.strId=d,this.dependencies=S,this._callback=t,this._errorback=w,this.moduleIdResolver=u,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return C._safeInvokeFunction=function(c,d){try{return{returnedValue:c.apply(I.global,d),producedError:null}}catch(S){return{returnedValue:null,producedError:S}}},C._invokeFactory=function(c,d,S,t){return c.shouldInvokeFactory(d)?c.shouldCatchError()?this._safeInvokeFunction(S,t):{returnedValue:S.apply(I.global,t),producedError:null}:{returnedValue:null,producedError:null}},C.prototype.complete=function(c,d,S,t){this._isComplete=!0;var w=null;if(this._callback)if(typeof this._callback=="function"){c.record(21,this.strId);var u=C._invokeFactory(d,this.strId,this._callback,S);w=u.producedError,c.record(22,this.strId),!w&&typeof u.returnedValue!="undefined"&&(!this.exportsPassedIn||I.Utilities.isEmpty(this.exports))&&(this.exports=u.returnedValue)}else this.exports=this._callback;if(w){var b=I.ensureError(w);b.phase="factory",b.moduleId=this.strId,b.neededBy=t(this.id),this.error=b,d.onError(b)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},C.prototype.onDependencyError=function(c){return this._isComplete=!0,this.error=c,this._errorback?(this._errorback(c),!0):!1},C.prototype.isComplete=function(){return this._isComplete},C}();I.Module=N;var e=function(){function C(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return C.prototype.getMaxModuleId=function(){return this._nextId},C.prototype.getModuleId=function(c){var d=this._strModuleIdToIntModuleId.get(c);return typeof d=="undefined"&&(d=this._nextId++,this._strModuleIdToIntModuleId.set(c,d),this._intModuleIdToStrModuleId[d]=c),d},C.prototype.getStrModuleId=function(c){return this._intModuleIdToStrModuleId[c]},C}(),A=function(){function C(c){this.id=c}return C.EXPORTS=new C(0),C.MODULE=new C(1),C.REQUIRE=new C(2),C}();I.RegularDependency=A;var l=function(){function C(c,d,S){this.id=c,this.pluginId=d,this.pluginParam=S}return C}();I.PluginDependency=l;var L=function(){function C(c,d,S,t,w){w===void 0&&(w=0),this._env=c,this._scriptLoader=d,this._loaderAvailableTimestamp=w,this._defineFunc=S,this._requireFunc=t,this._moduleIdProvider=new e,this._config=new I.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return C.prototype.reset=function(){return new C(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},C.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},C.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},C._findRelevantLocationInStack=function(c,d){for(var S=function(a){return a.replace(/\\/g,"/")},t=S(c),w=d.split(/\n/),u=0;u<w.length;u++){var b=w[u].match(/(.*):(\d+):(\d+)\)?$/);if(b){var y=b[1],g=b[2],v=b[3],h=Math.max(y.lastIndexOf(" ")+1,y.lastIndexOf("(")+1);if(y=y.substr(h),y=S(y),y===t){var i={line:parseInt(g,10),col:parseInt(v,10)};return i.line===1&&(i.col-="(function (require, define, __filename, __dirname) { ".length),i}}}throw new Error("Could not correlate define call site for needle "+c)},C.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var c=[],d=0,S=0,t=this._modules2.length;S<t;S++){var w=this._modules2[S];if(!!w){var u=this._buildInfoPath[w.id]||null,b=this._buildInfoDefineStack[w.id]||null,y=this._buildInfoDependencies[w.id];c[d++]={id:w.strId,path:u,defineLocation:u&&b?C._findRelevantLocationInStack(u,b):null,dependencies:y,shim:null,exports:w.exports}}}return c},C.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new I.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=I.NullLoaderEventRecorder.INSTANCE),this._recorder},C.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},C.prototype.enqueueDefineAnonymousModule=function(c,d){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var S=null;this._config.isBuild()&&(S=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:S,dependencies:c,callback:d}},C.prototype.defineModule=function(c,d,S,t,w,u){var b=this;u===void 0&&(u=new r(c));var y=this._moduleIdProvider.getModuleId(c);if(this._modules2[y]){this._config.isDuplicateMessageIgnoredFor(c)||console.warn("Duplicate definition of module '"+c+"'");return}var g=new N(y,c,this._normalizeDependencies(d,u),S,t,u);this._modules2[y]=g,this._config.isBuild()&&(this._buildInfoDefineStack[y]=w,this._buildInfoDependencies[y]=(g.dependencies||[]).map(function(v){return b._moduleIdProvider.getStrModuleId(v.id)})),this._resolve(g)},C.prototype._normalizeDependency=function(c,d){if(c==="exports")return A.EXPORTS;if(c==="module")return A.MODULE;if(c==="require")return A.REQUIRE;var S=c.indexOf("!");if(S>=0){var t=d.resolveModule(c.substr(0,S)),w=d.resolveModule(c.substr(S+1)),u=this._moduleIdProvider.getModuleId(t+"!"+w),b=this._moduleIdProvider.getModuleId(t);return new l(u,b,w)}return new A(this._moduleIdProvider.getModuleId(d.resolveModule(c)))},C.prototype._normalizeDependencies=function(c,d){for(var S=[],t=0,w=0,u=c.length;w<u;w++)S[t++]=this._normalizeDependency(c[w],d);return S},C.prototype._relativeRequire=function(c,d,S,t){if(typeof d=="string")return this.synchronousRequire(d,c);this.defineModule(I.Utilities.generateAnonymousModule(),d,S,t,null,c)},C.prototype.synchronousRequire=function(c,d){d===void 0&&(d=new r(c));var S=this._normalizeDependency(c,d),t=this._modules2[S.id];if(!t)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+c+"'. This is the first mention of this module!");if(!t.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+c+"'. This module has not been resolved completely yet.");if(t.error)throw t.error;return t.exports},C.prototype.configure=function(c,d){var S=this._config.shouldRecordStats();d?this._config=new I.Configuration(this._env,c):this._config=this._config.cloneAndMerge(c),this._config.shouldRecordStats()&&!S&&(this._recorder=null)},C.prototype.getConfig=function(){return this._config},C.prototype._onLoad=function(c){if(this._currentAnonymousDefineCall!==null){var d=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(c),d.dependencies,d.callback,null,d.stack)}},C.prototype._createLoadError=function(c,d){var S=this,t=this._moduleIdProvider.getStrModuleId(c),w=(this._inverseDependencies2[c]||[]).map(function(b){return S._moduleIdProvider.getStrModuleId(b)}),u=I.ensureError(d);return u.phase="loading",u.moduleId=t,u.neededBy=w,u},C.prototype._onLoadError=function(c,d){var S=this._createLoadError(c,d);this._modules2[c]||(this._modules2[c]=new N(c,this._moduleIdProvider.getStrModuleId(c),[],function(){},null,null));for(var t=[],w=0,u=this._moduleIdProvider.getMaxModuleId();w<u;w++)t[w]=!1;var b=!1,y=[];for(y.push(c),t[c]=!0;y.length>0;){var g=y.shift(),v=this._modules2[g];v&&(b=v.onDependencyError(S)||b);var h=this._inverseDependencies2[g];if(h)for(var w=0,u=h.length;w<u;w++){var i=h[w];t[i]||(y.push(i),t[i]=!0)}}b||this._config.onError(S)},C.prototype._hasDependencyPath=function(c,d){var S=this._modules2[c];if(!S)return!1;for(var t=[],w=0,u=this._moduleIdProvider.getMaxModuleId();w<u;w++)t[w]=!1;var b=[];for(b.push(S),t[c]=!0;b.length>0;){var y=b.shift(),g=y.dependencies;if(g)for(var w=0,u=g.length;w<u;w++){var v=g[w];if(v.id===d)return!0;var h=this._modules2[v.id];h&&!t[v.id]&&(t[v.id]=!0,b.push(h))}}return!1},C.prototype._findCyclePath=function(c,d,S){if(c===d||S===50)return[c];var t=this._modules2[c];if(!t)return null;var w=t.dependencies;if(w)for(var u=0,b=w.length;u<b;u++){var y=this._findCyclePath(w[u].id,d,S+1);if(y!==null)return y.push(c),y}return null},C.prototype._createRequire=function(c){var d=this,S=function(t,w,u){return d._relativeRequire(c,t,w,u)};return S.toUrl=function(t){return d._config.requireToUrl(c.resolveModule(t))},S.getStats=function(){return d.getLoaderEvents()},S.hasDependencyCycle=function(){return d._hasDependencyCycle},S.config=function(t,w){w===void 0&&(w=!1),d.configure(t,w)},S.__$__nodeRequire=I.global.nodeRequire,S},C.prototype._loadModule=function(c){var d=this;if(!(this._modules2[c]||this._knownModules2[c])){this._knownModules2[c]=!0;var S=this._moduleIdProvider.getStrModuleId(c),t=this._config.moduleIdToPaths(S),w=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(S.indexOf("/")===-1||w.test(S))&&t.push("node|"+S);var u=-1,b=function(y){if(u++,u>=t.length)d._onLoadError(c,y);else{var g=t[u],v=d.getRecorder();if(d._config.isBuild()&&g==="empty:"){d._buildInfoPath[c]=g,d.defineModule(d._moduleIdProvider.getStrModuleId(c),[],null,null,null),d._onLoad(c);return}v.record(10,g),d._scriptLoader.load(d,g,function(){d._config.isBuild()&&(d._buildInfoPath[c]=g),v.record(11,g),d._onLoad(c)},function(h){v.record(12,g),b(h)})}};b(null)}},C.prototype._loadPluginDependency=function(c,d){var S=this;if(!(this._modules2[d.id]||this._knownModules2[d.id])){this._knownModules2[d.id]=!0;var t=function(w){S.defineModule(S._moduleIdProvider.getStrModuleId(d.id),[],w,null,null)};t.error=function(w){S._config.onError(S._createLoadError(d.id,w))},c.load(d.pluginParam,this._createRequire(r.ROOT),t,this._config.getOptionsLiteral())}},C.prototype._resolve=function(c){var d=this,S=c.dependencies;if(S)for(var t=0,w=S.length;t<w;t++){var u=S[t];if(u===A.EXPORTS){c.exportsPassedIn=!0,c.unresolvedDependenciesCount--;continue}if(u===A.MODULE){c.unresolvedDependenciesCount--;continue}if(u===A.REQUIRE){c.unresolvedDependenciesCount--;continue}var b=this._modules2[u.id];if(b&&b.isComplete()){if(b.error){c.onDependencyError(b.error);return}c.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(u.id,c.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(u.id)+"' and '"+this._moduleIdProvider.getStrModuleId(c.id)+"'. The cyclic path follows:");var y=this._findCyclePath(u.id,c.id,0)||[];y.reverse(),y.push(u.id),console.warn(y.map(function(h){return d._moduleIdProvider.getStrModuleId(h)}).join(` => 
`)),c.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[u.id]=this._inverseDependencies2[u.id]||[],this._inverseDependencies2[u.id].push(c.id),u instanceof l){var g=this._modules2[u.pluginId];if(g&&g.isComplete()){this._loadPluginDependency(g.exports,u);continue}var v=this._inversePluginDependencies2.get(u.pluginId);v||(v=[],this._inversePluginDependencies2.set(u.pluginId,v)),v.push(u),this._loadModule(u.pluginId);continue}this._loadModule(u.id)}c.unresolvedDependenciesCount===0&&this._onModuleComplete(c)},C.prototype._onModuleComplete=function(c){var d=this,S=this.getRecorder();if(!c.isComplete()){var t=c.dependencies,w=[];if(t)for(var u=0,b=t.length;u<b;u++){var y=t[u];if(y===A.EXPORTS){w[u]=c.exports;continue}if(y===A.MODULE){w[u]={id:c.strId,config:function(){return d._config.getConfigForModule(c.strId)}};continue}if(y===A.REQUIRE){w[u]=this._createRequire(c.moduleIdResolver);continue}var g=this._modules2[y.id];if(g){w[u]=g.exports;continue}w[u]=null}var v=function(p){return(d._inverseDependencies2[p]||[]).map(function(o){return d._moduleIdProvider.getStrModuleId(o)})};c.complete(S,this._config,w,v);var h=this._inverseDependencies2[c.id];if(this._inverseDependencies2[c.id]=null,h)for(var u=0,b=h.length;u<b;u++){var i=h[u],a=this._modules2[i];a.unresolvedDependenciesCount--,a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}var m=this._inversePluginDependencies2.get(c.id);if(m){this._inversePluginDependencies2.delete(c.id);for(var u=0,b=m.length;u<b;u++)this._loadPluginDependency(c.exports,m[u])}}},C}();I.ModuleManager=L})(ie||(ie={}));var X,ie;(function(I){var r=new I.Environment,N=null,e=function(C,c,d){typeof C!="string"&&(d=c,c=C,C=null),(typeof c!="object"||!Array.isArray(c))&&(d=c,c=null),c||(c=["require","exports","module"]),C?N.defineModule(C,c,d,null,null):N.enqueueDefineAnonymousModule(c,d)};e.amd={jQuery:!0};var A=function(C,c){c===void 0&&(c=!1),N.configure(C,c)},l=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){A(arguments[0]);return}if(typeof arguments[0]=="string")return N.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){N.defineModule(I.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};l.config=A,l.getConfig=function(){return N.getConfig().getOptionsLiteral()},l.reset=function(){N=N.reset()},l.getBuildInfo=function(){return N.getBuildInfo()},l.getStats=function(){return N.getLoaderEvents()},l.define=e;function L(){if(typeof I.global.require!="undefined"||typeof require!="undefined"){var C=I.global.require||require;if(typeof C=="function"&&typeof C.resolve=="function"){var c=I.ensureRecordedNodeRequire(N.getRecorder(),C);I.global.nodeRequire=c,l.nodeRequire=c,l.__$__nodeRequire=c}}r.isNode&&!r.isElectronRenderer&&!r.isElectronNodeIntegrationWebWorker?(module.exports=l,require=l):(r.isElectronRenderer||(I.global.define=e),I.global.require=l)}I.init=L,(typeof I.global.define!="function"||!I.global.define.amd)&&(N=new I.ModuleManager(r,I.createScriptLoader(r),e,l,I.Utilities.getHighPerformanceTimestamp()),typeof I.global.require!="undefined"&&typeof I.global.require!="function"&&l.config(I.global.require),X=function(){return e.apply(null,arguments)},X.amd=e.amd,typeof doNotInitLoader=="undefined"&&L())})(ie||(ie={}));var le=this&&this.__awaiter||function(I,r,N,e){function A(l){return l instanceof N?l:new N(function(L){L(l)})}return new(N||(N=Promise))(function(l,L){function C(S){try{d(e.next(S))}catch(t){L(t)}}function c(S){try{d(e.throw(S))}catch(t){L(t)}}function d(S){S.done?l(S.value):A(S.value).then(C,c)}d((e=e.apply(I,r||[])).next())})};X(Z[18],J([0,1]),function(I,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.load=r.create=r.setPseudoTranslation=r.getConfiguredDefaultLocale=r.localize=void 0;let N=typeof document!="undefined"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const e="i-default";function A(b,y){let g;return y.length===0?g=b:g=b.replace(/\{(\d+)\}/g,(v,h)=>{const i=h[0],a=y[i];let m=v;return typeof a=="string"?m=a:(typeof a=="number"||typeof a=="boolean"||a===void 0||a===null)&&(m=String(a)),m}),N&&(g="\uFF3B"+g.replace(/[aouei]/g,"$&$&")+"\uFF3D"),g}function l(b,y){let g=b[y];return g||(g=b["*"],g)?g:null}function L(b){return b.charAt(b.length-1)==="/"?b:b+"/"}function C(b,y,g){return le(this,void 0,void 0,function*(){const v=L(b)+L(y)+"vscode/"+L(g),h=yield fetch(v);if(h.ok)return yield h.json();throw new Error(`${h.status} - ${h.statusText}`)})}function c(b){return function(y,g){const v=Array.prototype.slice.call(arguments,2);return A(b[y],v)}}function d(b,y,...g){return A(y,g)}r.localize=d;function S(b){}r.getConfiguredDefaultLocale=S;function t(b){N=b}r.setPseudoTranslation=t;function w(b,y){var g;return{localize:c(y[b]),getConfiguredDefaultLocale:(g=y.getConfiguredDefaultLocale)!==null&&g!==void 0?g:v=>{}}}r.create=w;function u(b,y,g,v){var h;const i=(h=v["vs/nls"])!==null&&h!==void 0?h:{};if(!b||b.length===0)return g({localize:d,getConfiguredDefaultLocale:()=>{var s;return(s=i.availableLanguages)===null||s===void 0?void 0:s["*"]}});const a=i.availableLanguages?l(i.availableLanguages,b):null,m=a===null||a===e;let p=".nls";m||(p=p+"."+a);const o=s=>{Array.isArray(s)?s.localize=c(s):s.localize=c(s[b]),s.getConfiguredDefaultLocale=()=>{var f;return(f=i.availableLanguages)===null||f===void 0?void 0:f["*"]},g(s)};typeof i.loadBundle=="function"?i.loadBundle(b,a,(s,f)=>{s?y([b+".nls"],o):o(f)}):i.translationServiceUrl&&!m?(()=>le(this,void 0,void 0,function*(){var s;try{const f=yield C(i.translationServiceUrl,a,b);return o(f)}catch(f){if(!a.includes("-"))return console.error(f),y([b+".nls"],o);try{const _=a.split("-")[0],E=yield C(i.translationServiceUrl,_,b);return(s=i.availableLanguages)!==null&&s!==void 0||(i.availableLanguages={}),i.availableLanguages["*"]=_,o(E)}catch(_){return console.error(_),y([b+".nls"],o)}}}))():y([b+p],o,s=>{if(p===".nls"){console.error("Failed trying to load default language strings",s);return}console.error(`Failed to load message bundle for language ${a}. Falling back to the default language:`,s),y([b+".nls"],o)})}r.load=u}),function(){var I,r;const N=self.MonacoEnvironment,e=N&&N.baseUrl?N.baseUrl:"../../../",A=typeof((I=self.trustedTypes)===null||I===void 0?void 0:I.createPolicy)=="function"?(r=self.trustedTypes)===null||r===void 0?void 0:r.createPolicy("amdLoader",{createScriptURL:t=>t,createScript:(t,...w)=>{const u=w.slice(0,-1).join(","),b=w.pop().toString();return`(function anonymous(${u}) {
${b}
})`}}):void 0;function l(){try{return(A?self.eval(A.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}function L(){return new Promise((t,w)=>{if(typeof self.define=="function"&&self.define.amd)return t();const u=e+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(u)&&u.substring(0,self.origin.length)!==self.origin)&&l()){fetch(u).then(y=>{if(y.status!==200)throw new Error(y.statusText);return y.text()}).then(y=>{y=`${y}
//# sourceURL=${u}`,(A?self.eval(A.createScript("",y)):new Function(y)).call(self),t()}).then(void 0,w);return}A?importScripts(A.createScriptURL(u)):importScripts(u),t()})}function C(){require.config({baseUrl:e,catchError:!0,trustedTypesPolicy:A,amdModulesPattern:/^vs\//})}function c(t){L().then(()=>{C(),require([t],function(w){setTimeout(function(){const u=w.create((b,y)=>{self.postMessage(b,y)},null);for(self.onmessage=b=>u.onmessage(b.data,b.ports);S.length>0;)self.onmessage(S.shift())},0)})})}typeof self.define=="function"&&self.define.amd&&C();let d=!0;const S=[];self.onmessage=t=>{if(!d){S.push(t);return}d=!1,c(t.data)}}(),X(Z[19],J([0,1]),function(I,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.CallbackIterable=r.ArrayQueue=r.findMinBy=r.findLastMaxBy=r.findMaxBy=r.numberComparator=r.compareBy=r.CompareResult=r.splice=r.insertInto=r.asArray=r.pushMany=r.pushToEnd=r.pushToStart=r.arrayInsert=r.range=r.firstOrDefault=r.lastIndex=r.findLast=r.distinct=r.isNonEmptyArray=r.isFalsyOrEmpty=r.coalesce=r.groupBy=r.quickSelect=r.findFirstInSorted=r.binarySearch2=r.binarySearch=r.removeFastWithoutKeepingOrder=r.equals=r.tail2=r.tail=void 0;function N(k,U=0){return k[k.length-(1+U)]}r.tail=N;function e(k){if(k.length===0)throw new Error("Invalid tail call");return[k.slice(0,k.length-1),k[k.length-1]]}r.tail2=e;function A(k,U,T=(O,z)=>O===z){if(k===U)return!0;if(!k||!U||k.length!==U.length)return!1;for(let O=0,z=k.length;O<z;O++)if(!T(k[O],U[O]))return!1;return!0}r.equals=A;function l(k,U){const T=k.length-1;U<T&&(k[U]=k[T]),k.pop()}r.removeFastWithoutKeepingOrder=l;function L(k,U,T){return C(k.length,O=>T(k[O],U))}r.binarySearch=L;function C(k,U){let T=0,O=k-1;for(;T<=O;){const z=(T+O)/2|0,n=U(z);if(n<0)T=z+1;else if(n>0)O=z-1;else return z}return-(T+1)}r.binarySearch2=C;function c(k,U){let T=0,O=k.length;if(O===0)return 0;for(;T<O;){const z=Math.floor((T+O)/2);U(k[z])?O=z:T=z+1}return T}r.findFirstInSorted=c;function d(k,U,T){if(k=k|0,k>=U.length)throw new TypeError("invalid index");const O=U[Math.floor(U.length*Math.random())],z=[],n=[],se=[];for(const me of U){const _e=T(me,O);_e<0?z.push(me):_e>0?n.push(me):se.push(me)}return k<z.length?d(k,z,T):k<z.length+se.length?se[0]:d(k-(z.length+se.length),n,T)}r.quickSelect=d;function S(k,U){const T=[];let O;for(const z of k.slice(0).sort(U))!O||U(O[0],z)!==0?(O=[z],T.push(O)):O.push(z);return T}r.groupBy=S;function t(k){return k.filter(U=>!!U)}r.coalesce=t;function w(k){return!Array.isArray(k)||k.length===0}r.isFalsyOrEmpty=w;function u(k){return Array.isArray(k)&&k.length>0}r.isNonEmptyArray=u;function b(k,U=T=>T){const T=new Set;return k.filter(O=>{const z=U(O);return T.has(z)?!1:(T.add(z),!0)})}r.distinct=b;function y(k,U){const T=g(k,U);if(T!==-1)return k[T]}r.findLast=y;function g(k,U){for(let T=k.length-1;T>=0;T--){const O=k[T];if(U(O))return T}return-1}r.lastIndex=g;function v(k,U){return k.length>0?k[0]:U}r.firstOrDefault=v;function h(k,U){let T=typeof U=="number"?k:0;typeof U=="number"?T=k:(T=0,U=k);const O=[];if(T<=U)for(let z=T;z<U;z++)O.push(z);else for(let z=T;z>U;z--)O.push(z);return O}r.range=h;function i(k,U,T){const O=k.slice(0,U),z=k.slice(U);return O.concat(T,z)}r.arrayInsert=i;function a(k,U){const T=k.indexOf(U);T>-1&&(k.splice(T,1),k.unshift(U))}r.pushToStart=a;function m(k,U){const T=k.indexOf(U);T>-1&&(k.splice(T,1),k.push(U))}r.pushToEnd=m;function p(k,U){for(const T of U)k.push(T)}r.pushMany=p;function o(k){return Array.isArray(k)?k:[k]}r.asArray=o;function s(k,U,T){const O=_(k,U),z=k.length,n=T.length;k.length=z+n;for(let se=z-1;se>=O;se--)k[se+n]=k[se];for(let se=0;se<n;se++)k[se+O]=T[se]}r.insertInto=s;function f(k,U,T,O){const z=_(k,U),n=k.splice(z,T);return s(k,z,O),n}r.splice=f;function _(k,U){return U<0?Math.max(U+k.length,0):Math.min(U,k.length)}var E;(function(k){function U(z){return z<0}k.isLessThan=U;function T(z){return z>0}k.isGreaterThan=T;function O(z){return z===0}k.isNeitherLessOrGreaterThan=O,k.greaterThan=1,k.lessThan=-1,k.neitherLessOrGreaterThan=0})(E=r.CompareResult||(r.CompareResult={}));function M(k,U){return(T,O)=>U(k(T),k(O))}r.compareBy=M;const D=(k,U)=>k-U;r.numberComparator=D;function P(k,U){if(k.length===0)return;let T=k[0];for(let O=1;O<k.length;O++){const z=k[O];U(z,T)>0&&(T=z)}return T}r.findMaxBy=P;function B(k,U){if(k.length===0)return;let T=k[0];for(let O=1;O<k.length;O++){const z=k[O];U(z,T)>=0&&(T=z)}return T}r.findLastMaxBy=B;function W(k,U){return P(k,(T,O)=>-U(T,O))}r.findMinBy=W;class ${constructor(U){this.items=U,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(U){let T=this.firstIdx;for(;T<this.items.length&&U(this.items[T]);)T++;const O=T===this.firstIdx?null:this.items.slice(this.firstIdx,T);return this.firstIdx=T,O}takeFromEndWhile(U){let T=this.lastIdx;for(;T>=0&&U(this.items[T]);)T--;const O=T===this.lastIdx?null:this.items.slice(T+1,this.lastIdx+1);return this.lastIdx=T,O}peek(){if(this.length!==0)return this.items[this.firstIdx]}dequeue(){const U=this.items[this.firstIdx];return this.firstIdx++,U}takeCount(U){const T=this.items.slice(this.firstIdx,this.firstIdx+U);return this.firstIdx+=U,T}}r.ArrayQueue=$;class q{constructor(U){this.iterate=U}toArray(){const U=[];return this.iterate(T=>(U.push(T),!0)),U}filter(U){return new q(T=>this.iterate(O=>U(O)?T(O):!0))}map(U){return new q(T=>this.iterate(O=>T(U(O))))}findLast(U){let T;return this.iterate(O=>(U(O)&&(T=O),!0)),T}findLastMaxBy(U){let T,O=!0;return this.iterate(z=>((O||E.isGreaterThan(U(z,T)))&&(O=!1,T=z),!0)),T}}r.CallbackIterable=q,q.empty=new q(k=>{})}),X(Z[20],J([0,1]),function(I,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.assertNever=r.ok=void 0;function N(A,l){if(!A)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}r.ok=N;function e(A,l="Unreachable"){throw new Error(l)}r.assertNever=e}),X(Z[21],J([0,1]),function(I,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.CachedFunction=r.LRUCachedFunction=void 0;class N{constructor(l){this.fn=l,this.lastCache=void 0,this.lastArgKey=void 0}get(l){const L=JSON.stringify(l);return this.lastArgKey!==L&&(this.lastArgKey=L,this.lastCache=this.fn(l)),this.lastCache}}r.LRUCachedFunction=N;class e{constructor(l){this.fn=l,this._map=new Map}get cachedValues(){return this._map}get(l){if(this._map.has(l))return this._map.get(l);const L=this.fn(l);return this._map.set(l,L),L}}r.CachedFunction=e}),X(Z[22],J([0,1]),function(I,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.CSSIcon=r.Codicon=r.getCodiconAriaLabel=void 0;function N(l){return l?l.replace(/\$\((.*?)\)/g,(L,C)=>` ${C} `).trim():""}r.getCodiconAriaLabel=N;class e{constructor(L,C,c){this.id=L,this.definition=C,this.description=c,e._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return e._allCodicons}}r.Codicon=e,e._allCodicons=[],e.add=new e("add",{fontCharacter:"\\ea60"}),e.plus=new e("plus",e.add.definition),e.gistNew=new e("gist-new",e.add.definition),e.repoCreate=new e("repo-create",e.add.definition),e.lightbulb=new e("lightbulb",{fontCharacter:"\\ea61"}),e.lightBulb=new e("light-bulb",{fontCharacter:"\\ea61"}),e.repo=new e("repo",{fontCharacter:"\\ea62"}),e.repoDelete=new e("repo-delete",{fontCharacter:"\\ea62"}),e.gistFork=new e("gist-fork",{fontCharacter:"\\ea63"}),e.repoForked=new e("repo-forked",{fontCharacter:"\\ea63"}),e.gitPullRequest=new e("git-pull-request",{fontCharacter:"\\ea64"}),e.gitPullRequestAbandoned=new e("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),e.recordKeys=new e("record-keys",{fontCharacter:"\\ea65"}),e.keyboard=new e("keyboard",{fontCharacter:"\\ea65"}),e.tag=new e("tag",{fontCharacter:"\\ea66"}),e.tagAdd=new e("tag-add",{fontCharacter:"\\ea66"}),e.tagRemove=new e("tag-remove",{fontCharacter:"\\ea66"}),e.person=new e("person",{fontCharacter:"\\ea67"}),e.personFollow=new e("person-follow",{fontCharacter:"\\ea67"}),e.personOutline=new e("person-outline",{fontCharacter:"\\ea67"}),e.personFilled=new e("person-filled",{fontCharacter:"\\ea67"}),e.gitBranch=new e("git-branch",{fontCharacter:"\\ea68"}),e.gitBranchCreate=new e("git-branch-create",{fontCharacter:"\\ea68"}),e.gitBranchDelete=new e("git-branch-delete",{fontCharacter:"\\ea68"}),e.sourceControl=new e("source-control",{fontCharacter:"\\ea68"}),e.mirror=new e("mirror",{fontCharacter:"\\ea69"}),e.mirrorPublic=new e("mirror-public",{fontCharacter:"\\ea69"}),e.star=new e("star",{fontCharacter:"\\ea6a"}),e.starAdd=new e("star-add",{fontCharacter:"\\ea6a"}),e.starDelete=new e("star-delete",{fontCharacter:"\\ea6a"}),e.starEmpty=new e("star-empty",{fontCharacter:"\\ea6a"}),e.comment=new e("comment",{fontCharacter:"\\ea6b"}),e.commentAdd=new e("comment-add",{fontCharacter:"\\ea6b"}),e.alert=new e("alert",{fontCharacter:"\\ea6c"}),e.warning=new e("warning",{fontCharacter:"\\ea6c"}),e.search=new e("search",{fontCharacter:"\\ea6d"}),e.searchSave=new e("search-save",{fontCharacter:"\\ea6d"}),e.logOut=new e("log-out",{fontCharacter:"\\ea6e"}),e.signOut=new e("sign-out",{fontCharacter:"\\ea6e"}),e.logIn=new e("log-in",{fontCharacter:"\\ea6f"}),e.signIn=new e("sign-in",{fontCharacter:"\\ea6f"}),e.eye=new e("eye",{fontCharacter:"\\ea70"}),e.eyeUnwatch=new e("eye-unwatch",{fontCharacter:"\\ea70"}),e.eyeWatch=new e("eye-watch",{fontCharacter:"\\ea70"}),e.circleFilled=new e("circle-filled",{fontCharacter:"\\ea71"}),e.primitiveDot=new e("primitive-dot",e.circleFilled.definition),e.closeDirty=new e("close-dirty",e.circleFilled.definition),e.terminalDecorationSuccess=new e("terminal-decoration-success",e.circleFilled.definition),e.debugBreakpoint=new e("debug-breakpoint",e.circleFilled.definition),e.debugBreakpointDisabled=new e("debug-breakpoint-disabled",e.circleFilled.definition),e.debugHint=new e("debug-hint",e.circleFilled.definition),e.primitiveSquare=new e("primitive-square",{fontCharacter:"\\ea72"}),e.edit=new e("edit",{fontCharacter:"\\ea73"}),e.pencil=new e("pencil",{fontCharacter:"\\ea73"}),e.info=new e("info",{fontCharacter:"\\ea74"}),e.issueOpened=new e("issue-opened",{fontCharacter:"\\ea74"}),e.gistPrivate=new e("gist-private",{fontCharacter:"\\ea75"}),e.gitForkPrivate=new e("git-fork-private",{fontCharacter:"\\ea75"}),e.lock=new e("lock",{fontCharacter:"\\ea75"}),e.mirrorPrivate=new e("mirror-private",{fontCharacter:"\\ea75"}),e.close=new e("close",{fontCharacter:"\\ea76"}),e.removeClose=new e("remove-close",{fontCharacter:"\\ea76"}),e.x=new e("x",{fontCharacter:"\\ea76"}),e.repoSync=new e("repo-sync",{fontCharacter:"\\ea77"}),e.sync=new e("sync",{fontCharacter:"\\ea77"}),e.clone=new e("clone",{fontCharacter:"\\ea78"}),e.desktopDownload=new e("desktop-download",{fontCharacter:"\\ea78"}),e.beaker=new e("beaker",{fontCharacter:"\\ea79"}),e.microscope=new e("microscope",{fontCharacter:"\\ea79"}),e.vm=new e("vm",{fontCharacter:"\\ea7a"}),e.deviceDesktop=new e("device-desktop",{fontCharacter:"\\ea7a"}),e.file=new e("file",{fontCharacter:"\\ea7b"}),e.fileText=new e("file-text",{fontCharacter:"\\ea7b"}),e.more=new e("more",{fontCharacter:"\\ea7c"}),e.ellipsis=new e("ellipsis",{fontCharacter:"\\ea7c"}),e.kebabHorizontal=new e("kebab-horizontal",{fontCharacter:"\\ea7c"}),e.mailReply=new e("mail-reply",{fontCharacter:"\\ea7d"}),e.reply=new e("reply",{fontCharacter:"\\ea7d"}),e.organization=new e("organization",{fontCharacter:"\\ea7e"}),e.organizationFilled=new e("organization-filled",{fontCharacter:"\\ea7e"}),e.organizationOutline=new e("organization-outline",{fontCharacter:"\\ea7e"}),e.newFile=new e("new-file",{fontCharacter:"\\ea7f"}),e.fileAdd=new e("file-add",{fontCharacter:"\\ea7f"}),e.newFolder=new e("new-folder",{fontCharacter:"\\ea80"}),e.fileDirectoryCreate=new e("file-directory-create",{fontCharacter:"\\ea80"}),e.trash=new e("trash",{fontCharacter:"\\ea81"}),e.trashcan=new e("trashcan",{fontCharacter:"\\ea81"}),e.history=new e("history",{fontCharacter:"\\ea82"}),e.clock=new e("clock",{fontCharacter:"\\ea82"}),e.folder=new e("folder",{fontCharacter:"\\ea83"}),e.fileDirectory=new e("file-directory",{fontCharacter:"\\ea83"}),e.symbolFolder=new e("symbol-folder",{fontCharacter:"\\ea83"}),e.logoGithub=new e("logo-github",{fontCharacter:"\\ea84"}),e.markGithub=new e("mark-github",{fontCharacter:"\\ea84"}),e.github=new e("github",{fontCharacter:"\\ea84"}),e.terminal=new e("terminal",{fontCharacter:"\\ea85"}),e.console=new e("console",{fontCharacter:"\\ea85"}),e.repl=new e("repl",{fontCharacter:"\\ea85"}),e.zap=new e("zap",{fontCharacter:"\\ea86"}),e.symbolEvent=new e("symbol-event",{fontCharacter:"\\ea86"}),e.error=new e("error",{fontCharacter:"\\ea87"}),e.stop=new e("stop",{fontCharacter:"\\ea87"}),e.variable=new e("variable",{fontCharacter:"\\ea88"}),e.symbolVariable=new e("symbol-variable",{fontCharacter:"\\ea88"}),e.array=new e("array",{fontCharacter:"\\ea8a"}),e.symbolArray=new e("symbol-array",{fontCharacter:"\\ea8a"}),e.symbolModule=new e("symbol-module",{fontCharacter:"\\ea8b"}),e.symbolPackage=new e("symbol-package",{fontCharacter:"\\ea8b"}),e.symbolNamespace=new e("symbol-namespace",{fontCharacter:"\\ea8b"}),e.symbolObject=new e("symbol-object",{fontCharacter:"\\ea8b"}),e.symbolMethod=new e("symbol-method",{fontCharacter:"\\ea8c"}),e.symbolFunction=new e("symbol-function",{fontCharacter:"\\ea8c"}),e.symbolConstructor=new e("symbol-constructor",{fontCharacter:"\\ea8c"}),e.symbolBoolean=new e("symbol-boolean",{fontCharacter:"\\ea8f"}),e.symbolNull=new e("symbol-null",{fontCharacter:"\\ea8f"}),e.symbolNumeric=new e("symbol-numeric",{fontCharacter:"\\ea90"}),e.symbolNumber=new e("symbol-number",{fontCharacter:"\\ea90"}),e.symbolStructure=new e("symbol-structure",{fontCharacter:"\\ea91"}),e.symbolStruct=new e("symbol-struct",{fontCharacter:"\\ea91"}),e.symbolParameter=new e("symbol-parameter",{fontCharacter:"\\ea92"}),e.symbolTypeParameter=new e("symbol-type-parameter",{fontCharacter:"\\ea92"}),e.symbolKey=new e("symbol-key",{fontCharacter:"\\ea93"}),e.symbolText=new e("symbol-text",{fontCharacter:"\\ea93"}),e.symbolReference=new e("symbol-reference",{fontCharacter:"\\ea94"}),e.goToFile=new e("go-to-file",{fontCharacter:"\\ea94"}),e.symbolEnum=new e("symbol-enum",{fontCharacter:"\\ea95"}),e.symbolValue=new e("symbol-value",{fontCharacter:"\\ea95"}),e.symbolRuler=new e("symbol-ruler",{fontCharacter:"\\ea96"}),e.symbolUnit=new e("symbol-unit",{fontCharacter:"\\ea96"}),e.activateBreakpoints=new e("activate-breakpoints",{fontCharacter:"\\ea97"}),e.archive=new e("archive",{fontCharacter:"\\ea98"}),e.arrowBoth=new e("arrow-both",{fontCharacter:"\\ea99"}),e.arrowDown=new e("arrow-down",{fontCharacter:"\\ea9a"}),e.arrowLeft=new e("arrow-left",{fontCharacter:"\\ea9b"}),e.arrowRight=new e("arrow-right",{fontCharacter:"\\ea9c"}),e.arrowSmallDown=new e("arrow-small-down",{fontCharacter:"\\ea9d"}),e.arrowSmallLeft=new e("arrow-small-left",{fontCharacter:"\\ea9e"}),e.arrowSmallRight=new e("arrow-small-right",{fontCharacter:"\\ea9f"}),e.arrowSmallUp=new e("arrow-small-up",{fontCharacter:"\\eaa0"}),e.arrowUp=new e("arrow-up",{fontCharacter:"\\eaa1"}),e.bell=new e("bell",{fontCharacter:"\\eaa2"}),e.bold=new e("bold",{fontCharacter:"\\eaa3"}),e.book=new e("book",{fontCharacter:"\\eaa4"}),e.bookmark=new e("bookmark",{fontCharacter:"\\eaa5"}),e.debugBreakpointConditionalUnverified=new e("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),e.debugBreakpointConditional=new e("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),e.debugBreakpointConditionalDisabled=new e("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),e.debugBreakpointDataUnverified=new e("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),e.debugBreakpointData=new e("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),e.debugBreakpointDataDisabled=new e("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),e.debugBreakpointLogUnverified=new e("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),e.debugBreakpointLog=new e("debug-breakpoint-log",{fontCharacter:"\\eaab"}),e.debugBreakpointLogDisabled=new e("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),e.briefcase=new e("briefcase",{fontCharacter:"\\eaac"}),e.broadcast=new e("broadcast",{fontCharacter:"\\eaad"}),e.browser=new e("browser",{fontCharacter:"\\eaae"}),e.bug=new e("bug",{fontCharacter:"\\eaaf"}),e.calendar=new e("calendar",{fontCharacter:"\\eab0"}),e.caseSensitive=new e("case-sensitive",{fontCharacter:"\\eab1"}),e.check=new e("check",{fontCharacter:"\\eab2"}),e.checklist=new e("checklist",{fontCharacter:"\\eab3"}),e.chevronDown=new e("chevron-down",{fontCharacter:"\\eab4"}),e.dropDownButton=new e("drop-down-button",e.chevronDown.definition),e.chevronLeft=new e("chevron-left",{fontCharacter:"\\eab5"}),e.chevronRight=new e("chevron-right",{fontCharacter:"\\eab6"}),e.chevronUp=new e("chevron-up",{fontCharacter:"\\eab7"}),e.chromeClose=new e("chrome-close",{fontCharacter:"\\eab8"}),e.chromeMaximize=new e("chrome-maximize",{fontCharacter:"\\eab9"}),e.chromeMinimize=new e("chrome-minimize",{fontCharacter:"\\eaba"}),e.chromeRestore=new e("chrome-restore",{fontCharacter:"\\eabb"}),e.circle=new e("circle",{fontCharacter:"\\eabc"}),e.circleOutline=new e("circle-outline",e.circle.definition),e.terminalDecorationIncomplete=new e("terminal-decoration-incomplete",e.circle.definition),e.debugBreakpointUnverified=new e("debug-breakpoint-unverified",e.circle.definition),e.circleSlash=new e("circle-slash",{fontCharacter:"\\eabd"}),e.circuitBoard=new e("circuit-board",{fontCharacter:"\\eabe"}),e.clearAll=new e("clear-all",{fontCharacter:"\\eabf"}),e.clippy=new e("clippy",{fontCharacter:"\\eac0"}),e.closeAll=new e("close-all",{fontCharacter:"\\eac1"}),e.cloudDownload=new e("cloud-download",{fontCharacter:"\\eac2"}),e.cloudUpload=new e("cloud-upload",{fontCharacter:"\\eac3"}),e.code=new e("code",{fontCharacter:"\\eac4"}),e.collapseAll=new e("collapse-all",{fontCharacter:"\\eac5"}),e.colorMode=new e("color-mode",{fontCharacter:"\\eac6"}),e.commentDiscussion=new e("comment-discussion",{fontCharacter:"\\eac7"}),e.compareChanges=new e("compare-changes",{fontCharacter:"\\eafd"}),e.creditCard=new e("credit-card",{fontCharacter:"\\eac9"}),e.dash=new e("dash",{fontCharacter:"\\eacc"}),e.dashboard=new e("dashboard",{fontCharacter:"\\eacd"}),e.database=new e("database",{fontCharacter:"\\eace"}),e.debugContinue=new e("debug-continue",{fontCharacter:"\\eacf"}),e.debugDisconnect=new e("debug-disconnect",{fontCharacter:"\\ead0"}),e.debugPause=new e("debug-pause",{fontCharacter:"\\ead1"}),e.debugRestart=new e("debug-restart",{fontCharacter:"\\ead2"}),e.debugStart=new e("debug-start",{fontCharacter:"\\ead3"}),e.debugStepInto=new e("debug-step-into",{fontCharacter:"\\ead4"}),e.debugStepOut=new e("debug-step-out",{fontCharacter:"\\ead5"}),e.debugStepOver=new e("debug-step-over",{fontCharacter:"\\ead6"}),e.debugStop=new e("debug-stop",{fontCharacter:"\\ead7"}),e.debug=new e("debug",{fontCharacter:"\\ead8"}),e.deviceCameraVideo=new e("device-camera-video",{fontCharacter:"\\ead9"}),e.deviceCamera=new e("device-camera",{fontCharacter:"\\eada"}),e.deviceMobile=new e("device-mobile",{fontCharacter:"\\eadb"}),e.diffAdded=new e("diff-added",{fontCharacter:"\\eadc"}),e.diffIgnored=new e("diff-ignored",{fontCharacter:"\\eadd"}),e.diffModified=new e("diff-modified",{fontCharacter:"\\eade"}),e.diffRemoved=new e("diff-removed",{fontCharacter:"\\eadf"}),e.diffRenamed=new e("diff-renamed",{fontCharacter:"\\eae0"}),e.diff=new e("diff",{fontCharacter:"\\eae1"}),e.discard=new e("discard",{fontCharacter:"\\eae2"}),e.editorLayout=new e("editor-layout",{fontCharacter:"\\eae3"}),e.emptyWindow=new e("empty-window",{fontCharacter:"\\eae4"}),e.exclude=new e("exclude",{fontCharacter:"\\eae5"}),e.extensions=new e("extensions",{fontCharacter:"\\eae6"}),e.eyeClosed=new e("eye-closed",{fontCharacter:"\\eae7"}),e.fileBinary=new e("file-binary",{fontCharacter:"\\eae8"}),e.fileCode=new e("file-code",{fontCharacter:"\\eae9"}),e.fileMedia=new e("file-media",{fontCharacter:"\\eaea"}),e.filePdf=new e("file-pdf",{fontCharacter:"\\eaeb"}),e.fileSubmodule=new e("file-submodule",{fontCharacter:"\\eaec"}),e.fileSymlinkDirectory=new e("file-symlink-directory",{fontCharacter:"\\eaed"}),e.fileSymlinkFile=new e("file-symlink-file",{fontCharacter:"\\eaee"}),e.fileZip=new e("file-zip",{fontCharacter:"\\eaef"}),e.files=new e("files",{fontCharacter:"\\eaf0"}),e.filter=new e("filter",{fontCharacter:"\\eaf1"}),e.flame=new e("flame",{fontCharacter:"\\eaf2"}),e.foldDown=new e("fold-down",{fontCharacter:"\\eaf3"}),e.foldUp=new e("fold-up",{fontCharacter:"\\eaf4"}),e.fold=new e("fold",{fontCharacter:"\\eaf5"}),e.folderActive=new e("folder-active",{fontCharacter:"\\eaf6"}),e.folderOpened=new e("folder-opened",{fontCharacter:"\\eaf7"}),e.gear=new e("gear",{fontCharacter:"\\eaf8"}),e.gift=new e("gift",{fontCharacter:"\\eaf9"}),e.gistSecret=new e("gist-secret",{fontCharacter:"\\eafa"}),e.gist=new e("gist",{fontCharacter:"\\eafb"}),e.gitCommit=new e("git-commit",{fontCharacter:"\\eafc"}),e.gitCompare=new e("git-compare",{fontCharacter:"\\eafd"}),e.gitMerge=new e("git-merge",{fontCharacter:"\\eafe"}),e.githubAction=new e("github-action",{fontCharacter:"\\eaff"}),e.githubAlt=new e("github-alt",{fontCharacter:"\\eb00"}),e.globe=new e("globe",{fontCharacter:"\\eb01"}),e.grabber=new e("grabber",{fontCharacter:"\\eb02"}),e.graph=new e("graph",{fontCharacter:"\\eb03"}),e.gripper=new e("gripper",{fontCharacter:"\\eb04"}),e.heart=new e("heart",{fontCharacter:"\\eb05"}),e.home=new e("home",{fontCharacter:"\\eb06"}),e.horizontalRule=new e("horizontal-rule",{fontCharacter:"\\eb07"}),e.hubot=new e("hubot",{fontCharacter:"\\eb08"}),e.inbox=new e("inbox",{fontCharacter:"\\eb09"}),e.issueClosed=new e("issue-closed",{fontCharacter:"\\eba4"}),e.issueReopened=new e("issue-reopened",{fontCharacter:"\\eb0b"}),e.issues=new e("issues",{fontCharacter:"\\eb0c"}),e.italic=new e("italic",{fontCharacter:"\\eb0d"}),e.jersey=new e("jersey",{fontCharacter:"\\eb0e"}),e.json=new e("json",{fontCharacter:"\\eb0f"}),e.kebabVertical=new e("kebab-vertical",{fontCharacter:"\\eb10"}),e.key=new e("key",{fontCharacter:"\\eb11"}),e.law=new e("law",{fontCharacter:"\\eb12"}),e.lightbulbAutofix=new e("lightbulb-autofix",{fontCharacter:"\\eb13"}),e.linkExternal=new e("link-external",{fontCharacter:"\\eb14"}),e.link=new e("link",{fontCharacter:"\\eb15"}),e.listOrdered=new e("list-ordered",{fontCharacter:"\\eb16"}),e.listUnordered=new e("list-unordered",{fontCharacter:"\\eb17"}),e.liveShare=new e("live-share",{fontCharacter:"\\eb18"}),e.loading=new e("loading",{fontCharacter:"\\eb19"}),e.location=new e("location",{fontCharacter:"\\eb1a"}),e.mailRead=new e("mail-read",{fontCharacter:"\\eb1b"}),e.mail=new e("mail",{fontCharacter:"\\eb1c"}),e.markdown=new e("markdown",{fontCharacter:"\\eb1d"}),e.megaphone=new e("megaphone",{fontCharacter:"\\eb1e"}),e.mention=new e("mention",{fontCharacter:"\\eb1f"}),e.milestone=new e("milestone",{fontCharacter:"\\eb20"}),e.mortarBoard=new e("mortar-board",{fontCharacter:"\\eb21"}),e.move=new e("move",{fontCharacter:"\\eb22"}),e.multipleWindows=new e("multiple-windows",{fontCharacter:"\\eb23"}),e.mute=new e("mute",{fontCharacter:"\\eb24"}),e.noNewline=new e("no-newline",{fontCharacter:"\\eb25"}),e.note=new e("note",{fontCharacter:"\\eb26"}),e.octoface=new e("octoface",{fontCharacter:"\\eb27"}),e.openPreview=new e("open-preview",{fontCharacter:"\\eb28"}),e.package_=new e("package",{fontCharacter:"\\eb29"}),e.paintcan=new e("paintcan",{fontCharacter:"\\eb2a"}),e.pin=new e("pin",{fontCharacter:"\\eb2b"}),e.play=new e("play",{fontCharacter:"\\eb2c"}),e.run=new e("run",{fontCharacter:"\\eb2c"}),e.plug=new e("plug",{fontCharacter:"\\eb2d"}),e.preserveCase=new e("preserve-case",{fontCharacter:"\\eb2e"}),e.preview=new e("preview",{fontCharacter:"\\eb2f"}),e.project=new e("project",{fontCharacter:"\\eb30"}),e.pulse=new e("pulse",{fontCharacter:"\\eb31"}),e.question=new e("question",{fontCharacter:"\\eb32"}),e.quote=new e("quote",{fontCharacter:"\\eb33"}),e.radioTower=new e("radio-tower",{fontCharacter:"\\eb34"}),e.reactions=new e("reactions",{fontCharacter:"\\eb35"}),e.references=new e("references",{fontCharacter:"\\eb36"}),e.refresh=new e("refresh",{fontCharacter:"\\eb37"}),e.regex=new e("regex",{fontCharacter:"\\eb38"}),e.remoteExplorer=new e("remote-explorer",{fontCharacter:"\\eb39"}),e.remote=new e("remote",{fontCharacter:"\\eb3a"}),e.remove=new e("remove",{fontCharacter:"\\eb3b"}),e.replaceAll=new e("replace-all",{fontCharacter:"\\eb3c"}),e.replace=new e("replace",{fontCharacter:"\\eb3d"}),e.repoClone=new e("repo-clone",{fontCharacter:"\\eb3e"}),e.repoForcePush=new e("repo-force-push",{fontCharacter:"\\eb3f"}),e.repoPull=new e("repo-pull",{fontCharacter:"\\eb40"}),e.repoPush=new e("repo-push",{fontCharacter:"\\eb41"}),e.report=new e("report",{fontCharacter:"\\eb42"}),e.requestChanges=new e("request-changes",{fontCharacter:"\\eb43"}),e.rocket=new e("rocket",{fontCharacter:"\\eb44"}),e.rootFolderOpened=new e("root-folder-opened",{fontCharacter:"\\eb45"}),e.rootFolder=new e("root-folder",{fontCharacter:"\\eb46"}),e.rss=new e("rss",{fontCharacter:"\\eb47"}),e.ruby=new e("ruby",{fontCharacter:"\\eb48"}),e.saveAll=new e("save-all",{fontCharacter:"\\eb49"}),e.saveAs=new e("save-as",{fontCharacter:"\\eb4a"}),e.save=new e("save",{fontCharacter:"\\eb4b"}),e.screenFull=new e("screen-full",{fontCharacter:"\\eb4c"}),e.screenNormal=new e("screen-normal",{fontCharacter:"\\eb4d"}),e.searchStop=new e("search-stop",{fontCharacter:"\\eb4e"}),e.server=new e("server",{fontCharacter:"\\eb50"}),e.settingsGear=new e("settings-gear",{fontCharacter:"\\eb51"}),e.settings=new e("settings",{fontCharacter:"\\eb52"}),e.shield=new e("shield",{fontCharacter:"\\eb53"}),e.smiley=new e("smiley",{fontCharacter:"\\eb54"}),e.sortPrecedence=new e("sort-precedence",{fontCharacter:"\\eb55"}),e.splitHorizontal=new e("split-horizontal",{fontCharacter:"\\eb56"}),e.splitVertical=new e("split-vertical",{fontCharacter:"\\eb57"}),e.squirrel=new e("squirrel",{fontCharacter:"\\eb58"}),e.starFull=new e("star-full",{fontCharacter:"\\eb59"}),e.starHalf=new e("star-half",{fontCharacter:"\\eb5a"}),e.symbolClass=new e("symbol-class",{fontCharacter:"\\eb5b"}),e.symbolColor=new e("symbol-color",{fontCharacter:"\\eb5c"}),e.symbolCustomColor=new e("symbol-customcolor",{fontCharacter:"\\eb5c"}),e.symbolConstant=new e("symbol-constant",{fontCharacter:"\\eb5d"}),e.symbolEnumMember=new e("symbol-enum-member",{fontCharacter:"\\eb5e"}),e.symbolField=new e("symbol-field",{fontCharacter:"\\eb5f"}),e.symbolFile=new e("symbol-file",{fontCharacter:"\\eb60"}),e.symbolInterface=new e("symbol-interface",{fontCharacter:"\\eb61"}),e.symbolKeyword=new e("symbol-keyword",{fontCharacter:"\\eb62"}),e.symbolMisc=new e("symbol-misc",{fontCharacter:"\\eb63"}),e.symbolOperator=new e("symbol-operator",{fontCharacter:"\\eb64"}),e.symbolProperty=new e("symbol-property",{fontCharacter:"\\eb65"}),e.wrench=new e("wrench",{fontCharacter:"\\eb65"}),e.wrenchSubaction=new e("wrench-subaction",{fontCharacter:"\\eb65"}),e.symbolSnippet=new e("symbol-snippet",{fontCharacter:"\\eb66"}),e.tasklist=new e("tasklist",{fontCharacter:"\\eb67"}),e.telescope=new e("telescope",{fontCharacter:"\\eb68"}),e.textSize=new e("text-size",{fontCharacter:"\\eb69"}),e.threeBars=new e("three-bars",{fontCharacter:"\\eb6a"}),e.thumbsdown=new e("thumbsdown",{fontCharacter:"\\eb6b"}),e.thumbsup=new e("thumbsup",{fontCharacter:"\\eb6c"}),e.tools=new e("tools",{fontCharacter:"\\eb6d"}),e.triangleDown=new e("triangle-down",{fontCharacter:"\\eb6e"}),e.triangleLeft=new e("triangle-left",{fontCharacter:"\\eb6f"}),e.triangleRight=new e("triangle-right",{fontCharacter:"\\eb70"}),e.triangleUp=new e("triangle-up",{fontCharacter:"\\eb71"}),e.twitter=new e("twitter",{fontCharacter:"\\eb72"}),e.unfold=new e("unfold",{fontCharacter:"\\eb73"}),e.unlock=new e("unlock",{fontCharacter:"\\eb74"}),e.unmute=new e("unmute",{fontCharacter:"\\eb75"}),e.unverified=new e("unverified",{fontCharacter:"\\eb76"}),e.verified=new e("verified",{fontCharacter:"\\eb77"}),e.versions=new e("versions",{fontCharacter:"\\eb78"}),e.vmActive=new e("vm-active",{fontCharacter:"\\eb79"}),e.vmOutline=new e("vm-outline",{fontCharacter:"\\eb7a"}),e.vmRunning=new e("vm-running",{fontCharacter:"\\eb7b"}),e.watch=new e("watch",{fontCharacter:"\\eb7c"}),e.whitespace=new e("whitespace",{fontCharacter:"\\eb7d"}),e.wholeWord=new e("whole-word",{fontCharacter:"\\eb7e"}),e.window=new e("window",{fontCharacter:"\\eb7f"}),e.wordWrap=new e("word-wrap",{fontCharacter:"\\eb80"}),e.zoomIn=new e("zoom-in",{fontCharacter:"\\eb81"}),e.zoomOut=new e("zoom-out",{fontCharacter:"\\eb82"}),e.listFilter=new e("list-filter",{fontCharacter:"\\eb83"}),e.listFlat=new e("list-flat",{fontCharacter:"\\eb84"}),e.listSelection=new e("list-selection",{fontCharacter:"\\eb85"}),e.selection=new e("selection",{fontCharacter:"\\eb85"}),e.listTree=new e("list-tree",{fontCharacter:"\\eb86"}),e.debugBreakpointFunctionUnverified=new e("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),e.debugBreakpointFunction=new e("debug-breakpoint-function",{fontCharacter:"\\eb88"}),e.debugBreakpointFunctionDisabled=new e("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),e.debugStackframeActive=new e("debug-stackframe-active",{fontCharacter:"\\eb89"}),e.circleSmallFilled=new e("circle-small-filled",{fontCharacter:"\\eb8a"}),e.debugStackframeDot=new e("debug-stackframe-dot",e.circleSmallFilled.definition),e.terminalDecorationMark=new e("terminal-decoration-mark",e.circleSmallFilled.definition),e.debugStackframe=new e("debug-stackframe",{fontCharacter:"\\eb8b"}),e.debugStackframeFocused=new e("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),e.debugBreakpointUnsupported=new e("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),e.symbolString=new e("symbol-string",{fontCharacter:"\\eb8d"}),e.debugReverseContinue=new e("debug-reverse-continue",{fontCharacter:"\\eb8e"}),e.debugStepBack=new e("debug-step-back",{fontCharacter:"\\eb8f"}),e.debugRestartFrame=new e("debug-restart-frame",{fontCharacter:"\\eb90"}),e.callIncoming=new e("call-incoming",{fontCharacter:"\\eb92"}),e.callOutgoing=new e("call-outgoing",{fontCharacter:"\\eb93"}),e.menu=new e("menu",{fontCharacter:"\\eb94"}),e.expandAll=new e("expand-all",{fontCharacter:"\\eb95"}),e.feedback=new e("feedback",{fontCharacter:"\\eb96"}),e.groupByRefType=new e("group-by-ref-type",{fontCharacter:"\\eb97"}),e.ungroupByRefType=new e("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),e.account=new e("account",{fontCharacter:"\\eb99"}),e.bellDot=new e("bell-dot",{fontCharacter:"\\eb9a"}),e.debugConsole=new e("debug-console",{fontCharacter:"\\eb9b"}),e.library=new e("library",{fontCharacter:"\\eb9c"}),e.output=new e("output",{fontCharacter:"\\eb9d"}),e.runAll=new e("run-all",{fontCharacter:"\\eb9e"}),e.syncIgnored=new e("sync-ignored",{fontCharacter:"\\eb9f"}),e.pinned=new e("pinned",{fontCharacter:"\\eba0"}),e.githubInverted=new e("github-inverted",{fontCharacter:"\\eba1"}),e.debugAlt=new e("debug-alt",{fontCharacter:"\\eb91"}),e.serverProcess=new e("server-process",{fontCharacter:"\\eba2"}),e.serverEnvironment=new e("server-environment",{fontCharacter:"\\eba3"}),e.pass=new e("pass",{fontCharacter:"\\eba4"}),e.stopCircle=new e("stop-circle",{fontCharacter:"\\eba5"}),e.playCircle=new e("play-circle",{fontCharacter:"\\eba6"}),e.record=new e("record",{fontCharacter:"\\eba7"}),e.debugAltSmall=new e("debug-alt-small",{fontCharacter:"\\eba8"}),e.vmConnect=new e("vm-connect",{fontCharacter:"\\eba9"}),e.cloud=new e("cloud",{fontCharacter:"\\ebaa"}),e.merge=new e("merge",{fontCharacter:"\\ebab"}),e.exportIcon=new e("export",{fontCharacter:"\\ebac"}),e.graphLeft=new e("graph-left",{fontCharacter:"\\ebad"}),e.magnet=new e("magnet",{fontCharacter:"\\ebae"}),e.notebook=new e("notebook",{fontCharacter:"\\ebaf"}),e.redo=new e("redo",{fontCharacter:"\\ebb0"}),e.checkAll=new e("check-all",{fontCharacter:"\\ebb1"}),e.pinnedDirty=new e("pinned-dirty",{fontCharacter:"\\ebb2"}),e.passFilled=new e("pass-filled",{fontCharacter:"\\ebb3"}),e.circleLargeFilled=new e("circle-large-filled",{fontCharacter:"\\ebb4"}),e.circleLarge=new e("circle-large",{fontCharacter:"\\ebb5"}),e.circleLargeOutline=new e("circle-large-outline",e.circleLarge.definition),e.combine=new e("combine",{fontCharacter:"\\ebb6"}),e.gather=new e("gather",{fontCharacter:"\\ebb6"}),e.table=new e("table",{fontCharacter:"\\ebb7"}),e.variableGroup=new e("variable-group",{fontCharacter:"\\ebb8"}),e.typeHierarchy=new e("type-hierarchy",{fontCharacter:"\\ebb9"}),e.typeHierarchySub=new e("type-hierarchy-sub",{fontCharacter:"\\ebba"}),e.typeHierarchySuper=new e("type-hierarchy-super",{fontCharacter:"\\ebbb"}),e.gitPullRequestCreate=new e("git-pull-request-create",{fontCharacter:"\\ebbc"}),e.runAbove=new e("run-above",{fontCharacter:"\\ebbd"}),e.runBelow=new e("run-below",{fontCharacter:"\\ebbe"}),e.notebookTemplate=new e("notebook-template",{fontCharacter:"\\ebbf"}),e.debugRerun=new e("debug-rerun",{fontCharacter:"\\ebc0"}),e.workspaceTrusted=new e("workspace-trusted",{fontCharacter:"\\ebc1"}),e.workspaceUntrusted=new e("workspace-untrusted",{fontCharacter:"\\ebc2"}),e.workspaceUnspecified=new e("workspace-unspecified",{fontCharacter:"\\ebc3"}),e.terminalCmd=new e("terminal-cmd",{fontCharacter:"\\ebc4"}),e.terminalDebian=new e("terminal-debian",{fontCharacter:"\\ebc5"}),e.terminalLinux=new e("terminal-linux",{fontCharacter:"\\ebc6"}),e.terminalPowershell=new e("terminal-powershell",{fontCharacter:"\\ebc7"}),e.terminalTmux=new e("terminal-tmux",{fontCharacter:"\\ebc8"}),e.terminalUbuntu=new e("terminal-ubuntu",{fontCharacter:"\\ebc9"}),e.terminalBash=new e("terminal-bash",{fontCharacter:"\\ebca"}),e.arrowSwap=new e("arrow-swap",{fontCharacter:"\\ebcb"}),e.copy=new e("copy",{fontCharacter:"\\ebcc"}),e.personAdd=new e("person-add",{fontCharacter:"\\ebcd"}),e.filterFilled=new e("filter-filled",{fontCharacter:"\\ebce"}),e.wand=new e("wand",{fontCharacter:"\\ebcf"}),e.debugLineByLine=new e("debug-line-by-line",{fontCharacter:"\\ebd0"}),e.inspect=new e("inspect",{fontCharacter:"\\ebd1"}),e.layers=new e("layers",{fontCharacter:"\\ebd2"}),e.layersDot=new e("layers-dot",{fontCharacter:"\\ebd3"}),e.layersActive=new e("layers-active",{fontCharacter:"\\ebd4"}),e.compass=new e("compass",{fontCharacter:"\\ebd5"}),e.compassDot=new e("compass-dot",{fontCharacter:"\\ebd6"}),e.compassActive=new e("compass-active",{fontCharacter:"\\ebd7"}),e.azure=new e("azure",{fontCharacter:"\\ebd8"}),e.issueDraft=new e("issue-draft",{fontCharacter:"\\ebd9"}),e.gitPullRequestClosed=new e("git-pull-request-closed",{fontCharacter:"\\ebda"}),e.gitPullRequestDraft=new e("git-pull-request-draft",{fontCharacter:"\\ebdb"}),e.debugAll=new e("debug-all",{fontCharacter:"\\ebdc"}),e.debugCoverage=new e("debug-coverage",{fontCharacter:"\\ebdd"}),e.runErrors=new e("run-errors",{fontCharacter:"\\ebde"}),e.folderLibrary=new e("folder-library",{fontCharacter:"\\ebdf"}),e.debugContinueSmall=new e("debug-continue-small",{fontCharacter:"\\ebe0"}),e.beakerStop=new e("beaker-stop",{fontCharacter:"\\ebe1"}),e.graphLine=new e("graph-line",{fontCharacter:"\\ebe2"}),e.graphScatter=new e("graph-scatter",{fontCharacter:"\\ebe3"}),e.pieChart=new e("pie-chart",{fontCharacter:"\\ebe4"}),e.bracket=new e("bracket",e.json.definition),e.bracketDot=new e("bracket-dot",{fontCharacter:"\\ebe5"}),e.bracketError=new e("bracket-error",{fontCharacter:"\\ebe6"}),e.lockSmall=new e("lock-small",{fontCharacter:"\\ebe7"}),e.azureDevops=new e("azure-devops",{fontCharacter:"\\ebe8"}),e.verifiedFilled=new e("verified-filled",{fontCharacter:"\\ebe9"}),e.newLine=new e("newline",{fontCharacter:"\\ebea"}),e.layout=new e("layout",{fontCharacter:"\\ebeb"}),e.layoutActivitybarLeft=new e("layout-activitybar-left",{fontCharacter:"\\ebec"}),e.layoutActivitybarRight=new e("layout-activitybar-right",{fontCharacter:"\\ebed"}),e.layoutPanelLeft=new e("layout-panel-left",{fontCharacter:"\\ebee"}),e.layoutPanelCenter=new e("layout-panel-center",{fontCharacter:"\\ebef"}),e.layoutPanelJustify=new e("layout-panel-justify",{fontCharacter:"\\ebf0"}),e.layoutPanelRight=new e("layout-panel-right",{fontCharacter:"\\ebf1"}),e.layoutPanel=new e("layout-panel",{fontCharacter:"\\ebf2"}),e.layoutSidebarLeft=new e("layout-sidebar-left",{fontCharacter:"\\ebf3"}),e.layoutSidebarRight=new e("layout-sidebar-right",{fontCharacter:"\\ebf4"}),e.layoutStatusbar=new e("layout-statusbar",{fontCharacter:"\\ebf5"}),e.layoutMenubar=new e("layout-menubar",{fontCharacter:"\\ebf6"}),e.layoutCentered=new e("layout-centered",{fontCharacter:"\\ebf7"}),e.layoutSidebarRightOff=new e("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),e.layoutPanelOff=new e("layout-panel-off",{fontCharacter:"\\ec01"}),e.layoutSidebarLeftOff=new e("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),e.target=new e("target",{fontCharacter:"\\ebf8"}),e.indent=new e("indent",{fontCharacter:"\\ebf9"}),e.recordSmall=new e("record-small",{fontCharacter:"\\ebfa"}),e.errorSmall=new e("error-small",{fontCharacter:"\\ebfb"}),e.terminalDecorationError=new e("terminal-decoration-error",e.errorSmall.definition),e.arrowCircleDown=new e("arrow-circle-down",{fontCharacter:"\\ebfc"}),e.arrowCircleLeft=new e("arrow-circle-left",{fontCharacter:"\\ebfd"}),e.arrowCircleRight=new e("arrow-circle-right",{fontCharacter:"\\ebfe"}),e.arrowCircleUp=new e("arrow-circle-up",{fontCharacter:"\\ebff"}),e.heartFilled=new e("heart-filled",{fontCharacter:"\\ec04"}),e.map=new e("map",{fontCharacter:"\\ec05"}),e.mapFilled=new e("map-filled",{fontCharacter:"\\ec06"}),e.circleSmall=new e("circle-small",{fontCharacter:"\\ec07"}),e.bellSlash=new e("bell-slash",{fontCharacter:"\\ec08"}),e.bellSlashDot=new e("bell-slash-dot",{fontCharacter:"\\ec09"}),e.commentUnresolved=new e("comment-unresolved",{fontCharacter:"\\ec0a"}),e.gitPullRequestGoToChanges=new e("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),e.gitPullRequestNewChanges=new e("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),e.dialogError=new e("dialog-error",e.error.definition),e.dialogWarning=new e("dialog-warning",e.warning.definition),e.dialogInfo=new e("dialog-info",e.info.definition),e.dialogClose=new e("dialog-close",e.close.definition),e.treeItemExpanded=new e("tree-item-expanded",e.chevronDown.definition),e.treeFilterOnTypeOn=new e("tree-filter-on-type-on",e.listFilter.definition),e.treeFilterOnTypeOff=new e("tree-filter-on-type-off",e.listSelection.definition),e.treeFilterClear=new e("tree-filter-clear",e.close.definition),e.treeItemLoading=new e("tree-item-loading",e.loading.definition),e.menuSelection=new e("menu-selection",e.check.definition),e.menuSubmenu=new e("menu-submenu",e.chevronRight.definition),e.menuBarMore=new e("menubar-more",e.more.definition),e.scrollbarButtonLeft=new e("scrollbar-button-left",e.triangleLeft.definition),e.scrollbarButtonRight=new e("scrollbar-button-right",e.triangleRight.definition),e.scrollbarButtonUp=new e("scrollbar-button-up",e.triangleUp.definition),e.scrollbarButtonDown=new e("scrollbar-button-down",e.triangleDown.definition),e.toolBarMore=new e("toolbar-more",e.more.definition),e.quickInputBack=new e("quick-input-back",e.arrowLeft.definition);var A;(function(l){l.iconNameSegment="[A-Za-z0-9]+",l.iconNameExpression="[A-Za-z0-9-]+",l.iconModifierExpression="~[A-Za-z]+",l.iconNameCharacter="[A-Za-z0-9~-]";const L=new RegExp(`^(${l.iconNameExpression})(${l.iconModifierExpression})?$`);function C(S){if(S instanceof e)return["codicon","codicon-"+S.id];const t=L.exec(S.id);if(!t)return C(e.error);const[,w,u]=t,b=["codicon","codicon-"+w];return u&&b.push("codicon-modifier-"+u.substr(1)),b}l.asClassNameArray=C;function c(S){return C(S).join(" ")}l.asClassName=c;function d(S){return"."+C(S).join(".")}l.asCSSSelector=d})(A=r.CSSIcon||(r.CSSIcon={}))}),X(Z[23],J([0,1]),function(I,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.DiffChange=void 0;class N{constructor(A,l,L,C){this.originalStart=A,this.originalLength=l,this.modifiedStart=L,this.modifiedLength=C}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}r.DiffChange=N}),X(Z[10],J([0,1]),function(I,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.BugIndicatingError=r.ErrorNoTelemetry=r.NotSupportedError=r.illegalState=r.illegalArgument=r.canceled=r.CancellationError=r.isCancellationError=r.transformErrorForSerialization=r.onUnexpectedExternalError=r.onUnexpectedError=r.errorHandler=r.ErrorHandler=void 0;class N{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(g){setTimeout(()=>{throw g.stack?u.isErrorNoTelemetry(g)?new u(g.message+`

`+g.stack):new Error(g.message+`

`+g.stack):g},0)}}emit(g){this.listeners.forEach(v=>{v(g)})}onUnexpectedError(g){this.unexpectedErrorHandler(g),this.emit(g)}onUnexpectedExternalError(g){this.unexpectedErrorHandler(g)}}r.ErrorHandler=N,r.errorHandler=new N;function e(y){C(y)||r.errorHandler.onUnexpectedError(y)}r.onUnexpectedError=e;function A(y){C(y)||r.errorHandler.onUnexpectedExternalError(y)}r.onUnexpectedExternalError=A;function l(y){if(y instanceof Error){const{name:g,message:v}=y,h=y.stacktrace||y.stack;return{$isError:!0,name:g,message:v,stack:h,noTelemetry:u.isErrorNoTelemetry(y)}}return y}r.transformErrorForSerialization=l;const L="Canceled";function C(y){return y instanceof c?!0:y instanceof Error&&y.name===L&&y.message===L}r.isCancellationError=C;class c extends Error{constructor(){super(L);this.name=this.message}}r.CancellationError=c;function d(){const y=new Error(L);return y.name=y.message,y}r.canceled=d;function S(y){return y?new Error(`Illegal argument: ${y}`):new Error("Illegal argument")}r.illegalArgument=S;function t(y){return y?new Error(`Illegal state: ${y}`):new Error("Illegal state")}r.illegalState=t;class w extends Error{constructor(g){super("NotSupported");g&&(this.message=g)}}r.NotSupportedError=w;class u extends Error{constructor(g){super(g);this.name="ErrorNoTelemetry"}static fromError(g){if(g instanceof u)return g;const v=new u;return v.message=g.message,v.stack=g.stack,v}static isErrorNoTelemetry(g){return g.name==="ErrorNoTelemetry"}}r.ErrorNoTelemetry=u;class b extends Error{constructor(g){super(g||"An unexpected bug occurred.");Object.setPrototypeOf(this,b.prototype);debugger}}r.BugIndicatingError=b}),X(Z[24],J([0,1]),function(I,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.once=void 0;function N(e){const A=this;let l=!1,L;return function(){return l||(l=!0,L=e.apply(A,arguments)),L}}r.once=N}),X(Z[11],J([0,1]),function(I,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Iterable=void 0;var N;(function(e){function A(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}e.is=A;const l=Object.freeze([]);function L(){return l}e.empty=L;function*C(o){yield o}e.single=C;function c(o){return o||l}e.from=c;function d(o){return!o||o[Symbol.iterator]().next().done===!0}e.isEmpty=d;function S(o){return o[Symbol.iterator]().next().value}e.first=S;function t(o,s){for(const f of o)if(s(f))return!0;return!1}e.some=t;function w(o,s){for(const f of o)if(s(f))return f}e.find=w;function*u(o,s){for(const f of o)s(f)&&(yield f)}e.filter=u;function*b(o,s){let f=0;for(const _ of o)yield s(_,f++)}e.map=b;function*y(...o){for(const s of o)for(const f of s)yield f}e.concat=y;function*g(o){for(const s of o)for(const f of s)yield f}e.concatNested=g;function v(o,s,f){let _=f;for(const E of o)_=s(_,E);return _}e.reduce=v;function h(o,s){let f=0;for(const _ of o)s(_,f++)}e.forEach=h;function*i(o,s,f=o.length){for(s<0&&(s+=o.length),f<0?f+=o.length:f>o.length&&(f=o.length);s<f;s++)yield o[s]}e.slice=i;function a(o,s=Number.POSITIVE_INFINITY){const f=[];if(s===0)return[f,o];const _=o[Symbol.iterator]();for(let E=0;E<s;E++){const M=_.next();if(M.done)return[f,e.empty()];f.push(M.value)}return[f,{[Symbol.iterator](){return _}}]}e.consume=a;function m(o){return a(o)[0]}e.collect=m;function p(o,s,f=(_,E)=>_===E){const _=o[Symbol.iterator](),E=s[Symbol.iterator]();for(;;){const M=_.next(),D=E.next();if(M.done!==D.done)return!1;if(M.done)return!0;if(!f(M.value,D.value))return!1}}e.equals=p})(N=r.Iterable||(r.Iterable={}))}),X(Z[25],J([0,1]),function(I,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.KeyChord=r.KeyCodeUtils=r.IMMUTABLE_KEY_CODE_TO_CODE=r.IMMUTABLE_CODE_TO_KEY_CODE=r.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=r.EVENT_KEY_CODE_MAP=void 0;class N{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(w,u){this._keyCodeToStr[w]=u,this._strToKeyCode[u.toLowerCase()]=w}keyCodeToStr(w){return this._keyCodeToStr[w]}strToKeyCode(w){return this._strToKeyCode[w.toLowerCase()]||0}}const e=new N,A=new N,l=new N;r.EVENT_KEY_CODE_MAP=new Array(230),r.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const L=[],C=Object.create(null),c=Object.create(null);r.IMMUTABLE_CODE_TO_KEY_CODE=[],r.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)r.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=127;t++)r.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",w=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]],u=[],b=[];for(const y of w){const[g,v,h,i,a,m,p,o,s,f]=y;if(b[h]||(b[h]=!0,L[h]=i,C[i]=h,c[i.toLowerCase()]=h,v&&(r.IMMUTABLE_CODE_TO_KEY_CODE[h]=a,a!==0&&a!==3&&a!==5&&a!==4&&a!==6&&a!==57&&(r.IMMUTABLE_KEY_CODE_TO_CODE[a]=h))),!u[a]){if(u[a]=!0,!m)throw new Error(`String representation missing for key code ${a} around scan code ${i}`);e.define(a,m),A.define(a,s||m),l.define(a,f||s||m)}p&&(r.EVENT_KEY_CODE_MAP[p]=a),o&&(r.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[o]=a)}r.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var d;(function(t){function w(h){return e.keyCodeToStr(h)}t.toString=w;function u(h){return e.strToKeyCode(h)}t.fromString=u;function b(h){return A.keyCodeToStr(h)}t.toUserSettingsUS=b;function y(h){return l.keyCodeToStr(h)}t.toUserSettingsGeneral=y;function g(h){return A.strToKeyCode(h)||l.strToKeyCode(h)}t.fromUserSettings=g;function v(h){if(h>=93&&h<=108)return null;switch(h){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return e.keyCodeToStr(h)}t.toElectronAccelerator=v})(d=r.KeyCodeUtils||(r.KeyCodeUtils={}));function S(t,w){const u=(w&65535)<<16>>>0;return(t|u)>>>0}r.KeyChord=S}),X(Z[26],J([0,1]),function(I,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Lazy=void 0;class N{constructor(A){this.executor=A,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}r.Lazy=N}),X(Z[7],J([0,1,24,11]),function(I,r,N,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.ImmortalReference=r.SafeDisposable=r.RefCountedDisposable=r.MutableDisposable=r.Disposable=r.DisposableStore=r.toDisposable=r.combinedDisposable=r.dispose=r.isDisposable=r.MultiDisposeError=r.markAsSingleton=r.setDisposableTracker=void 0;const A=!1;let l=null;function L(o){l=o}if(r.setDisposableTracker=L,A){const o="__is_disposable_tracked__";L(new class{trackDisposable(s){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[o]||console.log(f)},3e3)}setParent(s,f){if(s&&s!==h.None)try{s[o]=!0}catch{}}markAsDisposed(s){if(s&&s!==h.None)try{s[o]=!0}catch{}}markAsSingleton(s){}})}function C(o){return l==null||l.trackDisposable(o),o}function c(o){l==null||l.markAsDisposed(o)}function d(o,s){l==null||l.setParent(o,s)}function S(o,s){if(!!l)for(const f of o)l.setParent(f,s)}function t(o){return l==null||l.markAsSingleton(o),o}r.markAsSingleton=t;class w extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}r.MultiDisposeError=w;function u(o){return typeof o.dispose=="function"&&o.dispose.length===0}r.isDisposable=u;function b(o){if(e.Iterable.is(o)){const s=[];for(const f of o)if(f)try{f.dispose()}catch(_){s.push(_)}if(s.length===1)throw s[0];if(s.length>1)throw new w(s);return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}r.dispose=b;function y(...o){const s=g(()=>b(o));return S(o,s),s}r.combinedDisposable=y;function g(o){const s=C({dispose:(0,N.once)(()=>{c(s),o()})});return s}r.toDisposable=g;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(c(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{b(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return d(s,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}r.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this._store=new v,C(this),d(this._store,this)}dispose(){c(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}r.Disposable=h,h.None=Object.freeze({dispose(){}});class i{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){var f;this._isDisposed||s===this._value||((f=this._value)===null||f===void 0||f.dispose(),s&&d(s,this),this._value=s)}clear(){this.value=void 0}dispose(){var s;this._isDisposed=!0,c(this),(s=this._value)===null||s===void 0||s.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&d(s,null),s}}r.MutableDisposable=i;class a{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}r.RefCountedDisposable=a;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(s){let f=s;return this.unset=()=>f=void 0,this.isset=()=>f!==void 0,this.dispose=()=>{f&&(f(),f=void 0,c(this))},this}}r.SafeDisposable=m;class p{constructor(s){this.object=s}dispose(){}}r.ImmortalReference=p}),X(Z[12],J([0,1]),function(I,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.LinkedList=void 0;class N{constructor(l){this.element=l,this.next=N.Undefined,this.prev=N.Undefined}}N.Undefined=new N(void 0);class e{constructor(){this._first=N.Undefined,this._last=N.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===N.Undefined}clear(){let l=this._first;for(;l!==N.Undefined;){const L=l.next;l.prev=N.Undefined,l.next=N.Undefined,l=L}this._first=N.Undefined,this._last=N.Undefined,this._size=0}unshift(l){return this._insert(l,!1)}push(l){return this._insert(l,!0)}_insert(l,L){const C=new N(l);if(this._first===N.Undefined)this._first=C,this._last=C;else if(L){const d=this._last;this._last=C,C.prev=d,d.next=C}else{const d=this._first;this._first=C,C.next=d,d.prev=C}this._size+=1;let c=!1;return()=>{c||(c=!0,this._remove(C))}}shift(){if(this._first!==N.Undefined){const l=this._first.element;return this._remove(this._first),l}}pop(){if(this._last!==N.Undefined){const l=this._last.element;return this._remove(this._last),l}}_remove(l){if(l.prev!==N.Undefined&&l.next!==N.Undefined){const L=l.prev;L.next=l.next,l.next.prev=L}else l.prev===N.Undefined&&l.next===N.Undefined?(this._first=N.Undefined,this._last=N.Undefined):l.next===N.Undefined?(this._last=this._last.prev,this._last.next=N.Undefined):l.prev===N.Undefined&&(this._first=this._first.next,this._first.prev=N.Undefined);this._size-=1}*[Symbol.iterator](){let l=this._first;for(;l!==N.Undefined;)yield l.element,l=l.next}}r.LinkedList=e}),X(Z[2],J([0,1,21,26]),function(I,r,N,e){"use strict";var A;Object.defineProperty(r,"__esModule",{value:!0}),r.InvisibleCharacters=r.AmbiguousCharacters=r.noBreakWhitespace=r.getLeftDeleteOffset=r.singleLetterHash=r.containsUppercaseCharacter=r.startsWithUTF8BOM=r.UTF8_BOM_CHARACTER=r.isEmojiImprecise=r.isFullWidthCharacter=r.containsUnusualLineTerminators=r.UNUSUAL_LINE_TERMINATORS=r.isBasicASCII=r.containsRTL=r.getCharContainingOffset=r.prevCharLength=r.nextCharLength=r.GraphemeIterator=r.CodePointIterator=r.getNextCodePoint=r.computeCodePoint=r.isLowSurrogate=r.isHighSurrogate=r.commonSuffixLength=r.commonPrefixLength=r.startsWithIgnoreCase=r.equalsIgnoreCase=r.isUpperAsciiLetter=r.isLowerAsciiLetter=r.isAsciiDigit=r.compareSubstringIgnoreCase=r.compareIgnoreCase=r.compareSubstring=r.compare=r.lastNonWhitespaceIndex=r.getLeadingWhitespace=r.firstNonWhitespaceIndex=r.splitLines=r.regExpFlags=r.regExpLeadsToEndlessLoop=r.createRegExp=r.stripWildcards=r.convertSimple2RegExpPattern=r.rtrim=r.ltrim=r.trim=r.escapeRegExpCharacters=r.escape=r.format=r.isFalsyOrWhitespace=void 0;function l(R){return!R||typeof R!="string"?!0:R.trim().length===0}r.isFalsyOrWhitespace=l;const L=/{(\d+)}/g;function C(R,...F){return F.length===0?R:R.replace(L,function(V,H){const Y=parseInt(H,10);return isNaN(Y)||Y<0||Y>=F.length?V:F[Y]})}r.format=C;function c(R){return R.replace(/[<>&]/g,function(F){switch(F){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return F}})}r.escape=c;function d(R){return R.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}r.escapeRegExpCharacters=d;function S(R,F=" "){const V=t(R,F);return w(V,F)}r.trim=S;function t(R,F){if(!R||!F)return R;const V=F.length;if(V===0||R.length===0)return R;let H=0;for(;R.indexOf(F,H)===H;)H=H+V;return R.substring(H)}r.ltrim=t;function w(R,F){if(!R||!F)return R;const V=F.length,H=R.length;if(V===0||H===0)return R;let Y=H,ne=-1;for(;ne=R.lastIndexOf(F,Y-1),!(ne===-1||ne+V!==Y);){if(ne===0)return"";Y=ne}return R.substring(0,Y)}r.rtrim=w;function u(R){return R.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}r.convertSimple2RegExpPattern=u;function b(R){return R.replace(/\*/g,"")}r.stripWildcards=b;function y(R,F,V={}){if(!R)throw new Error("Cannot create regex from empty string");F||(R=d(R)),V.wholeWord&&(/\B/.test(R.charAt(0))||(R="\\b"+R),/\B/.test(R.charAt(R.length-1))||(R=R+"\\b"));let H="";return V.global&&(H+="g"),V.matchCase||(H+="i"),V.multiline&&(H+="m"),V.unicode&&(H+="u"),new RegExp(R,H)}r.createRegExp=y;function g(R){return R.source==="^"||R.source==="^$"||R.source==="$"||R.source==="^\\s*$"?!1:!!(R.exec("")&&R.lastIndex===0)}r.regExpLeadsToEndlessLoop=g;function v(R){return(R.global?"g":"")+(R.ignoreCase?"i":"")+(R.multiline?"m":"")+(R.unicode?"u":"")}r.regExpFlags=v;function h(R){return R.split(/\r\n|\r|\n/)}r.splitLines=h;function i(R){for(let F=0,V=R.length;F<V;F++){const H=R.charCodeAt(F);if(H!==32&&H!==9)return F}return-1}r.firstNonWhitespaceIndex=i;function a(R,F=0,V=R.length){for(let H=F;H<V;H++){const Y=R.charCodeAt(H);if(Y!==32&&Y!==9)return R.substring(F,H)}return R.substring(F,V)}r.getLeadingWhitespace=a;function m(R,F=R.length-1){for(let V=F;V>=0;V--){const H=R.charCodeAt(V);if(H!==32&&H!==9)return V}return-1}r.lastNonWhitespaceIndex=m;function p(R,F){return R<F?-1:R>F?1:0}r.compare=p;function o(R,F,V=0,H=R.length,Y=0,ne=F.length){for(;V<H&&Y<ne;V++,Y++){const he=R.charCodeAt(V),re=F.charCodeAt(Y);if(he<re)return-1;if(he>re)return 1}const oe=H-V,be=ne-Y;return oe<be?-1:oe>be?1:0}r.compareSubstring=o;function s(R,F){return f(R,F,0,R.length,0,F.length)}r.compareIgnoreCase=s;function f(R,F,V=0,H=R.length,Y=0,ne=F.length){for(;V<H&&Y<ne;V++,Y++){let he=R.charCodeAt(V),re=F.charCodeAt(Y);if(he===re)continue;if(he>=128||re>=128)return o(R.toLowerCase(),F.toLowerCase(),V,H,Y,ne);E(he)&&(he-=32),E(re)&&(re-=32);const ce=he-re;if(ce!==0)return ce}const oe=H-V,be=ne-Y;return oe<be?-1:oe>be?1:0}r.compareSubstringIgnoreCase=f;function _(R){return R>=48&&R<=57}r.isAsciiDigit=_;function E(R){return R>=97&&R<=122}r.isLowerAsciiLetter=E;function M(R){return R>=65&&R<=90}r.isUpperAsciiLetter=M;function D(R,F){return R.length===F.length&&f(R,F)===0}r.equalsIgnoreCase=D;function P(R,F){const V=F.length;return F.length>R.length?!1:f(R,F,0,V)===0}r.startsWithIgnoreCase=P;function B(R,F){const V=Math.min(R.length,F.length);let H;for(H=0;H<V;H++)if(R.charCodeAt(H)!==F.charCodeAt(H))return H;return V}r.commonPrefixLength=B;function W(R,F){const V=Math.min(R.length,F.length);let H;const Y=R.length-1,ne=F.length-1;for(H=0;H<V;H++)if(R.charCodeAt(Y-H)!==F.charCodeAt(ne-H))return H;return V}r.commonSuffixLength=W;function $(R){return 55296<=R&&R<=56319}r.isHighSurrogate=$;function q(R){return 56320<=R&&R<=57343}r.isLowSurrogate=q;function k(R,F){return(R-55296<<10)+(F-56320)+65536}r.computeCodePoint=k;function U(R,F,V){const H=R.charCodeAt(V);if($(H)&&V+1<F){const Y=R.charCodeAt(V+1);if(q(Y))return k(H,Y)}return H}r.getNextCodePoint=U;function T(R,F){const V=R.charCodeAt(F-1);if(q(V)&&F>1){const H=R.charCodeAt(F-2);if($(H))return k(H,V)}return V}class O{constructor(F,V=0){this._str=F,this._len=F.length,this._offset=V}get offset(){return this._offset}setOffset(F){this._offset=F}prevCodePoint(){const F=T(this._str,this._offset);return this._offset-=F>=65536?2:1,F}nextCodePoint(){const F=U(this._str,this._len,this._offset);return this._offset+=F>=65536?2:1,F}eol(){return this._offset>=this._len}}r.CodePointIterator=O;class z{constructor(F,V=0){this._iterator=new O(F,V)}get offset(){return this._iterator.offset}nextGraphemeLength(){const F=ue.getInstance(),V=this._iterator,H=V.offset;let Y=F.getGraphemeBreakType(V.nextCodePoint());for(;!V.eol();){const ne=V.offset,oe=F.getGraphemeBreakType(V.nextCodePoint());if(ge(Y,oe)){V.setOffset(ne);break}Y=oe}return V.offset-H}prevGraphemeLength(){const F=ue.getInstance(),V=this._iterator,H=V.offset;let Y=F.getGraphemeBreakType(V.prevCodePoint());for(;V.offset>0;){const ne=V.offset,oe=F.getGraphemeBreakType(V.prevCodePoint());if(ge(oe,Y)){V.setOffset(ne);break}Y=oe}return H-V.offset}eol(){return this._iterator.eol()}}r.GraphemeIterator=z;function n(R,F){return new z(R,F).nextGraphemeLength()}r.nextCharLength=n;function se(R,F){return new z(R,F).prevGraphemeLength()}r.prevCharLength=se;function me(R,F){F>0&&q(R.charCodeAt(F))&&F--;const V=F+n(R,F);return[V-se(R,V),V]}r.getCharContainingOffset=me;const _e=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ye(R){return _e.test(R)}r.containsRTL=ye;const K=/^[\t\n\r\x20-\x7E]*$/;function j(R){return K.test(R)}r.isBasicASCII=j,r.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function G(R){return r.UNUSUAL_LINE_TERMINATORS.test(R)}r.containsUnusualLineTerminators=G;function Q(R){return R>=11904&&R<=55215||R>=63744&&R<=64255||R>=65281&&R<=65374}r.isFullWidthCharacter=Q;function x(R){return R>=127462&&R<=127487||R===8986||R===8987||R===9200||R===9203||R>=9728&&R<=10175||R===11088||R===11093||R>=127744&&R<=128591||R>=128640&&R<=128764||R>=128992&&R<=129008||R>=129280&&R<=129535||R>=129648&&R<=129782}r.isEmojiImprecise=x,r.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ee(R){return!!(R&&R.length>0&&R.charCodeAt(0)===65279)}r.startsWithUTF8BOM=ee;function te(R,F=!1){return R?(F&&(R=R.replace(/\\./g,"")),R.toLowerCase()!==R):!1}r.containsUppercaseCharacter=te;function ae(R){const F=90-65+1;return R=R%(2*F),R<F?String.fromCharCode(97+R):String.fromCharCode(65+R-F)}r.singleLetterHash=ae;function ge(R,F){return R===0?F!==5&&F!==7:R===2&&F===3?!1:R===4||R===2||R===3||F===4||F===2||F===3?!0:!(R===8&&(F===8||F===9||F===11||F===12)||(R===11||R===9)&&(F===9||F===10)||(R===12||R===10)&&F===10||F===5||F===13||F===7||R===1||R===13&&F===14||R===6&&F===6)}class ue{constructor(){this._data=ve()}static getInstance(){return ue._INSTANCE||(ue._INSTANCE=new ue),ue._INSTANCE}getGraphemeBreakType(F){if(F<32)return F===10?3:F===13?2:4;if(F<127)return 0;const V=this._data,H=V.length/3;let Y=1;for(;Y<=H;)if(F<V[3*Y])Y=2*Y;else if(F>V[3*Y+1])Y=2*Y+1;else return V[3*Y+2];return 0}}ue._INSTANCE=null;function ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ce(R,F){if(R===0)return 0;const V=Le(R,F);if(V!==void 0)return V;const H=new O(F,R);return H.prevCodePoint(),H.offset}r.getLeftDeleteOffset=Ce;function Le(R,F){const V=new O(F,R);let H=V.prevCodePoint();for(;Se(H)||H===65039||H===8419;){if(V.offset===0)return;H=V.prevCodePoint()}if(!x(H))return;let Y=V.offset;return Y>0&&V.prevCodePoint()===8205&&(Y=V.offset),Y}function Se(R){return 127995<=R&&R<=127999}r.noBreakWhitespace="\xA0";class fe{constructor(F){this.confusableDictionary=F}static getInstance(F){return fe.cache.get(Array.from(F))}static getLocales(){return fe._locales.getValue()}isAmbiguous(F){return this.confusableDictionary.has(F)}getPrimaryConfusable(F){return this.confusableDictionary.get(F)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}r.AmbiguousCharacters=fe,A=fe,fe.ambiguousCharacterData=new e.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),fe.cache=new N.LRUCachedFunction(R=>{function F(re){const ce=new Map;for(let de=0;de<re.length;de+=2)ce.set(re[de],re[de+1]);return ce}function V(re,ce){const de=new Map(re);for(const[pe,Ne]of ce)de.set(pe,Ne);return de}function H(re,ce){if(!re)return ce;const de=new Map;for(const[pe,Ne]of re)ce.has(pe)&&de.set(pe,Ne);return de}const Y=A.ambiguousCharacterData.getValue();let ne=R.filter(re=>!re.startsWith("_")&&re in Y);ne.length===0&&(ne=["_default"]);let oe;for(const re of ne){const ce=F(Y[re]);oe=H(oe,ce)}const be=F(Y._common),he=V(be,oe);return new fe(he)}),fe._locales=new e.Lazy(()=>Object.keys(fe.ambiguousCharacterData.getValue()).filter(R=>!R.startsWith("_")));class we{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(we.getRawData())),this._data}static isInvisibleCharacter(F){return we.getData().has(F)}static get codePoints(){return we.getData()}}r.InvisibleCharacters=we,we._data=void 0}),X(Z[27],J([0,1,2]),function(I,r,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.StringSHA1=r.toHexString=r.stringHash=r.numberHash=r.doHash=r.hash=void 0;function e(y){return A(y,0)}r.hash=e;function A(y,g){switch(typeof y){case"object":return y===null?l(349,g):Array.isArray(y)?c(y,g):d(y,g);case"string":return C(y,g);case"boolean":return L(y,g);case"number":return l(y,g);case"undefined":return l(937,g);default:return l(617,g)}}r.doHash=A;function l(y,g){return(g<<5)-g+y|0}r.numberHash=l;function L(y,g){return l(y?433:863,g)}function C(y,g){g=l(149417,g);for(let v=0,h=y.length;v<h;v++)g=l(y.charCodeAt(v),g);return g}r.stringHash=C;function c(y,g){return g=l(104579,g),y.reduce((v,h)=>A(h,v),g)}function d(y,g){return g=l(181387,g),Object.keys(y).sort().reduce((v,h)=>(v=C(h,v),A(y[h],v)),g)}function S(y,g,v=32){const h=v-g,i=~((1<<h)-1);return(y<<g|(i&y)>>>h)>>>0}function t(y,g=0,v=y.byteLength,h=0){for(let i=0;i<v;i++)y[g+i]=h}function w(y,g,v="0"){for(;y.length<g;)y=v+y;return y}function u(y,g=32){return y instanceof ArrayBuffer?Array.from(new Uint8Array(y)).map(v=>v.toString(16).padStart(2,"0")).join(""):w((y>>>0).toString(16),g/4)}r.toHexString=u;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const v=g.length;if(v===0)return;const h=this._buff;let i=this._buffLen,a=this._leftoverHighSurrogate,m,p;for(a!==0?(m=a,p=-1,a=0):(m=g.charCodeAt(0),p=0);;){let o=m;if(N.isHighSurrogate(m))if(p+1<v){const s=g.charCodeAt(p+1);N.isLowSurrogate(s)?(p++,o=N.computeCodePoint(m,s)):o=65533}else{a=m;break}else N.isLowSurrogate(m)&&(o=65533);if(i=this._push(h,i,o),p++,p<v)m=g.charCodeAt(p);else break}this._buffLen=i,this._leftoverHighSurrogate=a}_push(g,v,h){return h<128?g[v++]=h:h<2048?(g[v++]=192|(h&1984)>>>6,g[v++]=128|(h&63)>>>0):h<65536?(g[v++]=224|(h&61440)>>>12,g[v++]=128|(h&4032)>>>6,g[v++]=128|(h&63)>>>0):(g[v++]=240|(h&1835008)>>>18,g[v++]=128|(h&258048)>>>12,g[v++]=128|(h&4032)>>>6,g[v++]=128|(h&63)>>>0),v>=64&&(this._step(),v-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),u(this._h0)+u(this._h1)+u(this._h2)+u(this._h3)+u(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,t(this._buff,this._buffLen),this._buffLen>56&&(this._step(),t(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=b._bigBlock32,v=this._buffDV;for(let _=0;_<64;_+=4)g.setUint32(_,v.getUint32(_,!1),!1);for(let _=64;_<320;_+=4)g.setUint32(_,S(g.getUint32(_-12,!1)^g.getUint32(_-32,!1)^g.getUint32(_-56,!1)^g.getUint32(_-64,!1),1),!1);let h=this._h0,i=this._h1,a=this._h2,m=this._h3,p=this._h4,o,s,f;for(let _=0;_<80;_++)_<20?(o=i&a|~i&m,s=1518500249):_<40?(o=i^a^m,s=1859775393):_<60?(o=i&a|i&m|a&m,s=2400959708):(o=i^a^m,s=3395469782),f=S(h,5)+o+p+s+g.getUint32(_*4,!1)&4294967295,p=m,m=a,a=S(i,30),i=h,h=f;this._h0=this._h0+h&4294967295,this._h1=this._h1+i&4294967295,this._h2=this._h2+a&4294967295,this._h3=this._h3+m&4294967295,this._h4=this._h4+p&4294967295}}r.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),X(Z[13],J([0,1,23,27]),function(I,r,N,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.LcsDiff=r.MyArray=r.Debug=r.stringDiff=r.StringDiffSequence=void 0;class A{constructor(t){this.source=t}getElements(){const t=this.source,w=new Int32Array(t.length);for(let u=0,b=t.length;u<b;u++)w[u]=t.charCodeAt(u);return w}}r.StringDiffSequence=A;function l(S,t,w){return new d(new A(S),new A(t)).ComputeDiff(w).changes}r.stringDiff=l;class L{static Assert(t,w){if(!t)throw new Error(w)}}r.Debug=L;class C{static Copy(t,w,u,b,y){for(let g=0;g<y;g++)u[b+g]=t[w+g]}static Copy2(t,w,u,b,y){for(let g=0;g<y;g++)u[b+g]=t[w+g]}}r.MyArray=C;class c{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new N.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(t,w){this.m_originalStart=Math.min(this.m_originalStart,t),this.m_modifiedStart=Math.min(this.m_modifiedStart,w),this.m_originalCount++}AddModifiedElement(t,w){this.m_originalStart=Math.min(this.m_originalStart,t),this.m_modifiedStart=Math.min(this.m_modifiedStart,w),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class d{constructor(t,w,u=null){this.ContinueProcessingPredicate=u,this._originalSequence=t,this._modifiedSequence=w;const[b,y,g]=d._getElements(t),[v,h,i]=d._getElements(w);this._hasStrings=g&&i,this._originalStringElements=b,this._originalElementsOrHash=y,this._modifiedStringElements=v,this._modifiedElementsOrHash=h,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(t){return t.length>0&&typeof t[0]=="string"}static _getElements(t){const w=t.getElements();if(d._isStringArray(w)){const u=new Int32Array(w.length);for(let b=0,y=w.length;b<y;b++)u[b]=(0,e.stringHash)(w[b],0);return[w,u,!0]}return w instanceof Int32Array?[[],w,!1]:[[],new Int32Array(w),!1]}ElementsAreEqual(t,w){return this._originalElementsOrHash[t]!==this._modifiedElementsOrHash[w]?!1:this._hasStrings?this._originalStringElements[t]===this._modifiedStringElements[w]:!0}ElementsAreStrictEqual(t,w){if(!this.ElementsAreEqual(t,w))return!1;const u=d._getStrictElement(this._originalSequence,t),b=d._getStrictElement(this._modifiedSequence,w);return u===b}static _getStrictElement(t,w){return typeof t.getStrictElement=="function"?t.getStrictElement(w):null}OriginalElementsAreEqual(t,w){return this._originalElementsOrHash[t]!==this._originalElementsOrHash[w]?!1:this._hasStrings?this._originalStringElements[t]===this._originalStringElements[w]:!0}ModifiedElementsAreEqual(t,w){return this._modifiedElementsOrHash[t]!==this._modifiedElementsOrHash[w]?!1:this._hasStrings?this._modifiedStringElements[t]===this._modifiedStringElements[w]:!0}ComputeDiff(t){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,t)}_ComputeDiff(t,w,u,b,y){const g=[!1];let v=this.ComputeDiffRecursive(t,w,u,b,g);return y&&(v=this.PrettifyChanges(v)),{quitEarly:g[0],changes:v}}ComputeDiffRecursive(t,w,u,b,y){for(y[0]=!1;t<=w&&u<=b&&this.ElementsAreEqual(t,u);)t++,u++;for(;w>=t&&b>=u&&this.ElementsAreEqual(w,b);)w--,b--;if(t>w||u>b){let m;return u<=b?(L.Assert(t===w+1,"originalStart should only be one more than originalEnd"),m=[new N.DiffChange(t,0,u,b-u+1)]):t<=w?(L.Assert(u===b+1,"modifiedStart should only be one more than modifiedEnd"),m=[new N.DiffChange(t,w-t+1,u,0)]):(L.Assert(t===w+1,"originalStart should only be one more than originalEnd"),L.Assert(u===b+1,"modifiedStart should only be one more than modifiedEnd"),m=[]),m}const g=[0],v=[0],h=this.ComputeRecursionPoint(t,w,u,b,g,v,y),i=g[0],a=v[0];if(h!==null)return h;if(!y[0]){const m=this.ComputeDiffRecursive(t,i,u,a,y);let p=[];return y[0]?p=[new N.DiffChange(i+1,w-(i+1)+1,a+1,b-(a+1)+1)]:p=this.ComputeDiffRecursive(i+1,w,a+1,b,y),this.ConcatenateChanges(m,p)}return[new N.DiffChange(t,w-t+1,u,b-u+1)]}WALKTRACE(t,w,u,b,y,g,v,h,i,a,m,p,o,s,f,_,E,M){let D=null,P=null,B=new c,W=w,$=u,q=o[0]-_[0]-b,k=-1073741824,U=this.m_forwardHistory.length-1;do{const T=q+t;T===W||T<$&&i[T-1]<i[T+1]?(m=i[T+1],s=m-q-b,m<k&&B.MarkNextChange(),k=m,B.AddModifiedElement(m+1,s),q=T+1-t):(m=i[T-1]+1,s=m-q-b,m<k&&B.MarkNextChange(),k=m-1,B.AddOriginalElement(m,s+1),q=T-1-t),U>=0&&(i=this.m_forwardHistory[U],t=i[0],W=1,$=i.length-1)}while(--U>=-1);if(D=B.getReverseChanges(),M[0]){let T=o[0]+1,O=_[0]+1;if(D!==null&&D.length>0){const z=D[D.length-1];T=Math.max(T,z.getOriginalEnd()),O=Math.max(O,z.getModifiedEnd())}P=[new N.DiffChange(T,p-T+1,O,f-O+1)]}else{B=new c,W=g,$=v,q=o[0]-_[0]-h,k=1073741824,U=E?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const T=q+y;T===W||T<$&&a[T-1]>=a[T+1]?(m=a[T+1]-1,s=m-q-h,m>k&&B.MarkNextChange(),k=m+1,B.AddOriginalElement(m+1,s+1),q=T+1-y):(m=a[T-1],s=m-q-h,m>k&&B.MarkNextChange(),k=m,B.AddModifiedElement(m+1,s+1),q=T-1-y),U>=0&&(a=this.m_reverseHistory[U],y=a[0],W=1,$=a.length-1)}while(--U>=-1);P=B.getChanges()}return this.ConcatenateChanges(D,P)}ComputeRecursionPoint(t,w,u,b,y,g,v){let h=0,i=0,a=0,m=0,p=0,o=0;t--,u--,y[0]=0,g[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const s=w-t+(b-u),f=s+1,_=new Int32Array(f),E=new Int32Array(f),M=b-u,D=w-t,P=t-u,B=w-b,$=(D-M)%2==0;_[M]=t,E[D]=w,v[0]=!1;for(let q=1;q<=s/2+1;q++){let k=0,U=0;a=this.ClipDiagonalBound(M-q,q,M,f),m=this.ClipDiagonalBound(M+q,q,M,f);for(let O=a;O<=m;O+=2){O===a||O<m&&_[O-1]<_[O+1]?h=_[O+1]:h=_[O-1]+1,i=h-(O-M)-P;const z=h;for(;h<w&&i<b&&this.ElementsAreEqual(h+1,i+1);)h++,i++;if(_[O]=h,h+i>k+U&&(k=h,U=i),!$&&Math.abs(O-D)<=q-1&&h>=E[O])return y[0]=h,g[0]=i,z<=E[O]&&1447>0&&q<=1447+1?this.WALKTRACE(M,a,m,P,D,p,o,B,_,E,h,w,y,i,b,g,$,v):null}const T=(k-t+(U-u)-q)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(k,T))return v[0]=!0,y[0]=k,g[0]=U,T>0&&1447>0&&q<=1447+1?this.WALKTRACE(M,a,m,P,D,p,o,B,_,E,h,w,y,i,b,g,$,v):(t++,u++,[new N.DiffChange(t,w-t+1,u,b-u+1)]);p=this.ClipDiagonalBound(D-q,q,D,f),o=this.ClipDiagonalBound(D+q,q,D,f);for(let O=p;O<=o;O+=2){O===p||O<o&&E[O-1]>=E[O+1]?h=E[O+1]-1:h=E[O-1],i=h-(O-D)-B;const z=h;for(;h>t&&i>u&&this.ElementsAreEqual(h,i);)h--,i--;if(E[O]=h,$&&Math.abs(O-M)<=q&&h<=_[O])return y[0]=h,g[0]=i,z>=_[O]&&1447>0&&q<=1447+1?this.WALKTRACE(M,a,m,P,D,p,o,B,_,E,h,w,y,i,b,g,$,v):null}if(q<=1447){let O=new Int32Array(m-a+2);O[0]=M-a+1,C.Copy2(_,a,O,1,m-a+1),this.m_forwardHistory.push(O),O=new Int32Array(o-p+2),O[0]=D-p+1,C.Copy2(E,p,O,1,o-p+1),this.m_reverseHistory.push(O)}}return this.WALKTRACE(M,a,m,P,D,p,o,B,_,E,h,w,y,i,b,g,$,v)}PrettifyChanges(t){for(let w=0;w<t.length;w++){const u=t[w],b=w<t.length-1?t[w+1].originalStart:this._originalElementsOrHash.length,y=w<t.length-1?t[w+1].modifiedStart:this._modifiedElementsOrHash.length,g=u.originalLength>0,v=u.modifiedLength>0;for(;u.originalStart+u.originalLength<b&&u.modifiedStart+u.modifiedLength<y&&(!g||this.OriginalElementsAreEqual(u.originalStart,u.originalStart+u.originalLength))&&(!v||this.ModifiedElementsAreEqual(u.modifiedStart,u.modifiedStart+u.modifiedLength));){const i=this.ElementsAreStrictEqual(u.originalStart,u.modifiedStart);if(this.ElementsAreStrictEqual(u.originalStart+u.originalLength,u.modifiedStart+u.modifiedLength)&&!i)break;u.originalStart++,u.modifiedStart++}const h=[null];if(w<t.length-1&&this.ChangesOverlap(t[w],t[w+1],h)){t[w]=h[0],t.splice(w+1,1),w--;continue}}for(let w=t.length-1;w>=0;w--){const u=t[w];let b=0,y=0;if(w>0){const m=t[w-1];b=m.originalStart+m.originalLength,y=m.modifiedStart+m.modifiedLength}const g=u.originalLength>0,v=u.modifiedLength>0;let h=0,i=this._boundaryScore(u.originalStart,u.originalLength,u.modifiedStart,u.modifiedLength);for(let m=1;;m++){const p=u.originalStart-m,o=u.modifiedStart-m;if(p<b||o<y||g&&!this.OriginalElementsAreEqual(p,p+u.originalLength)||v&&!this.ModifiedElementsAreEqual(o,o+u.modifiedLength))break;const f=(p===b&&o===y?5:0)+this._boundaryScore(p,u.originalLength,o,u.modifiedLength);f>i&&(i=f,h=m)}u.originalStart-=h,u.modifiedStart-=h;const a=[null];if(w>0&&this.ChangesOverlap(t[w-1],t[w],a)){t[w-1]=a[0],t.splice(w,1),w++;continue}}if(this._hasStrings)for(let w=1,u=t.length;w<u;w++){const b=t[w-1],y=t[w],g=y.originalStart-b.originalStart-b.originalLength,v=b.originalStart,h=y.originalStart+y.originalLength,i=h-v,a=b.modifiedStart,m=y.modifiedStart+y.modifiedLength,p=m-a;if(g<5&&i<20&&p<20){const o=this._findBetterContiguousSequence(v,i,a,p,g);if(o){const[s,f]=o;(s!==b.originalStart+b.originalLength||f!==b.modifiedStart+b.modifiedLength)&&(b.originalLength=s-b.originalStart,b.modifiedLength=f-b.modifiedStart,y.originalStart=s+g,y.modifiedStart=f+g,y.originalLength=h-y.originalStart,y.modifiedLength=m-y.modifiedStart)}}}return t}_findBetterContiguousSequence(t,w,u,b,y){if(w<y||b<y)return null;const g=t+w-y+1,v=u+b-y+1;let h=0,i=0,a=0;for(let m=t;m<g;m++)for(let p=u;p<v;p++){const o=this._contiguousSequenceScore(m,p,y);o>0&&o>h&&(h=o,i=m,a=p)}return h>0?[i,a]:null}_contiguousSequenceScore(t,w,u){let b=0;for(let y=0;y<u;y++){if(!this.ElementsAreEqual(t+y,w+y))return 0;b+=this._originalStringElements[t+y].length}return b}_OriginalIsBoundary(t){return t<=0||t>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[t])}_OriginalRegionIsBoundary(t,w){if(this._OriginalIsBoundary(t)||this._OriginalIsBoundary(t-1))return!0;if(w>0){const u=t+w;if(this._OriginalIsBoundary(u-1)||this._OriginalIsBoundary(u))return!0}return!1}_ModifiedIsBoundary(t){return t<=0||t>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[t])}_ModifiedRegionIsBoundary(t,w){if(this._ModifiedIsBoundary(t)||this._ModifiedIsBoundary(t-1))return!0;if(w>0){const u=t+w;if(this._ModifiedIsBoundary(u-1)||this._ModifiedIsBoundary(u))return!0}return!1}_boundaryScore(t,w,u,b){const y=this._OriginalRegionIsBoundary(t,w)?1:0,g=this._ModifiedRegionIsBoundary(u,b)?1:0;return y+g}ConcatenateChanges(t,w){const u=[];if(t.length===0||w.length===0)return w.length>0?w:t;if(this.ChangesOverlap(t[t.length-1],w[0],u)){const b=new Array(t.length+w.length-1);return C.Copy(t,0,b,0,t.length-1),b[t.length-1]=u[0],C.Copy(w,1,b,t.length,w.length-1),b}else{const b=new Array(t.length+w.length);return C.Copy(t,0,b,0,t.length),C.Copy(w,0,b,t.length,w.length),b}}ChangesOverlap(t,w,u){if(L.Assert(t.originalStart<=w.originalStart,"Left change is not less than or equal to right change"),L.Assert(t.modifiedStart<=w.modifiedStart,"Left change is not less than or equal to right change"),t.originalStart+t.originalLength>=w.originalStart||t.modifiedStart+t.modifiedLength>=w.modifiedStart){const b=t.originalStart;let y=t.originalLength;const g=t.modifiedStart;let v=t.modifiedLength;return t.originalStart+t.originalLength>=w.originalStart&&(y=w.originalStart+w.originalLength-t.originalStart),t.modifiedStart+t.modifiedLength>=w.modifiedStart&&(v=w.modifiedStart+w.modifiedLength-t.modifiedStart),u[0]=new N.DiffChange(b,y,g,v),!0}else return u[0]=null,!1}ClipDiagonalBound(t,w,u,b){if(t>=0&&t<b)return t;const y=u,g=b-u-1,v=w%2==0;if(t<0){const h=y%2==0;return v===h?0:1}else{const h=g%2==0;return v===h?b-1:b-2}}}r.LcsDiff=d}),X(Z[28],J([0,1]),function(I,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.withNullAsUndefined=r.validateConstraint=r.validateConstraints=r.isFunction=r.assertIsDefined=r.assertType=r.isUndefinedOrNull=r.isDefined=r.isUndefined=r.isBoolean=r.isIterable=r.isNumber=r.isTypedArray=r.isObject=r.isString=void 0;function N(v){return typeof v=="string"}r.isString=N;function e(v){return typeof v=="object"&&v!==null&&!Array.isArray(v)&&!(v instanceof RegExp)&&!(v instanceof Date)}r.isObject=e;function A(v){const h=Object.getPrototypeOf(Uint8Array);return typeof v=="object"&&v instanceof h}r.isTypedArray=A;function l(v){return typeof v=="number"&&!isNaN(v)}r.isNumber=l;function L(v){return!!v&&typeof v[Symbol.iterator]=="function"}r.isIterable=L;function C(v){return v===!0||v===!1}r.isBoolean=C;function c(v){return typeof v=="undefined"}r.isUndefined=c;function d(v){return!S(v)}r.isDefined=d;function S(v){return c(v)||v===null}r.isUndefinedOrNull=S;function t(v,h){if(!v)throw new Error(h?`Unexpected type, expected '${h}'`:"Unexpected type")}r.assertType=t;function w(v){if(S(v))throw new Error("Assertion Failed: argument is undefined or null");return v}r.assertIsDefined=w;function u(v){return typeof v=="function"}r.isFunction=u;function b(v,h){const i=Math.min(v.length,h.length);for(let a=0;a<i;a++)y(v[a],h[a])}r.validateConstraints=b;function y(v,h){if(N(h)){if(typeof v!==h)throw new Error(`argument does not match constraint: typeof ${h}`)}else if(u(h)){try{if(v instanceof h)return}catch{}if(!S(v)&&v.constructor===h||h.length===1&&h.call(void 0,v)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}r.validateConstraint=y;function g(v){return v===null?void 0:v}r.withNullAsUndefined=g}),X(Z[8],J([0,1,28]),function(I,r,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.createProxyObject=r.getAllMethodNames=r.getAllPropertyNames=r.equals=r.mixin=r.cloneAndChange=r.deepFreeze=r.deepClone=void 0;function e(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const b=Array.isArray(u)?[]:{};return Object.keys(u).forEach(y=>{u[y]&&typeof u[y]=="object"?b[y]=e(u[y]):b[y]=u[y]}),b}r.deepClone=e;function A(u){if(!u||typeof u!="object")return u;const b=[u];for(;b.length>0;){const y=b.shift();Object.freeze(y);for(const g in y)if(l.call(y,g)){const v=y[g];typeof v=="object"&&!Object.isFrozen(v)&&!(0,N.isTypedArray)(v)&&b.push(v)}}return u}r.deepFreeze=A;const l=Object.prototype.hasOwnProperty;function L(u,b){return C(u,b,new Set)}r.cloneAndChange=L;function C(u,b,y){if((0,N.isUndefinedOrNull)(u))return u;const g=b(u);if(typeof g!="undefined")return g;if(Array.isArray(u)){const v=[];for(const h of u)v.push(C(h,b,y));return v}if((0,N.isObject)(u)){if(y.has(u))throw new Error("Cannot clone recursive data-structure");y.add(u);const v={};for(const h in u)l.call(u,h)&&(v[h]=C(u[h],b,y));return y.delete(u),v}return u}function c(u,b,y=!0){return(0,N.isObject)(u)?((0,N.isObject)(b)&&Object.keys(b).forEach(g=>{g in u?y&&((0,N.isObject)(u[g])&&(0,N.isObject)(b[g])?c(u[g],b[g],y):u[g]=b[g]):u[g]=b[g]}),u):b}r.mixin=c;function d(u,b){if(u===b)return!0;if(u==null||b===null||b===void 0||typeof u!=typeof b||typeof u!="object"||Array.isArray(u)!==Array.isArray(b))return!1;let y,g;if(Array.isArray(u)){if(u.length!==b.length)return!1;for(y=0;y<u.length;y++)if(!d(u[y],b[y]))return!1}else{const v=[];for(g in u)v.push(g);v.sort();const h=[];for(g in b)h.push(g);if(h.sort(),!d(v,h))return!1;for(y=0;y<v.length;y++)if(!d(u[v[y]],b[v[y]]))return!1}return!0}r.equals=d;function S(u){let b=[],y=Object.getPrototypeOf(u);for(;Object.prototype!==y;)b=b.concat(Object.getOwnPropertyNames(y)),y=Object.getPrototypeOf(y);return b}r.getAllPropertyNames=S;function t(u){const b=[];for(const y of S(u))typeof u[y]=="function"&&b.push(y);return b}r.getAllMethodNames=t;function w(u,b){const y=v=>function(){const h=Array.prototype.slice.call(arguments,0);return b(v,h)},g={};for(const v of u)g[v]=y(v);return g}r.createProxyObject=w}),X(Z[14],J([0,1]),function(I,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.toUint32=r.toUint8=void 0;function N(A){return A<0?0:A>255?255:A|0}r.toUint8=N;function e(A){return A<0?0:A>4294967295?4294967295:A|0}r.toUint32=e}),X(Z[15],J([0,1,14]),function(I,r,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.CharacterSet=r.CharacterClassifier=void 0;class e{constructor(L){const C=(0,N.toUint8)(L);this._defaultValue=C,this._asciiMap=e._createAsciiMap(C),this._map=new Map}static _createAsciiMap(L){const C=new Uint8Array(256);for(let c=0;c<256;c++)C[c]=L;return C}set(L,C){const c=(0,N.toUint8)(C);L>=0&&L<256?this._asciiMap[L]=c:this._map.set(L,c)}get(L){return L>=0&&L<256?this._asciiMap[L]:this._map.get(L)||this._defaultValue}}r.CharacterClassifier=e;class A{constructor(){this._actual=new e(0)}add(L){this._actual.set(L,1)}has(L){return this._actual.get(L)===1}}r.CharacterSet=A}),X(Z[3],J([0,1]),function(I,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Position=void 0;class N{constructor(A,l){this.lineNumber=A,this.column=l}with(A=this.lineNumber,l=this.column){return A===this.lineNumber&&l===this.column?this:new N(A,l)}delta(A=0,l=0){return this.with(this.lineNumber+A,this.column+l)}equals(A){return N.equals(this,A)}static equals(A,l){return!A&&!l?!0:!!A&&!!l&&A.lineNumber===l.lineNumber&&A.column===l.column}isBefore(A){return N.isBefore(this,A)}static isBefore(A,l){return A.lineNumber<l.lineNumber?!0:l.lineNumber<A.lineNumber?!1:A.column<l.column}isBeforeOrEqual(A){return N.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,l){return A.lineNumber<l.lineNumber?!0:l.lineNumber<A.lineNumber?!1:A.column<=l.column}static compare(A,l){const L=A.lineNumber|0,C=l.lineNumber|0;if(L===C){const c=A.column|0,d=l.column|0;return c-d}return L-C}clone(){return new N(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new N(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}}r.Position=N}),X(Z[4],J([0,1,3]),function(I,r,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Range=void 0;class e{constructor(l,L,C,c){l>C||l===C&&L>c?(this.startLineNumber=C,this.startColumn=c,this.endLineNumber=l,this.endColumn=L):(this.startLineNumber=l,this.startColumn=L,this.endLineNumber=C,this.endColumn=c)}isEmpty(){return e.isEmpty(this)}static isEmpty(l){return l.startLineNumber===l.endLineNumber&&l.startColumn===l.endColumn}containsPosition(l){return e.containsPosition(this,l)}static containsPosition(l,L){return!(L.lineNumber<l.startLineNumber||L.lineNumber>l.endLineNumber||L.lineNumber===l.startLineNumber&&L.column<l.startColumn||L.lineNumber===l.endLineNumber&&L.column>l.endColumn)}static strictContainsPosition(l,L){return!(L.lineNumber<l.startLineNumber||L.lineNumber>l.endLineNumber||L.lineNumber===l.startLineNumber&&L.column<=l.startColumn||L.lineNumber===l.endLineNumber&&L.column>=l.endColumn)}containsRange(l){return e.containsRange(this,l)}static containsRange(l,L){return!(L.startLineNumber<l.startLineNumber||L.endLineNumber<l.startLineNumber||L.startLineNumber>l.endLineNumber||L.endLineNumber>l.endLineNumber||L.startLineNumber===l.startLineNumber&&L.startColumn<l.startColumn||L.endLineNumber===l.endLineNumber&&L.endColumn>l.endColumn)}strictContainsRange(l){return e.strictContainsRange(this,l)}static strictContainsRange(l,L){return!(L.startLineNumber<l.startLineNumber||L.endLineNumber<l.startLineNumber||L.startLineNumber>l.endLineNumber||L.endLineNumber>l.endLineNumber||L.startLineNumber===l.startLineNumber&&L.startColumn<=l.startColumn||L.endLineNumber===l.endLineNumber&&L.endColumn>=l.endColumn)}plusRange(l){return e.plusRange(this,l)}static plusRange(l,L){let C,c,d,S;return L.startLineNumber<l.startLineNumber?(C=L.startLineNumber,c=L.startColumn):L.startLineNumber===l.startLineNumber?(C=L.startLineNumber,c=Math.min(L.startColumn,l.startColumn)):(C=l.startLineNumber,c=l.startColumn),L.endLineNumber>l.endLineNumber?(d=L.endLineNumber,S=L.endColumn):L.endLineNumber===l.endLineNumber?(d=L.endLineNumber,S=Math.max(L.endColumn,l.endColumn)):(d=l.endLineNumber,S=l.endColumn),new e(C,c,d,S)}intersectRanges(l){return e.intersectRanges(this,l)}static intersectRanges(l,L){let C=l.startLineNumber,c=l.startColumn,d=l.endLineNumber,S=l.endColumn;const t=L.startLineNumber,w=L.startColumn,u=L.endLineNumber,b=L.endColumn;return C<t?(C=t,c=w):C===t&&(c=Math.max(c,w)),d>u?(d=u,S=b):d===u&&(S=Math.min(S,b)),C>d||C===d&&c>S?null:new e(C,c,d,S)}equalsRange(l){return e.equalsRange(this,l)}static equalsRange(l,L){return!!l&&!!L&&l.startLineNumber===L.startLineNumber&&l.startColumn===L.startColumn&&l.endLineNumber===L.endLineNumber&&l.endColumn===L.endColumn}getEndPosition(){return e.getEndPosition(this)}static getEndPosition(l){return new N.Position(l.endLineNumber,l.endColumn)}getStartPosition(){return e.getStartPosition(this)}static getStartPosition(l){return new N.Position(l.startLineNumber,l.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(l,L){return new e(this.startLineNumber,this.startColumn,l,L)}setStartPosition(l,L){return new e(l,L,this.endLineNumber,this.endColumn)}collapseToStart(){return e.collapseToStart(this)}static collapseToStart(l){return new e(l.startLineNumber,l.startColumn,l.startLineNumber,l.startColumn)}static fromPositions(l,L=l){return new e(l.lineNumber,l.column,L.lineNumber,L.column)}static lift(l){return l?new e(l.startLineNumber,l.startColumn,l.endLineNumber,l.endColumn):null}static isIRange(l){return l&&typeof l.startLineNumber=="number"&&typeof l.startColumn=="number"&&typeof l.endLineNumber=="number"&&typeof l.endColumn=="number"}static areIntersectingOrTouching(l,L){return!(l.endLineNumber<L.startLineNumber||l.endLineNumber===L.startLineNumber&&l.endColumn<L.startColumn||L.endLineNumber<l.startLineNumber||L.endLineNumber===l.startLineNumber&&L.endColumn<l.startColumn)}static areIntersecting(l,L){return!(l.endLineNumber<L.startLineNumber||l.endLineNumber===L.startLineNumber&&l.endColumn<=L.startColumn||L.endLineNumber<l.startLineNumber||L.endLineNumber===l.startLineNumber&&L.endColumn<=l.startColumn)}static compareRangesUsingStarts(l,L){if(l&&L){const d=l.startLineNumber|0,S=L.startLineNumber|0;if(d===S){const t=l.startColumn|0,w=L.startColumn|0;if(t===w){const u=l.endLineNumber|0,b=L.endLineNumber|0;if(u===b){const y=l.endColumn|0,g=L.endColumn|0;return y-g}return u-b}return t-w}return d-S}return(l?1:0)-(L?1:0)}static compareRangesUsingEnds(l,L){return l.endLineNumber===L.endLineNumber?l.endColumn===L.endColumn?l.startLineNumber===L.startLineNumber?l.startColumn-L.startColumn:l.startLineNumber-L.startLineNumber:l.endColumn-L.endColumn:l.endLineNumber-L.endLineNumber}static spansMultipleLines(l){return l.endLineNumber>l.startLineNumber}toJSON(){return this}}r.Range=e}),X(Z[29],J([0,1,3,4]),function(I,r,N,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Selection=void 0;class A extends e.Range{constructor(L,C,c,d){super(L,C,c,d);this.selectionStartLineNumber=L,this.selectionStartColumn=C,this.positionLineNumber=c,this.positionColumn=d}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(L){return A.selectionsEqual(this,L)}static selectionsEqual(L,C){return L.selectionStartLineNumber===C.selectionStartLineNumber&&L.selectionStartColumn===C.selectionStartColumn&&L.positionLineNumber===C.positionLineNumber&&L.positionColumn===C.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(L,C){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,L,C):new A(L,C,this.startLineNumber,this.startColumn)}getPosition(){return new N.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new N.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(L,C){return this.getDirection()===0?new A(L,C,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,L,C)}static fromPositions(L,C=L){return new A(L.lineNumber,L.column,C.lineNumber,C.column)}static fromRange(L,C){return C===0?new A(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):new A(L.endLineNumber,L.endColumn,L.startLineNumber,L.startColumn)}static liftSelection(L){return new A(L.selectionStartLineNumber,L.selectionStartColumn,L.positionLineNumber,L.positionColumn)}static selectionsArrEqual(L,C){if(L&&!C||!L&&C)return!1;if(!L&&!C)return!0;if(L.length!==C.length)return!1;for(let c=0,d=L.length;c<d;c++)if(!this.selectionsEqual(L[c],C[c]))return!1;return!0}static isISelection(L){return L&&typeof L.selectionStartLineNumber=="number"&&typeof L.selectionStartColumn=="number"&&typeof L.positionLineNumber=="number"&&typeof L.positionColumn=="number"}static createWithDirection(L,C,c,d,S){return S===0?new A(L,C,c,d):new A(c,d,L,C)}}r.Selection=A}),X(Z[30],J([0,1,15]),function(I,r,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.getMapForWordSeparators=r.WordCharacterClassifier=void 0;class e extends N.CharacterClassifier{constructor(L){super(0);for(let C=0,c=L.length;C<c;C++)this.set(L.charCodeAt(C),2);this.set(32,1),this.set(9,1)}}r.WordCharacterClassifier=e;function A(l){const L={};return C=>(L.hasOwnProperty(C)||(L[C]=l(C)),L[C])}r.getMapForWordSeparators=A(l=>new e(l))}),X(Z[16],J([0,1,11,12]),function(I,r,N,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.getWordAtText=r.ensureValidWordDefinition=r.DEFAULT_WORD_REGEXP=r.USUAL_WORD_SEPARATORS=void 0,r.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(d=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const t of r.USUAL_WORD_SEPARATORS)d.indexOf(t)>=0||(S+="\\"+t);return S+="\\s]+)",new RegExp(S,"g")}r.DEFAULT_WORD_REGEXP=A();function l(d){let S=r.DEFAULT_WORD_REGEXP;if(d&&d instanceof RegExp)if(d.global)S=d;else{let t="g";d.ignoreCase&&(t+="i"),d.multiline&&(t+="m"),d.unicode&&(t+="u"),S=new RegExp(d.source,t)}return S.lastIndex=0,S}r.ensureValidWordDefinition=l;const L=new e.LinkedList;L.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function C(d,S,t,w,u){if(u||(u=N.Iterable.first(L)),t.length>u.maxLen){let h=d-u.maxLen/2;return h<0?h=0:w+=h,t=t.substring(h,d+u.maxLen/2),C(d,S,t,w,u)}const b=Date.now(),y=d-1-w;let g=-1,v=null;for(let h=1;!(Date.now()-b>=u.timeBudget);h++){const i=y-u.windowSize*h;S.lastIndex=Math.max(0,i);const a=c(S,t,y,g);if(!a&&v||(v=a,i<=0))break;g=i}if(v){const h={word:v[0],startColumn:w+1+v.index,endColumn:w+1+v.index+v[0].length};return S.lastIndex=0,h}return null}r.getWordAtText=C;function c(d,S,t,w){let u;for(;u=d.exec(S);){const b=u.index||0;if(b<=t&&d.lastIndex>=t)return u;if(w>0&&b>w)return null}return null}}),X(Z[31],J([0,1,13,2]),function(I,r,N,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.DiffComputer=void 0;const A=3;function l(y,g,v,h){return new N.LcsDiff(y,g,v).ComputeDiff(h)}class L{constructor(g){const v=[],h=[];for(let i=0,a=g.length;i<a;i++)v[i]=w(g[i],1),h[i]=u(g[i],1);this.lines=g,this._startColumns=v,this._endColumns=h}getElements(){const g=[];for(let v=0,h=this.lines.length;v<h;v++)g[v]=this.lines[v].substring(this._startColumns[v]-1,this._endColumns[v]-1);return g}getStrictElement(g){return this.lines[g]}getStartLineNumber(g){return g+1}getEndLineNumber(g){return g+1}createCharSequence(g,v,h){const i=[],a=[],m=[];let p=0;for(let o=v;o<=h;o++){const s=this.lines[o],f=g?this._startColumns[o]:1,_=g?this._endColumns[o]:s.length+1;for(let E=f;E<_;E++)i[p]=s.charCodeAt(E-1),a[p]=o+1,m[p]=E,p++;!g&&o<h&&(i[p]=10,a[p]=o+1,m[p]=s.length+1,p++)}return new C(i,a,m)}}class C{constructor(g,v,h){this._charCodes=g,this._lineNumbers=v,this._columns=h}toString(){return"["+this._charCodes.map((g,v)=>(g===10?"\\n":String.fromCharCode(g))+`-(${this._lineNumbers[v]},${this._columns[v]})`).join(", ")+"]"}_assertIndex(g,v){if(g<0||g>=v.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(g){return g>0&&g===this._lineNumbers.length?this.getEndLineNumber(g-1):(this._assertIndex(g,this._lineNumbers),this._lineNumbers[g])}getEndLineNumber(g){return g===-1?this.getStartLineNumber(g+1):(this._assertIndex(g,this._lineNumbers),this._charCodes[g]===10?this._lineNumbers[g]+1:this._lineNumbers[g])}getStartColumn(g){return g>0&&g===this._columns.length?this.getEndColumn(g-1):(this._assertIndex(g,this._columns),this._columns[g])}getEndColumn(g){return g===-1?this.getStartColumn(g+1):(this._assertIndex(g,this._columns),this._charCodes[g]===10?1:this._columns[g]+1)}}class c{constructor(g,v,h,i,a,m,p,o){this.originalStartLineNumber=g,this.originalStartColumn=v,this.originalEndLineNumber=h,this.originalEndColumn=i,this.modifiedStartLineNumber=a,this.modifiedStartColumn=m,this.modifiedEndLineNumber=p,this.modifiedEndColumn=o}static createFromDiffChange(g,v,h){const i=v.getStartLineNumber(g.originalStart),a=v.getStartColumn(g.originalStart),m=v.getEndLineNumber(g.originalStart+g.originalLength-1),p=v.getEndColumn(g.originalStart+g.originalLength-1),o=h.getStartLineNumber(g.modifiedStart),s=h.getStartColumn(g.modifiedStart),f=h.getEndLineNumber(g.modifiedStart+g.modifiedLength-1),_=h.getEndColumn(g.modifiedStart+g.modifiedLength-1);return new c(i,a,m,p,o,s,f,_)}}function d(y){if(y.length<=1)return y;const g=[y[0]];let v=g[0];for(let h=1,i=y.length;h<i;h++){const a=y[h],m=a.originalStart-(v.originalStart+v.originalLength),p=a.modifiedStart-(v.modifiedStart+v.modifiedLength);Math.min(m,p)<A?(v.originalLength=a.originalStart+a.originalLength-v.originalStart,v.modifiedLength=a.modifiedStart+a.modifiedLength-v.modifiedStart):(g.push(a),v=a)}return g}class S{constructor(g,v,h,i,a){this.originalStartLineNumber=g,this.originalEndLineNumber=v,this.modifiedStartLineNumber=h,this.modifiedEndLineNumber=i,this.charChanges=a}static createFromDiffResult(g,v,h,i,a,m,p){let o,s,f,_,E;if(v.originalLength===0?(o=h.getStartLineNumber(v.originalStart)-1,s=0):(o=h.getStartLineNumber(v.originalStart),s=h.getEndLineNumber(v.originalStart+v.originalLength-1)),v.modifiedLength===0?(f=i.getStartLineNumber(v.modifiedStart)-1,_=0):(f=i.getStartLineNumber(v.modifiedStart),_=i.getEndLineNumber(v.modifiedStart+v.modifiedLength-1)),m&&v.originalLength>0&&v.originalLength<20&&v.modifiedLength>0&&v.modifiedLength<20&&a()){const M=h.createCharSequence(g,v.originalStart,v.originalStart+v.originalLength-1),D=i.createCharSequence(g,v.modifiedStart,v.modifiedStart+v.modifiedLength-1);if(M.getElements().length>0&&D.getElements().length>0){let P=l(M,D,a,!0).changes;p&&(P=d(P)),E=[];for(let B=0,W=P.length;B<W;B++)E.push(c.createFromDiffChange(P[B],M,D))}}return new S(o,s,f,_,E)}}class t{constructor(g,v,h){this.shouldComputeCharChanges=h.shouldComputeCharChanges,this.shouldPostProcessCharChanges=h.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=h.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=h.shouldMakePrettyDiff,this.originalLines=g,this.modifiedLines=v,this.original=new L(g),this.modified=new L(v),this.continueLineDiff=b(h.maxComputationTime),this.continueCharDiff=b(h.maxComputationTime===0?0:Math.min(h.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const g=l(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),v=g.changes,h=g.quitEarly;if(this.shouldIgnoreTrimWhitespace){const p=[];for(let o=0,s=v.length;o<s;o++)p.push(S.createFromDiffResult(this.shouldIgnoreTrimWhitespace,v[o],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:h,changes:p}}const i=[];let a=0,m=0;for(let p=-1,o=v.length;p<o;p++){const s=p+1<o?v[p+1]:null,f=s?s.originalStart:this.originalLines.length,_=s?s.modifiedStart:this.modifiedLines.length;for(;a<f&&m<_;){const E=this.originalLines[a],M=this.modifiedLines[m];if(E!==M){{let D=w(E,1),P=w(M,1);for(;D>1&&P>1;){const B=E.charCodeAt(D-2),W=M.charCodeAt(P-2);if(B!==W)break;D--,P--}(D>1||P>1)&&this._pushTrimWhitespaceCharChange(i,a+1,1,D,m+1,1,P)}{let D=u(E,1),P=u(M,1);const B=E.length+1,W=M.length+1;for(;D<B&&P<W;){const $=E.charCodeAt(D-1),q=E.charCodeAt(P-1);if($!==q)break;D++,P++}(D<B||P<W)&&this._pushTrimWhitespaceCharChange(i,a+1,D,B,m+1,P,W)}}a++,m++}s&&(i.push(S.createFromDiffResult(this.shouldIgnoreTrimWhitespace,s,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),a+=s.originalLength,m+=s.modifiedLength)}return{quitEarly:h,changes:i}}_pushTrimWhitespaceCharChange(g,v,h,i,a,m,p){if(this._mergeTrimWhitespaceCharChange(g,v,h,i,a,m,p))return;let o;this.shouldComputeCharChanges&&(o=[new c(v,h,v,i,a,m,a,p)]),g.push(new S(v,v,a,a,o))}_mergeTrimWhitespaceCharChange(g,v,h,i,a,m,p){const o=g.length;if(o===0)return!1;const s=g[o-1];return s.originalEndLineNumber===0||s.modifiedEndLineNumber===0?!1:s.originalEndLineNumber+1===v&&s.modifiedEndLineNumber+1===a?(s.originalEndLineNumber=v,s.modifiedEndLineNumber=a,this.shouldComputeCharChanges&&s.charChanges&&s.charChanges.push(new c(v,h,v,i,a,m,a,p)),!0):!1}}r.DiffComputer=t;function w(y,g){const v=e.firstNonWhitespaceIndex(y);return v===-1?g:v+1}function u(y,g){const v=e.lastNonWhitespaceIndex(y);return v===-1?g:v+2}function b(y){if(y===0)return()=>!0;const g=Date.now();return()=>Date.now()-g<y}}),X(Z[32],J([0,1,15]),function(I,r,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.computeLinks=r.LinkComputer=r.StateMachine=r.Uint8Matrix=void 0;class e{constructor(w,u,b){const y=new Uint8Array(w*u);for(let g=0,v=w*u;g<v;g++)y[g]=b;this._data=y,this.rows=w,this.cols=u}get(w,u){return this._data[w*this.cols+u]}set(w,u,b){this._data[w*this.cols+u]=b}}r.Uint8Matrix=e;class A{constructor(w){let u=0,b=0;for(let g=0,v=w.length;g<v;g++){const[h,i,a]=w[g];i>u&&(u=i),h>b&&(b=h),a>b&&(b=a)}u++,b++;const y=new e(b,u,0);for(let g=0,v=w.length;g<v;g++){const[h,i,a]=w[g];y.set(h,i,a)}this._states=y,this._maxCharCode=u}nextState(w,u){return u<0||u>=this._maxCharCode?0:this._states.get(w,u)}}r.StateMachine=A;let l=null;function L(){return l===null&&(l=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),l}let C=null;function c(){if(C===null){C=new N.CharacterClassifier(0);const t=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<t.length;u++)C.set(t.charCodeAt(u),1);const w=".,;:";for(let u=0;u<w.length;u++)C.set(w.charCodeAt(u),2)}return C}class d{static _createLink(w,u,b,y,g){let v=g-1;do{const h=u.charCodeAt(v);if(w.get(h)!==2)break;v--}while(v>y);if(y>0){const h=u.charCodeAt(y-1),i=u.charCodeAt(v);(h===40&&i===41||h===91&&i===93||h===123&&i===125)&&v--}return{range:{startLineNumber:b,startColumn:y+1,endLineNumber:b,endColumn:v+2},url:u.substring(y,v+1)}}static computeLinks(w,u=L()){const b=c(),y=[];for(let g=1,v=w.getLineCount();g<=v;g++){const h=w.getLineContent(g),i=h.length;let a=0,m=0,p=0,o=1,s=!1,f=!1,_=!1,E=!1;for(;a<i;){let M=!1;const D=h.charCodeAt(a);if(o===13){let P;switch(D){case 40:s=!0,P=0;break;case 41:P=s?0:1;break;case 91:_=!0,f=!0,P=0;break;case 93:_=!1,P=f?0:1;break;case 123:E=!0,P=0;break;case 125:P=E?0:1;break;case 39:P=p===39?1:0;break;case 34:P=p===34?1:0;break;case 96:P=p===96?1:0;break;case 42:P=p===42?1:0;break;case 124:P=p===124?1:0;break;case 32:P=_?0:1;break;default:P=b.get(D)}P===1&&(y.push(d._createLink(b,h,g,m,a)),M=!0)}else if(o===12){let P;D===91?(f=!0,P=0):P=b.get(D),P===1?M=!0:o=13}else o=u.nextState(o,D),o===0&&(M=!0);M&&(o=1,s=!1,f=!1,E=!1,m=a+1,p=D),a++}o===13&&y.push(d._createLink(b,h,g,m,i))}return y}}r.LinkComputer=d;function S(t){return!t||typeof t.getLineCount!="function"||typeof t.getLineContent!="function"?[]:d.computeLinks(t)}r.computeLinks=S}),X(Z[33],J([0,1]),function(I,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.BasicInplaceReplace=void 0;class N{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(A,l,L,C,c){if(A&&l){const d=this.doNavigateValueSet(l,c);if(d)return{range:A,value:d}}if(L&&C){const d=this.doNavigateValueSet(C,c);if(d)return{range:L,value:d}}return null}doNavigateValueSet(A,l){const L=this.numberReplace(A,l);return L!==null?L:this.textReplace(A,l)}numberReplace(A,l){const L=Math.pow(10,A.length-(A.lastIndexOf(".")+1));let C=Number(A);const c=parseFloat(A);return!isNaN(C)&&!isNaN(c)&&C===c?C===0&&!l?null:(C=Math.floor(C*L),C+=l?L:-L,String(C/L)):null}textReplace(A,l){return this.valueSetsReplace(this._defaultValueSet,A,l)}valueSetsReplace(A,l,L){let C=null;for(let c=0,d=A.length;C===null&&c<d;c++)C=this.valueSetReplace(A[c],l,L);return C}valueSetReplace(A,l,L){let C=A.indexOf(l);return C>=0?(C+=L?1:-1,C<0?C=A.length-1:C%=A.length,A[C]):null}}r.BasicInplaceReplace=N,N.INSTANCE=new N}),X(Z[34],J([0,1,8]),function(I,r,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.shouldSynchronizeModel=r.ApplyEditsResult=r.SearchData=r.ValidAnnotatedEditOperation=r.isITextSnapshot=r.FindMatch=r.TextModelResolvedOptions=r.InjectedTextCursorStops=r.MinimapPosition=r.OverviewRulerLane=void 0;var e;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=4]="Right",u[u.Full=7]="Full"})(e=r.OverviewRulerLane||(r.OverviewRulerLane={}));var A;(function(u){u[u.Inline=1]="Inline",u[u.Gutter=2]="Gutter"})(A=r.MinimapPosition||(r.MinimapPosition={}));var l;(function(u){u[u.Both=0]="Both",u[u.Right=1]="Right",u[u.Left=2]="Left",u[u.None=3]="None"})(l=r.InjectedTextCursorStops||(r.InjectedTextCursorStops={}));class L{constructor(b){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,b.tabSize|0),this.indentSize=b.tabSize|0,this.insertSpaces=Boolean(b.insertSpaces),this.defaultEOL=b.defaultEOL|0,this.trimAutoWhitespace=Boolean(b.trimAutoWhitespace),this.bracketPairColorizationOptions=b.bracketPairColorizationOptions}equals(b){return this.tabSize===b.tabSize&&this.indentSize===b.indentSize&&this.insertSpaces===b.insertSpaces&&this.defaultEOL===b.defaultEOL&&this.trimAutoWhitespace===b.trimAutoWhitespace&&(0,N.equals)(this.bracketPairColorizationOptions,b.bracketPairColorizationOptions)}createChangeEvent(b){return{tabSize:this.tabSize!==b.tabSize,indentSize:this.indentSize!==b.indentSize,insertSpaces:this.insertSpaces!==b.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==b.trimAutoWhitespace}}}r.TextModelResolvedOptions=L;class C{constructor(b,y){this._findMatchBrand=void 0,this.range=b,this.matches=y}}r.FindMatch=C;function c(u){return u&&typeof u.read=="function"}r.isITextSnapshot=c;class d{constructor(b,y,g,v,h,i){this.identifier=b,this.range=y,this.text=g,this.forceMoveMarkers=v,this.isAutoWhitespaceEdit=h,this._isTracked=i}}r.ValidAnnotatedEditOperation=d;class S{constructor(b,y,g){this.regex=b,this.wordSeparators=y,this.simpleSearch=g}}r.SearchData=S;class t{constructor(b,y,g){this.reverseEdits=b,this.changes=y,this.trimAutoWhitespaceLineNumbers=g}}r.ApplyEditsResult=t;function w(u){return!u.isTooLargeForSyncing()&&!u.isForSimpleWidget}r.shouldSynchronizeModel=w}),X(Z[35],J([0,1,19,14]),function(I,r,N,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.PrefixSumIndexOfResult=r.ConstantTimePrefixSumComputer=r.PrefixSumComputer=void 0;class A{constructor(c){this.values=c,this.prefixSum=new Uint32Array(c.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(c,d){c=(0,e.toUint32)(c);const S=this.values,t=this.prefixSum,w=d.length;return w===0?!1:(this.values=new Uint32Array(S.length+w),this.values.set(S.subarray(0,c),0),this.values.set(S.subarray(c),c+w),this.values.set(d,c),c-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=c-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(t.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(c,d){return c=(0,e.toUint32)(c),d=(0,e.toUint32)(d),this.values[c]===d?!1:(this.values[c]=d,c-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=c-1),!0)}removeValues(c,d){c=(0,e.toUint32)(c),d=(0,e.toUint32)(d);const S=this.values,t=this.prefixSum;if(c>=S.length)return!1;const w=S.length-c;return d>=w&&(d=w),d===0?!1:(this.values=new Uint32Array(S.length-d),this.values.set(S.subarray(0,c),0),this.values.set(S.subarray(c+d),c),this.prefixSum=new Uint32Array(this.values.length),c-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=c-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(t.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(c){return c<0?0:(c=(0,e.toUint32)(c),this._getPrefixSum(c))}_getPrefixSum(c){if(c<=this.prefixSumValidIndex[0])return this.prefixSum[c];let d=this.prefixSumValidIndex[0]+1;d===0&&(this.prefixSum[0]=this.values[0],d++),c>=this.values.length&&(c=this.values.length-1);for(let S=d;S<=c;S++)this.prefixSum[S]=this.prefixSum[S-1]+this.values[S];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],c),this.prefixSum[c]}getIndexOf(c){c=Math.floor(c),this.getTotalSum();let d=0,S=this.values.length-1,t=0,w=0,u=0;for(;d<=S;)if(t=d+(S-d)/2|0,w=this.prefixSum[t],u=w-this.values[t],c<u)S=t-1;else if(c>=w)d=t+1;else break;return new L(t,c-u)}}r.PrefixSumComputer=A;class l{constructor(c){this._values=c,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(c){return this._ensureValid(),c===0?0:this._prefixSum[c-1]}getIndexOf(c){this._ensureValid();const d=this._indexBySum[c],S=d>0?this._prefixSum[d-1]:0;return new L(d,c-S)}removeValues(c,d){this._values.splice(c,d),this._invalidate(c)}insertValues(c,d){this._values=(0,N.arrayInsert)(this._values,c,d),this._invalidate(c)}_invalidate(c){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,c-1)}_ensureValid(){if(!this._isValid){for(let c=this._validEndIndex+1,d=this._values.length;c<d;c++){const S=this._values[c],t=c>0?this._prefixSum[c-1]:0;this._prefixSum[c]=t+S;for(let w=0;w<S;w++)this._indexBySum[t+w]=c}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(c,d){this._values[c]!==d&&(this._values[c]=d,this._invalidate(c))}}r.ConstantTimePrefixSumComputer=l;class L{constructor(c,d){this.index=c,this.remainder=d,this._prefixSumIndexOfResultBrand=void 0,this.index=c,this.remainder=d}}r.PrefixSumIndexOfResult=L}),X(Z[36],J([0,1,2,3,35]),function(I,r,N,e,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.MirrorTextModel=void 0;class l{constructor(C,c,d,S){this._uri=C,this._lines=c,this._eol=d,this._versionId=S,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const c=C.changes;for(const d of c)this._acceptDeleteRange(d.range),this._acceptInsertText(new e.Position(d.range.startLineNumber,d.range.startColumn),d.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,c=this._lines.length,d=new Uint32Array(c);for(let S=0;S<c;S++)d[S]=this._lines[S].length+C;this._lineStarts=new A.PrefixSumComputer(d)}}_setLineText(C,c){this._lines[C]=c,this._lineStarts&&this._lineStarts.setValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,c){if(c.length===0)return;const d=(0,N.splitLines)(c);if(d.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+d[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}d[d.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+d[0]);const S=new Uint32Array(d.length-1);for(let t=1;t<d.length;t++)this._lines.splice(C.lineNumber+t-1,0,d[t]),S[t-1]=d[t].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,S)}}r.MirrorTextModel=l}),X(Z[37],J([0,1,2,30,3,4,34]),function(I,r,N,e,A,l,L){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Searcher=r.isValidMatch=r.TextModelSearch=r.createFindMatch=r.isMultilineRegexSource=r.SearchParams=void 0;const C=999;class c{constructor(h,i,a,m){this.searchString=h,this.isRegex=i,this.matchCase=a,this.wordSeparators=m}parseSearchRequest(){if(this.searchString==="")return null;let h;this.isRegex?h=d(this.searchString):h=this.searchString.indexOf(`
`)>=0;let i=null;try{i=N.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:h,global:!0,unicode:!0})}catch{return null}if(!i)return null;let a=!this.isRegex&&!h;return a&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(a=this.matchCase),new L.SearchData(i,this.wordSeparators?(0,e.getMapForWordSeparators)(this.wordSeparators):null,a?this.searchString:null)}}r.SearchParams=c;function d(v){if(!v||v.length===0)return!1;for(let h=0,i=v.length;h<i;h++){const a=v.charCodeAt(h);if(a===10)return!0;if(a===92){if(h++,h>=i)break;const m=v.charCodeAt(h);if(m===110||m===114||m===87)return!0}}return!1}r.isMultilineRegexSource=d;function S(v,h,i){if(!i)return new L.FindMatch(v,null);const a=[];for(let m=0,p=h.length;m<p;m++)a[m]=h[m];return new L.FindMatch(v,a)}r.createFindMatch=S;class t{constructor(h){const i=[];let a=0;for(let m=0,p=h.length;m<p;m++)h.charCodeAt(m)===10&&(i[a++]=m);this._lineFeedsOffsets=i}findLineFeedCountBeforeOffset(h){const i=this._lineFeedsOffsets;let a=0,m=i.length-1;if(m===-1||h<=i[0])return 0;for(;a<m;){const p=a+((m-a)/2>>0);i[p]>=h?m=p-1:i[p+1]>=h?(a=p,m=p):a=p+1}return a+1}}class w{static findMatches(h,i,a,m,p){const o=i.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(h,a,new g(o.wordSeparators,o.regex),m,p):this._doFindMatchesLineByLine(h,a,o,m,p):[]}static _getMultilineMatchRange(h,i,a,m,p,o){let s,f=0;m?(f=m.findLineFeedCountBeforeOffset(p),s=i+p+f):s=i+p;let _;if(m){const P=m.findLineFeedCountBeforeOffset(p+o.length)-f;_=s+o.length+P}else _=s+o.length;const E=h.getPositionAt(s),M=h.getPositionAt(_);return new l.Range(E.lineNumber,E.column,M.lineNumber,M.column)}static _doFindMatchesMultiline(h,i,a,m,p){const o=h.getOffsetAt(i.getStartPosition()),s=h.getValueInRange(i,1),f=h.getEOL()===`\r
`?new t(s):null,_=[];let E=0,M;for(a.reset(0);M=a.next(s);)if(_[E++]=S(this._getMultilineMatchRange(h,o,s,f,M.index,M[0]),M,m),E>=p)return _;return _}static _doFindMatchesLineByLine(h,i,a,m,p){const o=[];let s=0;if(i.startLineNumber===i.endLineNumber){const _=h.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return s=this._findMatchesInLine(a,_,i.startLineNumber,i.startColumn-1,s,o,m,p),o}const f=h.getLineContent(i.startLineNumber).substring(i.startColumn-1);s=this._findMatchesInLine(a,f,i.startLineNumber,i.startColumn-1,s,o,m,p);for(let _=i.startLineNumber+1;_<i.endLineNumber&&s<p;_++)s=this._findMatchesInLine(a,h.getLineContent(_),_,0,s,o,m,p);if(s<p){const _=h.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);s=this._findMatchesInLine(a,_,i.endLineNumber,0,s,o,m,p)}return o}static _findMatchesInLine(h,i,a,m,p,o,s,f){const _=h.wordSeparators;if(!s&&h.simpleSearch){const D=h.simpleSearch,P=D.length,B=i.length;let W=-P;for(;(W=i.indexOf(D,W+P))!==-1;)if((!_||y(_,i,B,W,P))&&(o[p++]=new L.FindMatch(new l.Range(a,W+1+m,a,W+1+P+m),null),p>=f))return p;return p}const E=new g(h.wordSeparators,h.regex);let M;E.reset(0);do if(M=E.next(i),M&&(o[p++]=S(new l.Range(a,M.index+1+m,a,M.index+1+M[0].length+m),M,s),p>=f))return p;while(M);return p}static findNextMatch(h,i,a,m){const p=i.parseSearchRequest();if(!p)return null;const o=new g(p.wordSeparators,p.regex);return p.regex.multiline?this._doFindNextMatchMultiline(h,a,o,m):this._doFindNextMatchLineByLine(h,a,o,m)}static _doFindNextMatchMultiline(h,i,a,m){const p=new A.Position(i.lineNumber,1),o=h.getOffsetAt(p),s=h.getLineCount(),f=h.getValueInRange(new l.Range(p.lineNumber,p.column,s,h.getLineMaxColumn(s)),1),_=h.getEOL()===`\r
`?new t(f):null;a.reset(i.column-1);const E=a.next(f);return E?S(this._getMultilineMatchRange(h,o,f,_,E.index,E[0]),E,m):i.lineNumber!==1||i.column!==1?this._doFindNextMatchMultiline(h,new A.Position(1,1),a,m):null}static _doFindNextMatchLineByLine(h,i,a,m){const p=h.getLineCount(),o=i.lineNumber,s=h.getLineContent(o),f=this._findFirstMatchInLine(a,s,o,i.column,m);if(f)return f;for(let _=1;_<=p;_++){const E=(o+_-1)%p,M=h.getLineContent(E+1),D=this._findFirstMatchInLine(a,M,E+1,1,m);if(D)return D}return null}static _findFirstMatchInLine(h,i,a,m,p){h.reset(m-1);const o=h.next(i);return o?S(new l.Range(a,o.index+1,a,o.index+1+o[0].length),o,p):null}static findPreviousMatch(h,i,a,m){const p=i.parseSearchRequest();if(!p)return null;const o=new g(p.wordSeparators,p.regex);return p.regex.multiline?this._doFindPreviousMatchMultiline(h,a,o,m):this._doFindPreviousMatchLineByLine(h,a,o,m)}static _doFindPreviousMatchMultiline(h,i,a,m){const p=this._doFindMatchesMultiline(h,new l.Range(1,1,i.lineNumber,i.column),a,m,10*C);if(p.length>0)return p[p.length-1];const o=h.getLineCount();return i.lineNumber!==o||i.column!==h.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(h,new A.Position(o,h.getLineMaxColumn(o)),a,m):null}static _doFindPreviousMatchLineByLine(h,i,a,m){const p=h.getLineCount(),o=i.lineNumber,s=h.getLineContent(o).substring(0,i.column-1),f=this._findLastMatchInLine(a,s,o,m);if(f)return f;for(let _=1;_<=p;_++){const E=(p+o-_-1)%p,M=h.getLineContent(E+1),D=this._findLastMatchInLine(a,M,E+1,m);if(D)return D}return null}static _findLastMatchInLine(h,i,a,m){let p=null,o;for(h.reset(0);o=h.next(i);)p=S(new l.Range(a,o.index+1,a,o.index+1+o[0].length),o,m);return p}}r.TextModelSearch=w;function u(v,h,i,a,m){if(a===0)return!0;const p=h.charCodeAt(a-1);if(v.get(p)!==0||p===13||p===10)return!0;if(m>0){const o=h.charCodeAt(a);if(v.get(o)!==0)return!0}return!1}function b(v,h,i,a,m){if(a+m===i)return!0;const p=h.charCodeAt(a+m);if(v.get(p)!==0||p===13||p===10)return!0;if(m>0){const o=h.charCodeAt(a+m-1);if(v.get(o)!==0)return!0}return!1}function y(v,h,i,a,m){return u(v,h,i,a,m)&&b(v,h,i,a,m)}r.isValidMatch=y;class g{constructor(h,i){this._wordSeparators=h,this._searchRegex=i,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(h){this._searchRegex.lastIndex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(h){const i=h.length;let a;do{if(this._prevMatchStartIndex+this._prevMatchLength===i||(a=this._searchRegex.exec(h),!a))return null;const m=a.index,p=a[0].length;if(m===this._prevMatchStartIndex&&p===this._prevMatchLength){if(p===0){N.getNextCodePoint(h,i,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=m,this._prevMatchLength=p,!this._wordSeparators||y(this._wordSeparators,h,i,m,p))return a}while(a);return null}}r.Searcher=g}),X(Z[38],J([0,1,4,37,2,20,16]),function(I,r,N,e,A,l,L){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.UnicodeTextModelHighlighter=void 0;class C{static computeUnicodeHighlights(w,u,b){const y=b?b.startLineNumber:1,g=b?b.endLineNumber:w.getLineCount(),v=new d(u),h=v.getCandidateCodePoints();let i;h==="allNonBasicAscii"?i=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):i=new RegExp(`${c(Array.from(h))}`,"g");const a=new e.Searcher(null,i),m=[];let p=!1,o,s=0,f=0,_=0;e:for(let E=y,M=g;E<=M;E++){const D=w.getLineContent(E),P=D.length;a.reset(0);do if(o=a.next(D),o){let B=o.index,W=o.index+o[0].length;if(B>0){const U=D.charCodeAt(B-1);A.isHighSurrogate(U)&&B--}if(W+1<P){const U=D.charCodeAt(W-1);A.isHighSurrogate(U)&&W++}const $=D.substring(B,W),q=(0,L.getWordAtText)(B+1,L.DEFAULT_WORD_REGEXP,D,0),k=v.shouldHighlightNonBasicASCII($,q?q.word:null);if(k!==0){k===3?s++:k===2?f++:k===1?_++:(0,l.assertNever)(k);const U=1e3;if(m.length>=U){p=!0;break e}m.push(new N.Range(E,B+1,E,W+1))}}while(o)}return{ranges:m,hasMore:p,ambiguousCharacterCount:s,invisibleCharacterCount:f,nonBasicAsciiCharacterCount:_}}static computeUnicodeHighlightReason(w,u){const b=new d(u);switch(b.shouldHighlightNonBasicASCII(w,null)){case 0:return null;case 2:return{kind:1};case 3:{const g=w.codePointAt(0),v=b.ambiguousCharacters.getPrimaryConfusable(g),h=A.AmbiguousCharacters.getLocales().filter(i=>!A.AmbiguousCharacters.getInstance(new Set([...u.allowedLocales,i])).isAmbiguous(g));return{kind:0,confusableWith:String.fromCodePoint(v),notAmbiguousInLocales:h}}case 1:return{kind:2}}}}r.UnicodeTextModelHighlighter=C;function c(t,w){return`[${A.escapeRegExpCharacters(t.map(b=>String.fromCodePoint(b)).join(""))}]`}class d{constructor(w){this.options=w,this.allowedCodePoints=new Set(w.allowedCodePoints),this.ambiguousCharacters=A.AmbiguousCharacters.getInstance(new Set(w.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const w=new Set;if(this.options.invisibleCharacters)for(const u of A.InvisibleCharacters.codePoints)S(String.fromCodePoint(u))||w.add(u);if(this.options.ambiguousCharacters)for(const u of this.ambiguousCharacters.getConfusableCodePoints())w.add(u);for(const u of this.allowedCodePoints)w.delete(u);return w}shouldHighlightNonBasicASCII(w,u){const b=w.codePointAt(0);if(this.allowedCodePoints.has(b))return 0;if(this.options.nonBasicASCII)return 1;let y=!1,g=!1;if(u)for(const v of u){const h=v.codePointAt(0),i=A.isBasicASCII(v);y=y||i,!i&&!this.ambiguousCharacters.isAmbiguous(h)&&!A.InvisibleCharacters.isInvisibleCharacter(h)&&(g=!0)}return!y&&g?0:this.options.invisibleCharacters&&!S(w)&&A.InvisibleCharacters.isInvisibleCharacter(b)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(b)?3:0}}function S(t){return t===" "||t===`
`||t==="	"}}),X(Z[39],J([0,1]),function(I,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.WrappingIndent=r.TrackedRangeStickiness=r.TextEditorCursorStyle=r.TextEditorCursorBlinkingStyle=r.SymbolTag=r.SymbolKind=r.SignatureHelpTriggerKind=r.SelectionDirection=r.ScrollbarVisibility=r.ScrollType=r.RenderMinimap=r.RenderLineNumbersType=r.PositionAffinity=r.OverviewRulerLane=r.OverlayWidgetPositionPreference=r.MouseTargetType=r.MinimapPosition=r.MarkerTag=r.MarkerSeverity=r.KeyCode=r.InlineCompletionTriggerKind=r.InlayHintKind=r.InjectedTextCursorStops=r.IndentAction=r.EndOfLineSequence=r.EndOfLinePreference=r.EditorOption=r.EditorAutoIndentStrategy=r.DocumentHighlightKind=r.DefaultEndOfLine=r.CursorChangeReason=r.ContentWidgetPositionPreference=r.CompletionTriggerKind=r.CompletionItemTag=r.CompletionItemKind=r.CompletionItemInsertTextRule=r.CodeActionTriggerType=r.AccessibilitySupport=void 0;var N;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(N=r.AccessibilitySupport||(r.AccessibilitySupport={}));var e;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(e=r.CodeActionTriggerType||(r.CodeActionTriggerType={}));var A;(function(n){n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(A=r.CompletionItemInsertTextRule||(r.CompletionItemInsertTextRule={}));var l;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(l=r.CompletionItemKind||(r.CompletionItemKind={}));var L;(function(n){n[n.Deprecated=1]="Deprecated"})(L=r.CompletionItemTag||(r.CompletionItemTag={}));var C;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(C=r.CompletionTriggerKind||(r.CompletionTriggerKind={}));var c;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(c=r.ContentWidgetPositionPreference||(r.ContentWidgetPositionPreference={}));var d;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(d=r.CursorChangeReason||(r.CursorChangeReason={}));var S;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(S=r.DefaultEndOfLine||(r.DefaultEndOfLine={}));var t;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(t=r.DocumentHighlightKind||(r.DocumentHighlightKind={}));var w;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(w=r.EditorAutoIndentStrategy||(r.EditorAutoIndentStrategy={}));var u;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.autoClosingBrackets=5]="autoClosingBrackets",n[n.autoClosingDelete=6]="autoClosingDelete",n[n.autoClosingOvertype=7]="autoClosingOvertype",n[n.autoClosingQuotes=8]="autoClosingQuotes",n[n.autoIndent=9]="autoIndent",n[n.automaticLayout=10]="automaticLayout",n[n.autoSurround=11]="autoSurround",n[n.bracketPairColorization=12]="bracketPairColorization",n[n.guides=13]="guides",n[n.codeLens=14]="codeLens",n[n.codeLensFontFamily=15]="codeLensFontFamily",n[n.codeLensFontSize=16]="codeLensFontSize",n[n.colorDecorators=17]="colorDecorators",n[n.columnSelection=18]="columnSelection",n[n.comments=19]="comments",n[n.contextmenu=20]="contextmenu",n[n.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",n[n.cursorBlinking=22]="cursorBlinking",n[n.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",n[n.cursorStyle=24]="cursorStyle",n[n.cursorSurroundingLines=25]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",n[n.cursorWidth=27]="cursorWidth",n[n.disableLayerHinting=28]="disableLayerHinting",n[n.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",n[n.domReadOnly=30]="domReadOnly",n[n.dragAndDrop=31]="dragAndDrop",n[n.dropIntoEditor=32]="dropIntoEditor",n[n.emptySelectionClipboard=33]="emptySelectionClipboard",n[n.experimental=34]="experimental",n[n.extraEditorClassName=35]="extraEditorClassName",n[n.fastScrollSensitivity=36]="fastScrollSensitivity",n[n.find=37]="find",n[n.fixedOverflowWidgets=38]="fixedOverflowWidgets",n[n.folding=39]="folding",n[n.foldingStrategy=40]="foldingStrategy",n[n.foldingHighlight=41]="foldingHighlight",n[n.foldingImportsByDefault=42]="foldingImportsByDefault",n[n.foldingMaximumRegions=43]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=44]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=45]="fontFamily",n[n.fontInfo=46]="fontInfo",n[n.fontLigatures=47]="fontLigatures",n[n.fontSize=48]="fontSize",n[n.fontWeight=49]="fontWeight",n[n.formatOnPaste=50]="formatOnPaste",n[n.formatOnType=51]="formatOnType",n[n.glyphMargin=52]="glyphMargin",n[n.gotoLocation=53]="gotoLocation",n[n.hideCursorInOverviewRuler=54]="hideCursorInOverviewRuler",n[n.hover=55]="hover",n[n.inDiffEditor=56]="inDiffEditor",n[n.inlineSuggest=57]="inlineSuggest",n[n.letterSpacing=58]="letterSpacing",n[n.lightbulb=59]="lightbulb",n[n.lineDecorationsWidth=60]="lineDecorationsWidth",n[n.lineHeight=61]="lineHeight",n[n.lineNumbers=62]="lineNumbers",n[n.lineNumbersMinChars=63]="lineNumbersMinChars",n[n.linkedEditing=64]="linkedEditing",n[n.links=65]="links",n[n.matchBrackets=66]="matchBrackets",n[n.minimap=67]="minimap",n[n.mouseStyle=68]="mouseStyle",n[n.mouseWheelScrollSensitivity=69]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=70]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=71]="multiCursorMergeOverlapping",n[n.multiCursorModifier=72]="multiCursorModifier",n[n.multiCursorPaste=73]="multiCursorPaste",n[n.occurrencesHighlight=74]="occurrencesHighlight",n[n.overviewRulerBorder=75]="overviewRulerBorder",n[n.overviewRulerLanes=76]="overviewRulerLanes",n[n.padding=77]="padding",n[n.parameterHints=78]="parameterHints",n[n.peekWidgetDefaultFocus=79]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=80]="definitionLinkOpensInPeek",n[n.quickSuggestions=81]="quickSuggestions",n[n.quickSuggestionsDelay=82]="quickSuggestionsDelay",n[n.readOnly=83]="readOnly",n[n.renameOnType=84]="renameOnType",n[n.renderControlCharacters=85]="renderControlCharacters",n[n.renderFinalNewline=86]="renderFinalNewline",n[n.renderLineHighlight=87]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=88]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=89]="renderValidationDecorations",n[n.renderWhitespace=90]="renderWhitespace",n[n.revealHorizontalRightPadding=91]="revealHorizontalRightPadding",n[n.roundedSelection=92]="roundedSelection",n[n.rulers=93]="rulers",n[n.scrollbar=94]="scrollbar",n[n.scrollBeyondLastColumn=95]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=96]="scrollBeyondLastLine",n[n.scrollPredominantAxis=97]="scrollPredominantAxis",n[n.selectionClipboard=98]="selectionClipboard",n[n.selectionHighlight=99]="selectionHighlight",n[n.selectOnLineNumbers=100]="selectOnLineNumbers",n[n.showFoldingControls=101]="showFoldingControls",n[n.showUnused=102]="showUnused",n[n.snippetSuggestions=103]="snippetSuggestions",n[n.smartSelect=104]="smartSelect",n[n.smoothScrolling=105]="smoothScrolling",n[n.stickyTabStops=106]="stickyTabStops",n[n.stopRenderingLineAfter=107]="stopRenderingLineAfter",n[n.suggest=108]="suggest",n[n.suggestFontSize=109]="suggestFontSize",n[n.suggestLineHeight=110]="suggestLineHeight",n[n.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",n[n.suggestSelection=112]="suggestSelection",n[n.tabCompletion=113]="tabCompletion",n[n.tabIndex=114]="tabIndex",n[n.unicodeHighlighting=115]="unicodeHighlighting",n[n.unusualLineTerminators=116]="unusualLineTerminators",n[n.useShadowDOM=117]="useShadowDOM",n[n.useTabStops=118]="useTabStops",n[n.wordSeparators=119]="wordSeparators",n[n.wordWrap=120]="wordWrap",n[n.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=123]="wordWrapColumn",n[n.wordWrapOverride1=124]="wordWrapOverride1",n[n.wordWrapOverride2=125]="wordWrapOverride2",n[n.wrappingIndent=126]="wrappingIndent",n[n.wrappingStrategy=127]="wrappingStrategy",n[n.showDeprecated=128]="showDeprecated",n[n.inlayHints=129]="inlayHints",n[n.editorClassName=130]="editorClassName",n[n.pixelRatio=131]="pixelRatio",n[n.tabFocusMode=132]="tabFocusMode",n[n.layoutInfo=133]="layoutInfo",n[n.wrappingInfo=134]="wrappingInfo"})(u=r.EditorOption||(r.EditorOption={}));var b;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(b=r.EndOfLinePreference||(r.EndOfLinePreference={}));var y;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(y=r.EndOfLineSequence||(r.EndOfLineSequence={}));var g;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(g=r.IndentAction||(r.IndentAction={}));var v;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(v=r.InjectedTextCursorStops||(r.InjectedTextCursorStops={}));var h;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(h=r.InlayHintKind||(r.InlayHintKind={}));var i;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(i=r.InlineCompletionTriggerKind||(r.InlineCompletionTriggerKind={}));var a;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.NumLock=78]="NumLock",n[n.ScrollLock=79]="ScrollLock",n[n.Semicolon=80]="Semicolon",n[n.Equal=81]="Equal",n[n.Comma=82]="Comma",n[n.Minus=83]="Minus",n[n.Period=84]="Period",n[n.Slash=85]="Slash",n[n.Backquote=86]="Backquote",n[n.BracketLeft=87]="BracketLeft",n[n.Backslash=88]="Backslash",n[n.BracketRight=89]="BracketRight",n[n.Quote=90]="Quote",n[n.OEM_8=91]="OEM_8",n[n.IntlBackslash=92]="IntlBackslash",n[n.Numpad0=93]="Numpad0",n[n.Numpad1=94]="Numpad1",n[n.Numpad2=95]="Numpad2",n[n.Numpad3=96]="Numpad3",n[n.Numpad4=97]="Numpad4",n[n.Numpad5=98]="Numpad5",n[n.Numpad6=99]="Numpad6",n[n.Numpad7=100]="Numpad7",n[n.Numpad8=101]="Numpad8",n[n.Numpad9=102]="Numpad9",n[n.NumpadMultiply=103]="NumpadMultiply",n[n.NumpadAdd=104]="NumpadAdd",n[n.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=106]="NumpadSubtract",n[n.NumpadDecimal=107]="NumpadDecimal",n[n.NumpadDivide=108]="NumpadDivide",n[n.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",n[n.ABNT_C1=110]="ABNT_C1",n[n.ABNT_C2=111]="ABNT_C2",n[n.AudioVolumeMute=112]="AudioVolumeMute",n[n.AudioVolumeUp=113]="AudioVolumeUp",n[n.AudioVolumeDown=114]="AudioVolumeDown",n[n.BrowserSearch=115]="BrowserSearch",n[n.BrowserHome=116]="BrowserHome",n[n.BrowserBack=117]="BrowserBack",n[n.BrowserForward=118]="BrowserForward",n[n.MediaTrackNext=119]="MediaTrackNext",n[n.MediaTrackPrevious=120]="MediaTrackPrevious",n[n.MediaStop=121]="MediaStop",n[n.MediaPlayPause=122]="MediaPlayPause",n[n.LaunchMediaPlayer=123]="LaunchMediaPlayer",n[n.LaunchMail=124]="LaunchMail",n[n.LaunchApp2=125]="LaunchApp2",n[n.Clear=126]="Clear",n[n.MAX_VALUE=127]="MAX_VALUE"})(a=r.KeyCode||(r.KeyCode={}));var m;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(m=r.MarkerSeverity||(r.MarkerSeverity={}));var p;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(p=r.MarkerTag||(r.MarkerTag={}));var o;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(o=r.MinimapPosition||(r.MinimapPosition={}));var s;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(s=r.MouseTargetType||(r.MouseTargetType={}));var f;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(f=r.OverlayWidgetPositionPreference||(r.OverlayWidgetPositionPreference={}));var _;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(_=r.OverviewRulerLane||(r.OverviewRulerLane={}));var E;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(E=r.PositionAffinity||(r.PositionAffinity={}));var M;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(M=r.RenderLineNumbersType||(r.RenderLineNumbersType={}));var D;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(D=r.RenderMinimap||(r.RenderMinimap={}));var P;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(P=r.ScrollType||(r.ScrollType={}));var B;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(B=r.ScrollbarVisibility||(r.ScrollbarVisibility={}));var W;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(W=r.SelectionDirection||(r.SelectionDirection={}));var $;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})($=r.SignatureHelpTriggerKind||(r.SignatureHelpTriggerKind={}));var q;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(q=r.SymbolKind||(r.SymbolKind={}));var k;(function(n){n[n.Deprecated=1]="Deprecated"})(k=r.SymbolTag||(r.SymbolTag={}));var U;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(U=r.TextEditorCursorBlinkingStyle||(r.TextEditorCursorBlinkingStyle={}));var T;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(T=r.TextEditorCursorStyle||(r.TextEditorCursorStyle={}));var O;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(O=r.TrackedRangeStickiness||(r.TrackedRangeStickiness={}));var z;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(z=r.WrappingIndent||(r.WrappingIndent={}))}),X(Z[40],J([18,47]),function(I,r){return I.create("vs/base/common/platform",r)}),X(Z[5],J([0,1,40]),function(I,r,N){"use strict";var e;Object.defineProperty(r,"__esModule",{value:!0}),r.isAndroid=r.isEdge=r.isSafari=r.isFirefox=r.isChrome=r.isLittleEndian=r.OS=r.setTimeout0=r.setTimeout0IsFaster=r.language=r.userAgent=r.isIOS=r.isWebWorker=r.isWeb=r.isNative=r.isLinux=r.isMacintosh=r.isWindows=r.globals=void 0;const A="en";let l=!1,L=!1,C=!1,c=!1,d=!1,S=!1,t=!1,w=!1,u=!1,b,y=A,g,v;r.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof r.globals.vscode!="undefined"&&typeof r.globals.vscode.process!="undefined"?h=r.globals.vscode.process:typeof process!="undefined"&&(h=process);const i=typeof((e=h==null?void 0:h.versions)===null||e===void 0?void 0:e.electron)=="string",a=i&&(h==null?void 0:h.type)==="renderer";if(typeof navigator=="object"&&!a)v=navigator.userAgent,l=v.indexOf("Windows")>=0,L=v.indexOf("Macintosh")>=0,w=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=v.indexOf("Linux")>=0,S=!0,b=N.getConfiguredDefaultLocale(N.localize(0,null))||A,y=b;else if(typeof h=="object"){l=h.platform==="win32",L=h.platform==="darwin",C=h.platform==="linux",c=C&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,t=i,u=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,b=A,y=A;const f=h.env.VSCODE_NLS_CONFIG;if(f)try{const _=JSON.parse(f),E=_.availableLanguages["*"];b=_.locale,y=E||A,g=_._translationsConfigFile}catch{}d=!0}else console.error("Unable to resolve platform.");let m=0;L?m=1:l?m=3:C&&(m=2),r.isWindows=l,r.isMacintosh=L,r.isLinux=C,r.isNative=d,r.isWeb=S,r.isWebWorker=S&&typeof r.globals.importScripts=="function",r.isIOS=w,r.userAgent=v,r.language=y,r.setTimeout0IsFaster=typeof r.globals.postMessage=="function"&&!r.globals.importScripts,r.setTimeout0=(()=>{if(r.setTimeout0IsFaster){const f=[];r.globals.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let M=0,D=f.length;M<D;M++){const P=f[M];if(P.id===E.data.vscodeScheduleAsyncWork){f.splice(M,1),P.callback();return}}});let _=0;return E=>{const M=++_;f.push({id:M,callback:E}),r.globals.postMessage({vscodeScheduleAsyncWork:M},"*")}}return f=>setTimeout(f)})(),r.OS=L||w?2:l?1:3;let p=!0,o=!1;function s(){if(!o){o=!0;const f=new Uint8Array(2);f[0]=1,f[1]=2,p=new Uint16Array(f.buffer)[0]===(2<<8)+1}return p}r.isLittleEndian=s,r.isChrome=!!(r.userAgent&&r.userAgent.indexOf("Chrome")>=0),r.isFirefox=!!(r.userAgent&&r.userAgent.indexOf("Firefox")>=0),r.isSafari=!!(!r.isChrome&&r.userAgent&&r.userAgent.indexOf("Safari")>=0),r.isEdge=!!(r.userAgent&&r.userAgent.indexOf("Edg/")>=0),r.isAndroid=!!(r.userAgent&&r.userAgent.indexOf("Android")>=0)}),X(Z[41],J([0,1,5]),function(I,r,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.platform=r.env=r.cwd=void 0;let e;if(typeof N.globals.vscode!="undefined"&&typeof N.globals.vscode.process!="undefined"){const A=N.globals.vscode.process;e={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process!="undefined"?e={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:e={get platform(){return N.isWindows?"win32":N.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};r.cwd=e.cwd,r.env=e.env,r.platform=e.platform}),X(Z[42],J([0,1,41]),function(I,r,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.sep=r.extname=r.basename=r.dirname=r.relative=r.resolve=r.normalize=r.posix=r.win32=void 0;const e=65,A=97,l=90,L=122,C=46,c=47,d=92,S=58,t=63;class w extends Error{constructor(a,m,p){let o;typeof m=="string"&&m.indexOf("not ")===0?(o="must not be",m=m.replace(/^not /,"")):o="must be";const s=a.indexOf(".")!==-1?"property":"argument";let f=`The "${a}" ${s} ${o} of type ${m}`;f+=`. Received type ${typeof p}`;super(f);this.code="ERR_INVALID_ARG_TYPE"}}function u(i,a){if(typeof i!="string")throw new w(a,"string",i)}function b(i){return i===c||i===d}function y(i){return i===c}function g(i){return i>=e&&i<=l||i>=A&&i<=L}function v(i,a,m,p){let o="",s=0,f=-1,_=0,E=0;for(let M=0;M<=i.length;++M){if(M<i.length)E=i.charCodeAt(M);else{if(p(E))break;E=c}if(p(E)){if(!(f===M-1||_===1))if(_===2){if(o.length<2||s!==2||o.charCodeAt(o.length-1)!==C||o.charCodeAt(o.length-2)!==C){if(o.length>2){const D=o.lastIndexOf(m);D===-1?(o="",s=0):(o=o.slice(0,D),s=o.length-1-o.lastIndexOf(m)),f=M,_=0;continue}else if(o.length!==0){o="",s=0,f=M,_=0;continue}}a&&(o+=o.length>0?`${m}..`:"..",s=2)}else o.length>0?o+=`${m}${i.slice(f+1,M)}`:o=i.slice(f+1,M),s=M-f-1;f=M,_=0}else E===C&&_!==-1?++_:_=-1}return o}function h(i,a){if(a===null||typeof a!="object")throw new w("pathObject","Object",a);const m=a.dir||a.root,p=a.base||`${a.name||""}${a.ext||""}`;return m?m===a.root?`${m}${p}`:`${m}${i}${p}`:p}r.win32={resolve(...i){let a="",m="",p=!1;for(let o=i.length-1;o>=-1;o--){let s;if(o>=0){if(s=i[o],u(s,"path"),s.length===0)continue}else a.length===0?s=N.cwd():(s=N.env[`=${a}`]||N.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==a.toLowerCase()&&s.charCodeAt(2)===d)&&(s=`${a}\\`));const f=s.length;let _=0,E="",M=!1;const D=s.charCodeAt(0);if(f===1)b(D)&&(_=1,M=!0);else if(b(D))if(M=!0,b(s.charCodeAt(1))){let P=2,B=P;for(;P<f&&!b(s.charCodeAt(P));)P++;if(P<f&&P!==B){const W=s.slice(B,P);for(B=P;P<f&&b(s.charCodeAt(P));)P++;if(P<f&&P!==B){for(B=P;P<f&&!b(s.charCodeAt(P));)P++;(P===f||P!==B)&&(E=`\\\\${W}\\${s.slice(B,P)}`,_=P)}}}else _=1;else g(D)&&s.charCodeAt(1)===S&&(E=s.slice(0,2),_=2,f>2&&b(s.charCodeAt(2))&&(M=!0,_=3));if(E.length>0)if(a.length>0){if(E.toLowerCase()!==a.toLowerCase())continue}else a=E;if(p){if(a.length>0)break}else if(m=`${s.slice(_)}\\${m}`,p=M,M&&a.length>0)break}return m=v(m,!p,"\\",b),p?`${a}\\${m}`:`${a}${m}`||"."},normalize(i){u(i,"path");const a=i.length;if(a===0)return".";let m=0,p,o=!1;const s=i.charCodeAt(0);if(a===1)return y(s)?"\\":i;if(b(s))if(o=!0,b(i.charCodeAt(1))){let _=2,E=_;for(;_<a&&!b(i.charCodeAt(_));)_++;if(_<a&&_!==E){const M=i.slice(E,_);for(E=_;_<a&&b(i.charCodeAt(_));)_++;if(_<a&&_!==E){for(E=_;_<a&&!b(i.charCodeAt(_));)_++;if(_===a)return`\\\\${M}\\${i.slice(E)}\\`;_!==E&&(p=`\\\\${M}\\${i.slice(E,_)}`,m=_)}}}else m=1;else g(s)&&i.charCodeAt(1)===S&&(p=i.slice(0,2),m=2,a>2&&b(i.charCodeAt(2))&&(o=!0,m=3));let f=m<a?v(i.slice(m),!o,"\\",b):"";return f.length===0&&!o&&(f="."),f.length>0&&b(i.charCodeAt(a-1))&&(f+="\\"),p===void 0?o?`\\${f}`:f:o?`${p}\\${f}`:`${p}${f}`},isAbsolute(i){u(i,"path");const a=i.length;if(a===0)return!1;const m=i.charCodeAt(0);return b(m)||a>2&&g(m)&&i.charCodeAt(1)===S&&b(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let a,m;for(let s=0;s<i.length;++s){const f=i[s];u(f,"path"),f.length>0&&(a===void 0?a=m=f:a+=`\\${f}`)}if(a===void 0)return".";let p=!0,o=0;if(typeof m=="string"&&b(m.charCodeAt(0))){++o;const s=m.length;s>1&&b(m.charCodeAt(1))&&(++o,s>2&&(b(m.charCodeAt(2))?++o:p=!1))}if(p){for(;o<a.length&&b(a.charCodeAt(o));)o++;o>=2&&(a=`\\${a.slice(o)}`)}return r.win32.normalize(a)},relative(i,a){if(u(i,"from"),u(a,"to"),i===a)return"";const m=r.win32.resolve(i),p=r.win32.resolve(a);if(m===p||(i=m.toLowerCase(),a=p.toLowerCase(),i===a))return"";let o=0;for(;o<i.length&&i.charCodeAt(o)===d;)o++;let s=i.length;for(;s-1>o&&i.charCodeAt(s-1)===d;)s--;const f=s-o;let _=0;for(;_<a.length&&a.charCodeAt(_)===d;)_++;let E=a.length;for(;E-1>_&&a.charCodeAt(E-1)===d;)E--;const M=E-_,D=f<M?f:M;let P=-1,B=0;for(;B<D;B++){const $=i.charCodeAt(o+B);if($!==a.charCodeAt(_+B))break;$===d&&(P=B)}if(B!==D){if(P===-1)return p}else{if(M>D){if(a.charCodeAt(_+B)===d)return p.slice(_+B+1);if(B===2)return p.slice(_+B)}f>D&&(i.charCodeAt(o+B)===d?P=B:B===2&&(P=3)),P===-1&&(P=0)}let W="";for(B=o+P+1;B<=s;++B)(B===s||i.charCodeAt(B)===d)&&(W+=W.length===0?"..":"\\..");return _+=P,W.length>0?`${W}${p.slice(_,E)}`:(p.charCodeAt(_)===d&&++_,p.slice(_,E))},toNamespacedPath(i){if(typeof i!="string")return i;if(i.length===0)return"";const a=r.win32.resolve(i);if(a.length<=2)return i;if(a.charCodeAt(0)===d){if(a.charCodeAt(1)===d){const m=a.charCodeAt(2);if(m!==t&&m!==C)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(g(a.charCodeAt(0))&&a.charCodeAt(1)===S&&a.charCodeAt(2)===d)return`\\\\?\\${a}`;return i},dirname(i){u(i,"path");const a=i.length;if(a===0)return".";let m=-1,p=0;const o=i.charCodeAt(0);if(a===1)return b(o)?i:".";if(b(o)){if(m=p=1,b(i.charCodeAt(1))){let _=2,E=_;for(;_<a&&!b(i.charCodeAt(_));)_++;if(_<a&&_!==E){for(E=_;_<a&&b(i.charCodeAt(_));)_++;if(_<a&&_!==E){for(E=_;_<a&&!b(i.charCodeAt(_));)_++;if(_===a)return i;_!==E&&(m=p=_+1)}}}}else g(o)&&i.charCodeAt(1)===S&&(m=a>2&&b(i.charCodeAt(2))?3:2,p=m);let s=-1,f=!0;for(let _=a-1;_>=p;--_)if(b(i.charCodeAt(_))){if(!f){s=_;break}}else f=!1;if(s===-1){if(m===-1)return".";s=m}return i.slice(0,s)},basename(i,a){a!==void 0&&u(a,"ext"),u(i,"path");let m=0,p=-1,o=!0,s;if(i.length>=2&&g(i.charCodeAt(0))&&i.charCodeAt(1)===S&&(m=2),a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let f=a.length-1,_=-1;for(s=i.length-1;s>=m;--s){const E=i.charCodeAt(s);if(b(E)){if(!o){m=s+1;break}}else _===-1&&(o=!1,_=s+1),f>=0&&(E===a.charCodeAt(f)?--f==-1&&(p=s):(f=-1,p=_))}return m===p?p=_:p===-1&&(p=i.length),i.slice(m,p)}for(s=i.length-1;s>=m;--s)if(b(i.charCodeAt(s))){if(!o){m=s+1;break}}else p===-1&&(o=!1,p=s+1);return p===-1?"":i.slice(m,p)},extname(i){u(i,"path");let a=0,m=-1,p=0,o=-1,s=!0,f=0;i.length>=2&&i.charCodeAt(1)===S&&g(i.charCodeAt(0))&&(a=p=2);for(let _=i.length-1;_>=a;--_){const E=i.charCodeAt(_);if(b(E)){if(!s){p=_+1;break}continue}o===-1&&(s=!1,o=_+1),E===C?m===-1?m=_:f!==1&&(f=1):m!==-1&&(f=-1)}return m===-1||o===-1||f===0||f===1&&m===o-1&&m===p+1?"":i.slice(m,o)},format:h.bind(null,"\\"),parse(i){u(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const m=i.length;let p=0,o=i.charCodeAt(0);if(m===1)return b(o)?(a.root=a.dir=i,a):(a.base=a.name=i,a);if(b(o)){if(p=1,b(i.charCodeAt(1))){let P=2,B=P;for(;P<m&&!b(i.charCodeAt(P));)P++;if(P<m&&P!==B){for(B=P;P<m&&b(i.charCodeAt(P));)P++;if(P<m&&P!==B){for(B=P;P<m&&!b(i.charCodeAt(P));)P++;P===m?p=P:P!==B&&(p=P+1)}}}}else if(g(o)&&i.charCodeAt(1)===S){if(m<=2)return a.root=a.dir=i,a;if(p=2,b(i.charCodeAt(2))){if(m===3)return a.root=a.dir=i,a;p=3}}p>0&&(a.root=i.slice(0,p));let s=-1,f=p,_=-1,E=!0,M=i.length-1,D=0;for(;M>=p;--M){if(o=i.charCodeAt(M),b(o)){if(!E){f=M+1;break}continue}_===-1&&(E=!1,_=M+1),o===C?s===-1?s=M:D!==1&&(D=1):s!==-1&&(D=-1)}return _!==-1&&(s===-1||D===0||D===1&&s===_-1&&s===f+1?a.base=a.name=i.slice(f,_):(a.name=i.slice(f,s),a.base=i.slice(f,_),a.ext=i.slice(s,_))),f>0&&f!==p?a.dir=i.slice(0,f-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},r.posix={resolve(...i){let a="",m=!1;for(let p=i.length-1;p>=-1&&!m;p--){const o=p>=0?i[p]:N.cwd();u(o,"path"),o.length!==0&&(a=`${o}/${a}`,m=o.charCodeAt(0)===c)}return a=v(a,!m,"/",y),m?`/${a}`:a.length>0?a:"."},normalize(i){if(u(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===c,m=i.charCodeAt(i.length-1)===c;return i=v(i,!a,"/",y),i.length===0?a?"/":m?"./":".":(m&&(i+="/"),a?`/${i}`:i)},isAbsolute(i){return u(i,"path"),i.length>0&&i.charCodeAt(0)===c},join(...i){if(i.length===0)return".";let a;for(let m=0;m<i.length;++m){const p=i[m];u(p,"path"),p.length>0&&(a===void 0?a=p:a+=`/${p}`)}return a===void 0?".":r.posix.normalize(a)},relative(i,a){if(u(i,"from"),u(a,"to"),i===a||(i=r.posix.resolve(i),a=r.posix.resolve(a),i===a))return"";const m=1,p=i.length,o=p-m,s=1,f=a.length-s,_=o<f?o:f;let E=-1,M=0;for(;M<_;M++){const P=i.charCodeAt(m+M);if(P!==a.charCodeAt(s+M))break;P===c&&(E=M)}if(M===_)if(f>_){if(a.charCodeAt(s+M)===c)return a.slice(s+M+1);if(M===0)return a.slice(s+M)}else o>_&&(i.charCodeAt(m+M)===c?E=M:M===0&&(E=0));let D="";for(M=m+E+1;M<=p;++M)(M===p||i.charCodeAt(M)===c)&&(D+=D.length===0?"..":"/..");return`${D}${a.slice(s+E)}`},toNamespacedPath(i){return i},dirname(i){if(u(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===c;let m=-1,p=!0;for(let o=i.length-1;o>=1;--o)if(i.charCodeAt(o)===c){if(!p){m=o;break}}else p=!1;return m===-1?a?"/":".":a&&m===1?"//":i.slice(0,m)},basename(i,a){a!==void 0&&u(a,"ext"),u(i,"path");let m=0,p=-1,o=!0,s;if(a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let f=a.length-1,_=-1;for(s=i.length-1;s>=0;--s){const E=i.charCodeAt(s);if(E===c){if(!o){m=s+1;break}}else _===-1&&(o=!1,_=s+1),f>=0&&(E===a.charCodeAt(f)?--f==-1&&(p=s):(f=-1,p=_))}return m===p?p=_:p===-1&&(p=i.length),i.slice(m,p)}for(s=i.length-1;s>=0;--s)if(i.charCodeAt(s)===c){if(!o){m=s+1;break}}else p===-1&&(o=!1,p=s+1);return p===-1?"":i.slice(m,p)},extname(i){u(i,"path");let a=-1,m=0,p=-1,o=!0,s=0;for(let f=i.length-1;f>=0;--f){const _=i.charCodeAt(f);if(_===c){if(!o){m=f+1;break}continue}p===-1&&(o=!1,p=f+1),_===C?a===-1?a=f:s!==1&&(s=1):a!==-1&&(s=-1)}return a===-1||p===-1||s===0||s===1&&a===p-1&&a===m+1?"":i.slice(a,p)},format:h.bind(null,"/"),parse(i){u(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const m=i.charCodeAt(0)===c;let p;m?(a.root="/",p=1):p=0;let o=-1,s=0,f=-1,_=!0,E=i.length-1,M=0;for(;E>=p;--E){const D=i.charCodeAt(E);if(D===c){if(!_){s=E+1;break}continue}f===-1&&(_=!1,f=E+1),D===C?o===-1?o=E:M!==1&&(M=1):o!==-1&&(M=-1)}if(f!==-1){const D=s===0&&m?1:s;o===-1||M===0||M===1&&o===f-1&&o===s+1?a.base=a.name=i.slice(D,f):(a.name=i.slice(D,o),a.base=i.slice(D,f),a.ext=i.slice(o,f))}return s>0?a.dir=i.slice(0,s-1):m&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},r.posix.win32=r.win32.win32=r.win32,r.posix.posix=r.win32.posix=r.posix,r.normalize=N.platform==="win32"?r.win32.normalize:r.posix.normalize,r.resolve=N.platform==="win32"?r.win32.resolve:r.posix.resolve,r.relative=N.platform==="win32"?r.win32.relative:r.posix.relative,r.dirname=N.platform==="win32"?r.win32.dirname:r.posix.dirname,r.basename=N.platform==="win32"?r.win32.basename:r.posix.basename,r.extname=N.platform==="win32"?r.win32.extname:r.posix.extname,r.sep=N.platform==="win32"?r.win32.sep:r.posix.sep}),X(Z[17],J([0,1,5]),function(I,r,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.StopWatch=void 0;const e=N.globals.performance&&typeof N.globals.performance.now=="function";class A{constructor(L){this._highResolution=e&&L,this._startTime=this._now(),this._stopTime=-1}static create(L=!0){return new A(L)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?N.globals.performance.now():Date.now()}}r.StopWatch=A}),X(Z[6],J([0,1,10,7,12,17]),function(I,r,N,e,A,l){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Relay=r.EventBufferer=r.DebounceEmitter=r.PauseableEmitter=r.EventDeliveryQueue=r.Emitter=r.Event=void 0;const L=!1,C=!1;var c;(function(p){p.None=()=>e.Disposable.None;function o(K){if(C){const{onListenerDidAdd:j}=K,G=w.create();let Q=0;K.onListenerDidAdd=()=>{++Q==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),G.print()),j==null||j()}}}function s(K){return(j,G=null,Q)=>{let x=!1,ee;return ee=K(te=>{if(!x)return ee?ee.dispose():x=!0,j.call(G,te)},null,Q),x&&ee.dispose(),ee}}p.once=s;function f(K,j,G){return B((Q,x=null,ee)=>K(te=>Q.call(x,j(te)),null,ee),G)}p.map=f;function _(K,j,G){return B((Q,x=null,ee)=>K(te=>{j(te),Q.call(x,te)},null,ee),G)}p.forEach=_;function E(K,j,G){return B((Q,x=null,ee)=>K(te=>j(te)&&Q.call(x,te),null,ee),G)}p.filter=E;function M(K){return K}p.signal=M;function D(...K){return(j,G=null,Q)=>(0,e.combinedDisposable)(...K.map(x=>x(ee=>j.call(G,ee),null,Q)))}p.any=D;function P(K,j,G,Q){let x=G;return f(K,ee=>(x=j(x,ee),x),Q)}p.reduce=P;function B(K,j){let G;const Q={onFirstListenerAdd(){G=K(x.fire,x)},onLastListenerRemove(){G==null||G.dispose()}};j||o(Q);const x=new b(Q);return j==null||j.add(x),x.event}function W(K,j,G=100,Q=!1,x,ee){let te,ae,ge,ue=0;const ve={leakWarningThreshold:x,onFirstListenerAdd(){te=K(Le=>{ue++,ae=j(ae,Le),Q&&!ge&&(Ce.fire(ae),ae=void 0),clearTimeout(ge),ge=setTimeout(()=>{const Se=ae;ae=void 0,ge=void 0,(!Q||ue>1)&&Ce.fire(Se),ue=0},G)})},onLastListenerRemove(){te.dispose()}};ee||o(ve);const Ce=new b(ve);return ee==null||ee.add(Ce),Ce.event}p.debounce=W;function $(K,j=(Q,x)=>Q===x,G){let Q=!0,x;return E(K,ee=>{const te=Q||!j(ee,x);return Q=!1,x=ee,te},G)}p.latch=$;function q(K,j,G){return[p.filter(K,j,G),p.filter(K,Q=>!j(Q),G)]}p.split=q;function k(K,j=!1,G=[]){let Q=G.slice(),x=K(ae=>{Q?Q.push(ae):te.fire(ae)});const ee=()=>{Q==null||Q.forEach(ae=>te.fire(ae)),Q=null},te=new b({onFirstListenerAdd(){x||(x=K(ae=>te.fire(ae)))},onFirstListenerDidAdd(){Q&&(j?setTimeout(ee):ee())},onLastListenerRemove(){x&&x.dispose(),x=null}});return te.event}p.buffer=k;class U{constructor(j){this.event=j,this.disposables=new e.DisposableStore}map(j){return new U(f(this.event,j,this.disposables))}forEach(j){return new U(_(this.event,j,this.disposables))}filter(j){return new U(E(this.event,j,this.disposables))}reduce(j,G){return new U(P(this.event,j,G,this.disposables))}latch(){return new U($(this.event,void 0,this.disposables))}debounce(j,G=100,Q=!1,x){return new U(W(this.event,j,G,Q,x,this.disposables))}on(j,G,Q){return this.event(j,G,Q)}once(j,G,Q){return s(this.event)(j,G,Q)}dispose(){this.disposables.dispose()}}function T(K){return new U(K)}p.chain=T;function O(K,j,G=Q=>Q){const Q=(...ae)=>te.fire(G(...ae)),x=()=>K.on(j,Q),ee=()=>K.removeListener(j,Q),te=new b({onFirstListenerAdd:x,onLastListenerRemove:ee});return te.event}p.fromNodeEventEmitter=O;function z(K,j,G=Q=>Q){const Q=(...ae)=>te.fire(G(...ae)),x=()=>K.addEventListener(j,Q),ee=()=>K.removeEventListener(j,Q),te=new b({onFirstListenerAdd:x,onLastListenerRemove:ee});return te.event}p.fromDOMEventEmitter=z;function n(K){return new Promise(j=>s(K)(j))}p.toPromise=n;function se(K,j){return j(void 0),K(G=>j(G))}p.runAndSubscribe=se;function me(K,j){let G=null;function Q(ee){G==null||G.dispose(),G=new e.DisposableStore,j(ee,G)}Q(void 0);const x=K(ee=>Q(ee));return(0,e.toDisposable)(()=>{x.dispose(),G==null||G.dispose()})}p.runAndSubscribeWithStore=me;class _e{constructor(j,G){this.obs=j,this._counter=0,this._hasChanged=!1;const Q={onFirstListenerAdd:()=>{j.addObserver(this)},onLastListenerRemove:()=>{j.removeObserver(this)}};G||o(Q),this.emitter=new b(Q),G&&G.add(this.emitter)}beginUpdate(j){this._counter++}handleChange(j,G){this._hasChanged=!0}endUpdate(j){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function ye(K,j){return new _e(K,j).emitter.event}p.fromObservable=ye})(c=r.Event||(r.Event={}));class d{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${d._idPool++}`}start(o){this._stopWatch=new l.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}d._idPool=0;let S=-1;class t{constructor(o,s=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=s,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o,s){let f=S;if(typeof this.customThreshold=="number"&&(f=this.customThreshold),f<=0||s<f)return;this._stacks||(this._stacks=new Map);const _=this._stacks.get(o.value)||0;if(this._stacks.set(o.value,_+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=f*.5;let E,M=0;for(const[D,P]of this._stacks)(!E||M<P)&&(E=D,M=P);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${M}):`),console.warn(E)}return()=>{const E=this._stacks.get(o.value)||0;this._stacks.set(o.value,E-1)}}}class w{constructor(o){this.value=o}static create(){var o;return new w((o=new Error().stack)!==null&&o!==void 0?o:"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class u{constructor(o,s,f){this.callback=o,this.callbackThis=s,this.stack=f,this.subscription=new e.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class b{constructor(o){var s,f;this._disposed=!1,this._options=o,this._leakageMon=S>0?new t(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((s=this._options)===null||s===void 0?void 0:s._profName)?new d(this._options._profName):void 0,this._deliveryQueue=(f=this._options)===null||f===void 0?void 0:f.deliveryQueue}dispose(){var o,s,f,_;if(!this._disposed){if(this._disposed=!0,this._listeners){if(L){const E=Array.from(this._listeners);queueMicrotask(()=>{var M;for(const D of E)D.subscription.isset()&&(D.subscription.unset(),(M=D.stack)===null||M===void 0||M.print())})}this._listeners.clear()}(o=this._deliveryQueue)===null||o===void 0||o.clear(this),(f=(s=this._options)===null||s===void 0?void 0:s.onLastListenerRemove)===null||f===void 0||f.call(s),(_=this._leakageMon)===null||_===void 0||_.dispose()}}get event(){return this._event||(this._event=(o,s,f)=>{var _,E,M;this._listeners||(this._listeners=new A.LinkedList);const D=this._listeners.isEmpty();D&&((_=this._options)===null||_===void 0?void 0:_.onFirstListenerAdd)&&this._options.onFirstListenerAdd(this);let P,B;this._leakageMon&&this._listeners.size>=30&&(B=w.create(),P=this._leakageMon.check(B,this._listeners.size+1)),L&&(B=B??w.create());const W=new u(o,s,B),$=this._listeners.push(W);D&&((E=this._options)===null||E===void 0?void 0:E.onFirstListenerDidAdd)&&this._options.onFirstListenerDidAdd(this),((M=this._options)===null||M===void 0?void 0:M.onListenerDidAdd)&&this._options.onListenerDidAdd(this,o,s);const q=W.subscription.set(()=>{P==null||P(),this._disposed||($(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return f instanceof e.DisposableStore?f.add(q):Array.isArray(f)&&f.push(q),q}),this._event}fire(o){var s,f;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new g);for(const _ of this._listeners)this._deliveryQueue.push(this,_,o);(s=this._perfMon)===null||s===void 0||s.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),(f=this._perfMon)===null||f===void 0||f.stop()}}}r.Emitter=b;class y{constructor(){this._queue=new A.LinkedList}get size(){return this._queue.size}push(o,s,f){this._queue.push(new v(o,s,f))}clear(o){const s=new A.LinkedList;for(const f of this._queue)f.emitter!==o&&s.push(f);this._queue=s}deliver(){for(;this._queue.size>0;){const o=this._queue.shift();try{o.listener.invoke(o.event)}catch(s){(0,N.onUnexpectedError)(s)}}}}r.EventDeliveryQueue=y;class g extends y{clear(o){this._queue.clear()}}class v{constructor(o,s,f){this.emitter=o,this.listener=s,this.event=f}}class h extends b{constructor(o){super(o);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=o==null?void 0:o.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}r.PauseableEmitter=h;class i extends h{constructor(o){var s;super(o);this._delay=(s=o.delay)!==null&&s!==void 0?s:100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}r.DebounceEmitter=i;class a{constructor(){this.buffers=[]}wrapEvent(o){return(s,f,_)=>o(E=>{const M=this.buffers[this.buffers.length-1];M?M.push(()=>s.call(f,E)):s.call(f,E)},void 0,_)}bufferEvents(o){const s=[];this.buffers.push(s);const f=o();return this.buffers.pop(),s.forEach(_=>_()),f}}r.EventBufferer=a;class m{constructor(){this.listening=!1,this.inputEvent=c.None,this.inputEventListener=e.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}r.Relay=m}),X(Z[43],J([0,1,6]),function(I,r,N){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.CancellationTokenSource=r.CancellationToken=void 0;const e=Object.freeze(function(C,c){const d=setTimeout(C.bind(c),0);return{dispose(){clearTimeout(d)}}});var A;(function(C){function c(d){return d===C.None||d===C.Cancelled||d instanceof l?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}C.isCancellationToken=c,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:N.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:e})})(A=r.CancellationToken||(r.CancellationToken={}));class l{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?e:(this._emitter||(this._emitter=new N.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class L{constructor(c){this._token=void 0,this._parentListener=void 0,this._parentListener=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new l),this._token}cancel(){this._token?this._token instanceof l&&this._token.cancel():this._token=A.Cancelled}dispose(c=!1){var d;c&&this.cancel(),(d=this._parentListener)===null||d===void 0||d.dispose(),this._token?this._token instanceof l&&this._token.dispose():this._token=A.None}}r.CancellationTokenSource=L}),X(Z[9],J([0,1,42,5]),function(I,r,N,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.uriToFsPath=r.URI=void 0;const A=/^\w[\w\d+.-]*$/,l=/^\//,L=/^\/\//;function C(s,f){if(!s.scheme&&f)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!A.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!l.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function c(s,f){return!s&&!f?"file":s}function d(s,f){switch(s){case"https":case"http":case"file":f?f[0]!==t&&(f=t+f):f=t;break}return f}const S="",t="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{constructor(f,_,E,M,D,P=!1){typeof f=="object"?(this.scheme=f.scheme||S,this.authority=f.authority||S,this.path=f.path||S,this.query=f.query||S,this.fragment=f.fragment||S):(this.scheme=c(f,P),this.authority=_||S,this.path=d(this.scheme,E||S),this.query=M||S,this.fragment=D||S,C(this,P))}static isUri(f){return f instanceof u?!0:f?typeof f.authority=="string"&&typeof f.fragment=="string"&&typeof f.path=="string"&&typeof f.query=="string"&&typeof f.scheme=="string"&&typeof f.fsPath=="string"&&typeof f.with=="function"&&typeof f.toString=="function":!1}get fsPath(){return i(this,!1)}with(f){if(!f)return this;let{scheme:_,authority:E,path:M,query:D,fragment:P}=f;return _===void 0?_=this.scheme:_===null&&(_=S),E===void 0?E=this.authority:E===null&&(E=S),M===void 0?M=this.path:M===null&&(M=S),D===void 0?D=this.query:D===null&&(D=S),P===void 0?P=this.fragment:P===null&&(P=S),_===this.scheme&&E===this.authority&&M===this.path&&D===this.query&&P===this.fragment?this:new y(_,E,M,D,P)}static parse(f,_=!1){const E=w.exec(f);return E?new y(E[2]||S,o(E[4]||S),o(E[5]||S),o(E[7]||S),o(E[9]||S),_):new y(S,S,S,S,S)}static file(f){let _=S;if(e.isWindows&&(f=f.replace(/\\/g,t)),f[0]===t&&f[1]===t){const E=f.indexOf(t,2);E===-1?(_=f.substring(2),f=t):(_=f.substring(2,E),f=f.substring(E)||t)}return new y("file",_,f,S,S)}static from(f){const _=new y(f.scheme,f.authority,f.path,f.query,f.fragment);return C(_,!0),_}static joinPath(f,..._){if(!f.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let E;return e.isWindows&&f.scheme==="file"?E=u.file(N.win32.join(i(f,!0),..._)).path:E=N.posix.join(f.path,..._),f.with({path:E})}toString(f=!1){return a(this,f)}toJSON(){return this}static revive(f){if(f){if(f instanceof u)return f;{const _=new y(f);return _._formatted=f.external,_._fsPath=f._sep===b?f.fsPath:null,_}}else return f}}r.URI=u;const b=e.isWindows?1:void 0;class y extends u{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(f=!1){return f?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const f={$mid:1};return this._fsPath&&(f.fsPath=this._fsPath,f._sep=b),this._formatted&&(f.external=this._formatted),this.path&&(f.path=this.path),this.scheme&&(f.scheme=this.scheme),this.authority&&(f.authority=this.authority),this.query&&(f.query=this.query),this.fragment&&(f.fragment=this.fragment),f}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(s,f){let _,E=-1;for(let M=0;M<s.length;M++){const D=s.charCodeAt(M);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||f&&D===47)E!==-1&&(_+=encodeURIComponent(s.substring(E,M)),E=-1),_!==void 0&&(_+=s.charAt(M));else{_===void 0&&(_=s.substr(0,M));const P=g[D];P!==void 0?(E!==-1&&(_+=encodeURIComponent(s.substring(E,M)),E=-1),_+=P):E===-1&&(E=M)}}return E!==-1&&(_+=encodeURIComponent(s.substring(E))),_!==void 0?_:s}function h(s){let f;for(let _=0;_<s.length;_++){const E=s.charCodeAt(_);E===35||E===63?(f===void 0&&(f=s.substr(0,_)),f+=g[E]):f!==void 0&&(f+=s[_])}return f!==void 0?f:s}function i(s,f){let _;return s.authority&&s.path.length>1&&s.scheme==="file"?_=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?f?_=s.path.substr(1):_=s.path[1].toLowerCase()+s.path.substr(2):_=s.path,e.isWindows&&(_=_.replace(/\//g,"\\")),_}r.uriToFsPath=i;function a(s,f){const _=f?h:v;let E="",{scheme:M,authority:D,path:P,query:B,fragment:W}=s;if(M&&(E+=M,E+=":"),(D||M==="file")&&(E+=t,E+=t),D){let $=D.indexOf("@");if($!==-1){const q=D.substr(0,$);D=D.substr($+1),$=q.indexOf(":"),$===-1?E+=_(q,!1):(E+=_(q.substr(0,$),!1),E+=":",E+=_(q.substr($+1),!1)),E+="@"}D=D.toLowerCase(),$=D.indexOf(":"),$===-1?E+=_(D,!1):(E+=_(D.substr(0,$),!1),E+=D.substr($))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const $=P.charCodeAt(1);$>=65&&$<=90&&(P=`/${String.fromCharCode($+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const $=P.charCodeAt(0);$>=65&&$<=90&&(P=`${String.fromCharCode($+32)}:${P.substr(2)}`)}E+=_(P,!0)}return B&&(E+="?",E+=_(B,!1)),W&&(E+="#",E+=f?W:v(W,!1)),E}function m(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+m(s.substr(3)):s}}const p=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(s){return s.match(p)?s.replace(p,f=>m(f)):s}}),X(Z[48],J([0,1,10,6,7,8,5,2]),function(I,r,N,e,A,l,L,C){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.create=r.SimpleWorkerServer=r.SimpleWorkerClient=r.logOnceWebWorkerWarning=void 0;const c="$initialize";let d=!1;function S(o){!L.isWeb||(d||(d=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(o.message))}r.logOnceWebWorkerWarning=S;class t{constructor(s,f,_,E){this.vsWorker=s,this.req=f,this.method=_,this.args=E,this.type=0}}class w{constructor(s,f,_,E){this.vsWorker=s,this.seq=f,this.res=_,this.err=E,this.type=1}}class u{constructor(s,f,_,E){this.vsWorker=s,this.req=f,this.eventName=_,this.arg=E,this.type=2}}class b{constructor(s,f,_){this.vsWorker=s,this.req=f,this.event=_,this.type=3}}class y{constructor(s,f){this.vsWorker=s,this.req=f,this.type=4}}class g{constructor(s){this._workerId=-1,this._handler=s,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(s){this._workerId=s}sendMessage(s,f){const _=String(++this._lastSentReq);return new Promise((E,M)=>{this._pendingReplies[_]={resolve:E,reject:M},this._send(new t(this._workerId,_,s,f))})}listen(s,f){let _=null;const E=new e.Emitter({onFirstListenerAdd:()=>{_=String(++this._lastSentReq),this._pendingEmitters.set(_,E),this._send(new u(this._workerId,_,s,f))},onLastListenerRemove:()=>{this._pendingEmitters.delete(_),this._send(new y(this._workerId,_)),_=null}});return E.event}handleMessage(s){!s||!s.vsWorker||this._workerId!==-1&&s.vsWorker!==this._workerId||this._handleMessage(s)}_handleMessage(s){switch(s.type){case 1:return this._handleReplyMessage(s);case 0:return this._handleRequestMessage(s);case 2:return this._handleSubscribeEventMessage(s);case 3:return this._handleEventMessage(s);case 4:return this._handleUnsubscribeEventMessage(s)}}_handleReplyMessage(s){if(!this._pendingReplies[s.seq]){console.warn("Got reply to unknown seq");return}const f=this._pendingReplies[s.seq];if(delete this._pendingReplies[s.seq],s.err){let _=s.err;s.err.$isError&&(_=new Error,_.name=s.err.name,_.message=s.err.message,_.stack=s.err.stack),f.reject(_);return}f.resolve(s.res)}_handleRequestMessage(s){const f=s.req;this._handler.handleMessage(s.method,s.args).then(E=>{this._send(new w(this._workerId,f,E,void 0))},E=>{E.detail instanceof Error&&(E.detail=(0,N.transformErrorForSerialization)(E.detail)),this._send(new w(this._workerId,f,void 0,(0,N.transformErrorForSerialization)(E)))})}_handleSubscribeEventMessage(s){const f=s.req,_=this._handler.handleEvent(s.eventName,s.arg)(E=>{this._send(new b(this._workerId,f,E))});this._pendingEvents.set(f,_)}_handleEventMessage(s){if(!this._pendingEmitters.has(s.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(s.req).fire(s.event)}_handleUnsubscribeEventMessage(s){if(!this._pendingEvents.has(s.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(s.req).dispose(),this._pendingEvents.delete(s.req)}_send(s){const f=[];if(s.type===0)for(let _=0;_<s.args.length;_++)s.args[_]instanceof ArrayBuffer&&f.push(s.args[_]);else s.type===1&&s.res instanceof ArrayBuffer&&f.push(s.res);this._handler.sendMessage(s,f)}}class v extends A.Disposable{constructor(s,f,_){super();let E=null;this._worker=this._register(s.create("vs/base/common/worker/simpleWorker",W=>{this._protocol.handleMessage(W)},W=>{E==null||E(W)})),this._protocol=new g({sendMessage:(W,$)=>{this._worker.postMessage(W,$)},handleMessage:(W,$)=>{if(typeof _[W]!="function")return Promise.reject(new Error("Missing method "+W+" on main thread host."));try{return Promise.resolve(_[W].apply(_,$))}catch(q){return Promise.reject(q)}},handleEvent:(W,$)=>{if(i(W)){const q=_[W].call(_,$);if(typeof q!="function")throw new Error(`Missing dynamic event ${W} on main thread host.`);return q}if(h(W)){const q=_[W];if(typeof q!="function")throw new Error(`Missing event ${W} on main thread host.`);return q}throw new Error(`Malformed event name ${W}`)}}),this._protocol.setWorkerId(this._worker.getId());let M=null;typeof L.globals.require!="undefined"&&typeof L.globals.require.getConfig=="function"?M=L.globals.require.getConfig():typeof L.globals.requirejs!="undefined"&&(M=L.globals.requirejs.s.contexts._.config);const D=(0,l.getAllMethodNames)(_);this._onModuleLoaded=this._protocol.sendMessage(c,[this._worker.getId(),JSON.parse(JSON.stringify(M)),f,D]);const P=(W,$)=>this._request(W,$),B=(W,$)=>this._protocol.listen(W,$);this._lazyProxy=new Promise((W,$)=>{E=$,this._onModuleLoaded.then(q=>{W(a(q,P,B))},q=>{$(q),this._onError("Worker failed to load "+f,q)})})}getProxyObject(){return this._lazyProxy}_request(s,f){return new Promise((_,E)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(s,f).then(_,E)},E)})}_onError(s,f){console.error(s),console.info(f)}}r.SimpleWorkerClient=v;function h(o){return o[0]==="o"&&o[1]==="n"&&C.isUpperAsciiLetter(o.charCodeAt(2))}function i(o){return/^onDynamic/.test(o)&&C.isUpperAsciiLetter(o.charCodeAt(9))}function a(o,s,f){const _=D=>function(){const P=Array.prototype.slice.call(arguments,0);return s(D,P)},E=D=>function(P){return f(D,P)},M={};for(const D of o){if(i(D)){M[D]=E(D);continue}if(h(D)){M[D]=f(D,void 0);continue}M[D]=_(D)}return M}class m{constructor(s,f){this._requestHandlerFactory=f,this._requestHandler=null,this._protocol=new g({sendMessage:(_,E)=>{s(_,E)},handleMessage:(_,E)=>this._handleMessage(_,E),handleEvent:(_,E)=>this._handleEvent(_,E)})}onmessage(s){this._protocol.handleMessage(s)}_handleMessage(s,f){if(s===c)return this.initialize(f[0],f[1],f[2],f[3]);if(!this._requestHandler||typeof this._requestHandler[s]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+s));try{return Promise.resolve(this._requestHandler[s].apply(this._requestHandler,f))}catch(_){return Promise.reject(_)}}_handleEvent(s,f){if(!this._requestHandler)throw new Error("Missing requestHandler");if(i(s)){const _=this._requestHandler[s].call(this._requestHandler,f);if(typeof _!="function")throw new Error(`Missing dynamic event ${s} on request handler.`);return _}if(h(s)){const _=this._requestHandler[s];if(typeof _!="function")throw new Error(`Missing event ${s} on request handler.`);return _}throw new Error(`Malformed event name ${s}`)}initialize(s,f,_,E){this._protocol.setWorkerId(s);const P=a(E,(B,W)=>this._protocol.sendMessage(B,W),(B,W)=>this._protocol.listen(B,W));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(P),Promise.resolve((0,l.getAllMethodNames)(this._requestHandler))):(f&&(typeof f.baseUrl!="undefined"&&delete f.baseUrl,typeof f.paths!="undefined"&&typeof f.paths.vs!="undefined"&&delete f.paths.vs,typeof f.trustedTypesPolicy!==void 0&&delete f.trustedTypesPolicy,f.catchError=!0,L.globals.require.config(f)),new Promise((B,W)=>{(L.globals.require||I)([_],q=>{if(this._requestHandler=q.create(P),!this._requestHandler){W(new Error("No RequestHandler!"));return}B((0,l.getAllMethodNames)(this._requestHandler))},W)}))}}r.SimpleWorkerServer=m;function p(o){return new m(o,null)}r.create=p}),X(Z[44],J([0,1,6,7]),function(I,r,N,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.TokenizationRegistry=void 0;class A{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new N.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(C){this._onDidChange.fire({changedLanguages:C,changedColorMap:!1})}register(C,c){return this._map.set(C,c),this.fire([C]),(0,e.toDisposable)(()=>{this._map.get(C)===c&&(this._map.delete(C),this.fire([C]))})}registerFactory(C,c){var d;(d=this._factories.get(C))===null||d===void 0||d.dispose();const S=new l(this,C,c);return this._factories.set(C,S),(0,e.toDisposable)(()=>{const t=this._factories.get(C);!t||t!==S||(this._factories.delete(C),t.dispose())})}getOrCreate(C){return le(this,void 0,void 0,function*(){const c=this.get(C);if(c)return c;const d=this._factories.get(C);return!d||d.isResolved?null:(yield d.resolve(),this.get(C))})}get(C){return this._map.get(C)||null}isResolved(C){if(this.get(C))return!0;const d=this._factories.get(C);return!!(!d||d.isResolved)}setColorMap(C){this._colorMap=C,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}r.TokenizationRegistry=A;class l extends e.Disposable{constructor(C,c,d){super();this._registry=C,this._languageId=c,this._factory=d,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}resolve(){return le(this,void 0,void 0,function*(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise})}_create(){return le(this,void 0,void 0,function*(){const C=yield Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,C&&!this._isDisposed&&this._register(this._registry.register(this._languageId,C))})}}}),X(Z[45],J([0,1,22,9,4,44]),function(I,r,N,e,A,l){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.TokenizationRegistry=r.InlayHintKind=r.Command=r.FoldingRangeKind=r.SymbolKinds=r.isLocationLink=r.DocumentHighlightKind=r.SignatureHelpTriggerKind=r.InlineCompletionTriggerKind=r.CompletionItemKinds=r.EncodedTokenizationResult=r.TokenizationResult=r.Token=void 0;class L{constructor(i,a,m){this._tokenBrand=void 0,this.offset=i,this.type=a,this.language=m}toString(){return"("+this.offset+", "+this.type+")"}}r.Token=L;class C{constructor(i,a){this._tokenizationResultBrand=void 0,this.tokens=i,this.endState=a}}r.TokenizationResult=C;class c{constructor(i,a){this._encodedTokenizationResultBrand=void 0,this.tokens=i,this.endState=a}}r.EncodedTokenizationResult=c;var d;(function(h){const i=new Map;i.set(0,N.Codicon.symbolMethod),i.set(1,N.Codicon.symbolFunction),i.set(2,N.Codicon.symbolConstructor),i.set(3,N.Codicon.symbolField),i.set(4,N.Codicon.symbolVariable),i.set(5,N.Codicon.symbolClass),i.set(6,N.Codicon.symbolStruct),i.set(7,N.Codicon.symbolInterface),i.set(8,N.Codicon.symbolModule),i.set(9,N.Codicon.symbolProperty),i.set(10,N.Codicon.symbolEvent),i.set(11,N.Codicon.symbolOperator),i.set(12,N.Codicon.symbolUnit),i.set(13,N.Codicon.symbolValue),i.set(15,N.Codicon.symbolEnum),i.set(14,N.Codicon.symbolConstant),i.set(15,N.Codicon.symbolEnum),i.set(16,N.Codicon.symbolEnumMember),i.set(17,N.Codicon.symbolKeyword),i.set(27,N.Codicon.symbolSnippet),i.set(18,N.Codicon.symbolText),i.set(19,N.Codicon.symbolColor),i.set(20,N.Codicon.symbolFile),i.set(21,N.Codicon.symbolReference),i.set(22,N.Codicon.symbolCustomColor),i.set(23,N.Codicon.symbolFolder),i.set(24,N.Codicon.symbolTypeParameter),i.set(25,N.Codicon.account),i.set(26,N.Codicon.issues);function a(o){let s=i.get(o);return s||(console.info("No codicon found for CompletionItemKind "+o),s=N.Codicon.symbolProperty),s}h.toIcon=a;const m=new Map;m.set("method",0),m.set("function",1),m.set("constructor",2),m.set("field",3),m.set("variable",4),m.set("class",5),m.set("struct",6),m.set("interface",7),m.set("module",8),m.set("property",9),m.set("event",10),m.set("operator",11),m.set("unit",12),m.set("value",13),m.set("constant",14),m.set("enum",15),m.set("enum-member",16),m.set("enumMember",16),m.set("keyword",17),m.set("snippet",27),m.set("text",18),m.set("color",19),m.set("file",20),m.set("reference",21),m.set("customcolor",22),m.set("folder",23),m.set("type-parameter",24),m.set("typeParameter",24),m.set("account",25),m.set("issue",26);function p(o,s){let f=m.get(o);return typeof f=="undefined"&&!s&&(f=9),f}h.fromString=p})(d=r.CompletionItemKinds||(r.CompletionItemKinds={}));var S;(function(h){h[h.Automatic=0]="Automatic",h[h.Explicit=1]="Explicit"})(S=r.InlineCompletionTriggerKind||(r.InlineCompletionTriggerKind={}));var t;(function(h){h[h.Invoke=1]="Invoke",h[h.TriggerCharacter=2]="TriggerCharacter",h[h.ContentChange=3]="ContentChange"})(t=r.SignatureHelpTriggerKind||(r.SignatureHelpTriggerKind={}));var w;(function(h){h[h.Text=0]="Text",h[h.Read=1]="Read",h[h.Write=2]="Write"})(w=r.DocumentHighlightKind||(r.DocumentHighlightKind={}));function u(h){return h&&e.URI.isUri(h.uri)&&A.Range.isIRange(h.range)&&(A.Range.isIRange(h.originSelectionRange)||A.Range.isIRange(h.targetSelectionRange))}r.isLocationLink=u;var b;(function(h){const i=new Map;i.set(0,N.Codicon.symbolFile),i.set(1,N.Codicon.symbolModule),i.set(2,N.Codicon.symbolNamespace),i.set(3,N.Codicon.symbolPackage),i.set(4,N.Codicon.symbolClass),i.set(5,N.Codicon.symbolMethod),i.set(6,N.Codicon.symbolProperty),i.set(7,N.Codicon.symbolField),i.set(8,N.Codicon.symbolConstructor),i.set(9,N.Codicon.symbolEnum),i.set(10,N.Codicon.symbolInterface),i.set(11,N.Codicon.symbolFunction),i.set(12,N.Codicon.symbolVariable),i.set(13,N.Codicon.symbolConstant),i.set(14,N.Codicon.symbolString),i.set(15,N.Codicon.symbolNumber),i.set(16,N.Codicon.symbolBoolean),i.set(17,N.Codicon.symbolArray),i.set(18,N.Codicon.symbolObject),i.set(19,N.Codicon.symbolKey),i.set(20,N.Codicon.symbolNull),i.set(21,N.Codicon.symbolEnumMember),i.set(22,N.Codicon.symbolStruct),i.set(23,N.Codicon.symbolEvent),i.set(24,N.Codicon.symbolOperator),i.set(25,N.Codicon.symbolTypeParameter);function a(m){let p=i.get(m);return p||(console.info("No codicon found for SymbolKind "+m),p=N.Codicon.symbolProperty),p}h.toIcon=a})(b=r.SymbolKinds||(r.SymbolKinds={}));class y{constructor(i){this.value=i}}r.FoldingRangeKind=y,y.Comment=new y("comment"),y.Imports=new y("imports"),y.Region=new y("region");var g;(function(h){function i(a){return!a||typeof a!="object"?!1:typeof a.id=="string"&&typeof a.title=="string"}h.is=i})(g=r.Command||(r.Command={}));var v;(function(h){h[h.Type=1]="Type",h[h.Parameter=2]="Parameter"})(v=r.InlayHintKind||(r.InlayHintKind={})),r.TokenizationRegistry=new l.TokenizationRegistry}),X(Z[46],J([0,1,43,6,25,9,3,4,29,45,39]),function(I,r,N,e,A,l,L,C,c,d,S){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.createMonacoBaseAPI=r.KeyMod=void 0;class t{static chord(b,y){return(0,A.KeyChord)(b,y)}}r.KeyMod=t,t.CtrlCmd=2048,t.Shift=1024,t.Alt=512,t.WinCtrl=256;function w(){return{editor:void 0,languages:void 0,CancellationTokenSource:N.CancellationTokenSource,Emitter:e.Emitter,KeyCode:S.KeyCode,KeyMod:t,Position:L.Position,Range:C.Range,Selection:c.Selection,SelectionDirection:S.SelectionDirection,MarkerSeverity:S.MarkerSeverity,MarkerTag:S.MarkerTag,Uri:l.URI,Token:d.Token}}r.createMonacoBaseAPI=w}),X(Z[49],J([0,1,13,5,9,3,4,31,36,16,32,33,46,17,38,8]),function(I,r,N,e,A,l,L,C,c,d,S,t,w,u,b,y){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.create=r.EditorSimpleWorker=r.MirrorModel=void 0;class g extends c.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(a){return this._lines[a-1]}getWordAtPosition(a,m){const p=(0,d.getWordAtText)(a.column,(0,d.ensureValidWordDefinition)(m),this._lines[a.lineNumber-1],0);return p?new L.Range(a.lineNumber,p.startColumn,a.lineNumber,p.endColumn):null}words(a){const m=this._lines,p=this._wordenize.bind(this);let o=0,s="",f=0,_=[];return{*[Symbol.iterator](){for(;;)if(f<_.length){const E=s.substring(_[f].start,_[f].end);f+=1,yield E}else if(o<m.length)s=m[o],_=p(s,a),f=0,o+=1;else break}}}getLineWords(a,m){const p=this._lines[a-1],o=this._wordenize(p,m),s=[];for(const f of o)s.push({word:p.substring(f.start,f.end),startColumn:f.start+1,endColumn:f.end+1});return s}_wordenize(a,m){const p=[];let o;for(m.lastIndex=0;(o=m.exec(a))&&o[0].length!==0;)p.push({start:o.index,end:o.index+o[0].length});return p}getValueInRange(a){if(a=this._validateRange(a),a.startLineNumber===a.endLineNumber)return this._lines[a.startLineNumber-1].substring(a.startColumn-1,a.endColumn-1);const m=this._eol,p=a.startLineNumber-1,o=a.endLineNumber-1,s=[];s.push(this._lines[p].substring(a.startColumn-1));for(let f=p+1;f<o;f++)s.push(this._lines[f]);return s.push(this._lines[o].substring(0,a.endColumn-1)),s.join(m)}offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getPrefixSum(a.lineNumber-2)+(a.column-1)}positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const m=this._lineStarts.getIndexOf(a),p=this._lines[m.index].length;return{lineNumber:1+m.index,column:1+Math.min(m.remainder,p)}}_validateRange(a){const m=this._validatePosition({lineNumber:a.startLineNumber,column:a.startColumn}),p=this._validatePosition({lineNumber:a.endLineNumber,column:a.endColumn});return m.lineNumber!==a.startLineNumber||m.column!==a.startColumn||p.lineNumber!==a.endLineNumber||p.column!==a.endColumn?{startLineNumber:m.lineNumber,startColumn:m.column,endLineNumber:p.lineNumber,endColumn:p.column}:a}_validatePosition(a){if(!l.Position.isIPosition(a))throw new Error("bad position");let{lineNumber:m,column:p}=a,o=!1;if(m<1)m=1,p=1,o=!0;else if(m>this._lines.length)m=this._lines.length,p=this._lines[m-1].length+1,o=!0;else{const s=this._lines[m-1].length+1;p<1?(p=1,o=!0):p>s&&(p=s,o=!0)}return o?{lineNumber:m,column:p}:a}}r.MirrorModel=g;class v{constructor(a,m){this._host=a,this._models=Object.create(null),this._foreignModuleFactory=m,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(a){return this._models[a]}_getModels(){const a=[];return Object.keys(this._models).forEach(m=>a.push(this._models[m])),a}acceptNewModel(a){this._models[a.url]=new g(A.URI.parse(a.url),a.lines,a.EOL,a.versionId)}acceptModelChanged(a,m){if(!this._models[a])return;this._models[a].onEvents(m)}acceptRemovedModel(a){!this._models[a]||delete this._models[a]}computeUnicodeHighlights(a,m,p){return le(this,void 0,void 0,function*(){const o=this._getModel(a);return o?b.UnicodeTextModelHighlighter.computeUnicodeHighlights(o,m,p):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}})}computeDiff(a,m,p,o){return le(this,void 0,void 0,function*(){const s=this._getModel(a),f=this._getModel(m);return!s||!f?null:v.computeDiff(s,f,p,o)})}static computeDiff(a,m,p,o){const s=a.getLinesContent(),f=m.getLinesContent(),E=new C.DiffComputer(s,f,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:p,shouldMakePrettyDiff:!0,maxComputationTime:o}).computeDiff(),M=E.changes.length>0?!1:this._modelsAreIdentical(a,m);return{quitEarly:E.quitEarly,identical:M,changes:E.changes}}static _modelsAreIdentical(a,m){const p=a.getLineCount(),o=m.getLineCount();if(p!==o)return!1;for(let s=1;s<=p;s++){const f=a.getLineContent(s),_=m.getLineContent(s);if(f!==_)return!1}return!0}computeMoreMinimalEdits(a,m){return le(this,void 0,void 0,function*(){const p=this._getModel(a);if(!p)return m;const o=[];let s;m=m.slice(0).sort((f,_)=>{if(f.range&&_.range)return L.Range.compareRangesUsingStarts(f.range,_.range);const E=f.range?0:1,M=_.range?0:1;return E-M});for(let{range:f,text:_,eol:E}of m){if(typeof E=="number"&&(s=E),L.Range.isEmpty(f)&&!_)continue;const M=p.getValueInRange(f);if(_=_.replace(/\r\n|\n|\r/g,p.eol),M===_)continue;if(Math.max(_.length,M.length)>v._diffLimit){o.push({range:f,text:_});continue}const D=(0,N.stringDiff)(M,_,!1),P=p.offsetAt(L.Range.lift(f).getStartPosition());for(const B of D){const W=p.positionAt(P+B.originalStart),$=p.positionAt(P+B.originalStart+B.originalLength),q={text:_.substr(B.modifiedStart,B.modifiedLength),range:{startLineNumber:W.lineNumber,startColumn:W.column,endLineNumber:$.lineNumber,endColumn:$.column}};p.getValueInRange(q.range)!==q.text&&o.push(q)}}return typeof s=="number"&&o.push({eol:s,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),o})}computeLinks(a){return le(this,void 0,void 0,function*(){const m=this._getModel(a);return m?(0,S.computeLinks)(m):null})}textualSuggest(a,m,p,o){return le(this,void 0,void 0,function*(){const s=new u.StopWatch(!0),f=new RegExp(p,o),_=new Set;e:for(const E of a){const M=this._getModel(E);if(!!M){for(const D of M.words(f))if(!(D===m||!isNaN(Number(D)))&&(_.add(D),_.size>v._suggestionsLimit))break e}}return{words:Array.from(_),duration:s.elapsed()}})}computeWordRanges(a,m,p,o){return le(this,void 0,void 0,function*(){const s=this._getModel(a);if(!s)return Object.create(null);const f=new RegExp(p,o),_=Object.create(null);for(let E=m.startLineNumber;E<m.endLineNumber;E++){const M=s.getLineWords(E,f);for(const D of M){if(!isNaN(Number(D.word)))continue;let P=_[D.word];P||(P=[],_[D.word]=P),P.push({startLineNumber:E,startColumn:D.startColumn,endLineNumber:E,endColumn:D.endColumn})}}return _})}navigateValueSet(a,m,p,o,s){return le(this,void 0,void 0,function*(){const f=this._getModel(a);if(!f)return null;const _=new RegExp(o,s);m.startColumn===m.endColumn&&(m={startLineNumber:m.startLineNumber,startColumn:m.startColumn,endLineNumber:m.endLineNumber,endColumn:m.endColumn+1});const E=f.getValueInRange(m),M=f.getWordAtPosition({lineNumber:m.startLineNumber,column:m.startColumn},_);if(!M)return null;const D=f.getValueInRange(M);return t.BasicInplaceReplace.INSTANCE.navigateValueSet(m,E,M,D,p)})}loadForeignModule(a,m,p){const o=(_,E)=>this._host.fhr(_,E),f={host:(0,y.createProxyObject)(p,o),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(f,m),Promise.resolve((0,y.getAllMethodNames)(this._foreignModule))):new Promise((_,E)=>{I([a],M=>{this._foreignModule=M.create(f,m),_((0,y.getAllMethodNames)(this._foreignModule))},E)})}fmr(a,m){if(!this._foreignModule||typeof this._foreignModule[a]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+a));try{return Promise.resolve(this._foreignModule[a].apply(this._foreignModule,m))}catch(p){return Promise.reject(p)}}}r.EditorSimpleWorker=v,v._diffLimit=1e5,v._suggestionsLimit=1e4;function h(i){return new v(i,null)}r.create=h,typeof importScripts=="function"&&(e.globals.monaco=(0,w.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map